indexing

	description: "Describes the Xplain extend statement."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2002, Berend de Boer"
	date:       "$Date: 2008/07/26 $"
	revision:   "$Revision: #3 $"

class

	XPLAIN_EXTEND_STATEMENT


inherit

	XPLAIN_STATEMENT
		redefine
			cleanup
		end


create

	make


feature -- Initialization

	make (a_extension: XPLAIN_EXTENSION) is
		require
			have_extension: a_extension /= Void
		do
			extension := a_extension
		end


feature -- Generate output

	write (a_generator: ABSTRACT_GENERATOR) is
			-- Write output according to this generator.
		do
			a_generator.write_extend (extension)
		end


feature -- Cleanup

	cleanup is
			-- After stored procedure has been written, the extend is
			-- removed from the type.
		do
			extension.type.remove_extension (extension)
		end


feature --  Warnings

	uses_parameter (a_parameter: XPLAIN_ATTRIBUTE_NAME): BOOLEAN is
			-- Is parameter `a_parameter' used by this statement?
		do
			Result := extension.expression.uses_parameter (a_parameter)
		end


feature -- Access

	extension: XPLAIN_EXTENSION


invariant

	have_extension: extension /= Void

end
