indexing

  description:

	"Scanner for Xplain ddl parsers%
	%Rewritten from a Delphi 4.0 scanner.%
	%Traces of this go back go versions created in 1994."

  known_bugs:
  "1. Seems /* .. */ style comments not parsed correctly?? Maybe remove %
  %   such style comments."

  author:     "Berend de Boer <berend@pobox.com>"
  copyright:  "Copyright (c) 1999-2001, Berend de Boer, see forum.txt"
  date:       "$Date: 2008/07/26 $"
  revision:   "$Revision: #11 $"

class XPLAIN_SCANNER

inherit

	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			make_with_file as make_compressed_scanner_skeleton_with_file
		redefine
			wrap
		end

	XPLAIN_TOKENS
		export
			{NONE} all
		end

	UT_CHARACTER_CODES
		export {NONE} all
		end

	KL_SHARED_EXCEPTIONS
		export
			{NONE} all
		end

	KL_SHARED_ARGUMENTS
		export
			{NONE} all
		end

	ST_FORMATTING_ROUTINES
		export
			{NONE} all
		end


create

	make_with_stdin,
	make_with_file,
	execute


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= cond_literal_sql)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 72 then
if yy_act <= 36 then
if yy_act <= 18 then
if yy_act <= 9 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
yy_set_line_column
--|#line 75 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 75")
end
-- Ignore white space
else
yy_set_line_column
--|#line 80 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 80")
end
-- ignore comments
end
else
yy_set_line_column
--|#line 81 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 81")
end
-- ignore comments
end
else
if yy_act = 4 then
	yy_column := yy_column + 1
--|#line 86 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 86")
end
set_start_condition (comment_sql)
else
	yy_column := yy_column + 2
--|#line 87 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 87")
end
set_start_condition (comment_sql)
end
end
else
if yy_act <= 7 then
if yy_act = 6 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 88 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 88")
end

						if pending_init = Void then
							write_pending_statement
						end
						if immediate_output_mode then
							sqlgenerator.write_one_line_comment(text)
						end
						
else
	yy_column := yy_column + 1
--|#line 96 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 96")
end
 -- ignore cr's
						
end
else
if yy_act = 8 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 98 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 98")
end

						set_start_condition (INITIAL)
						
else
	yy_column := yy_column + 1
--|#line 105 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 105")
end

								 write_pending_statement
								 set_start_condition (cond_literal_sql)
								 my_sql := ""
								 
end
end
end
else
if yy_act <= 14 then
if yy_act <= 12 then
if yy_act <= 11 then
if yy_act = 10 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 110 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 110")
end
 -- Eat anything that's not a '}'
								 my_sql.append_string (text)
								 
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 113 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 113")
end

								 my_sql.append_character ('%N')
								 
end
else
	yy_column := yy_column + 1
--|#line 116 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 116")
end
 -- ignore cr's
								 
end
else
if yy_act = 13 then
	yy_column := yy_column + 1
--|#line 118 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 118")
end
 set_start_condition (INITIAL); last_token := LITERAL_SQL; last_string_value := my_sql; 
else
	yy_column := yy_column + 2
--|#line 123 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 123")
end
conditional_parse_domain (XPLAIN_A)
end
end
else
if yy_act <= 16 then
if yy_act = 15 then
	yy_column := yy_column + 2
--|#line 124 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 124")
end
conditional_parse_domain (XPLAIN_B)
else
	yy_column := yy_column + 2
--|#line 125 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 125")
end
conditional_parse_domain (XPLAIN_C)
end
else
if yy_act = 17 then
	yy_column := yy_column + 2
--|#line 126 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 126")
end
conditional_parse_domain (XPLAIN_D)
else
	yy_column := yy_column + 2
--|#line 127 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 127")
end
conditional_parse_domain (XPLAIN_I)
end
end
end
end
else
if yy_act <= 27 then
if yy_act <= 23 then
if yy_act <= 21 then
if yy_act <= 20 then
if yy_act = 19 then
	yy_column := yy_column + 2
--|#line 128 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 128")
end
conditional_parse_domain (XPLAIN_M)
else
	yy_column := yy_column + 2
--|#line 129 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 129")
end
conditional_parse_domain (XPLAIN_P)
end
else
	yy_column := yy_column + 2
--|#line 130 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 130")
end
conditional_parse_domain (XPLAIN_R)
end
else
if yy_act = 22 then
	yy_column := yy_column + 2
--|#line 131 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 131")
end
conditional_parse_domain (XPLAIN_T)
else
	yy_column := yy_column + 1
--|#line 136 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 136")
end
last_token := Minus_code
end
end
else
if yy_act <= 25 then
if yy_act = 24 then
	yy_column := yy_column + 1
--|#line 137 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 137")
end
last_token := Plus_code
else
	yy_column := yy_column + 1
--|#line 138 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 138")
end
last_token := Star_code
end
else
if yy_act = 26 then
	yy_column := yy_column + 1
--|#line 139 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 139")
end
last_token := Slash_code
else
	yy_column := yy_column + 1
--|#line 140 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 140")
end
last_token := Equal_code; expect_domain := False
end
end
end
else
if yy_act <= 32 then
if yy_act <= 30 then
if yy_act <= 29 then
if yy_act = 28 then
	yy_column := yy_column + 1
--|#line 141 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 141")
end
last_token := Greater_than_code
else
	yy_column := yy_column + 1
--|#line 142 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 142")
end
last_token := Less_than_code
end
else
	yy_column := yy_column + 2
--|#line 143 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 143")
end
last_token := XPLAIN_NE
end
else
if yy_act = 31 then
	yy_column := yy_column + 1
--|#line 144 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 144")
end
last_token := Dot_code; expect_domain := False
else
	yy_column := yy_column + 2
--|#line 145 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 145")
end
last_token := XPLAIN_DOTDOT
end
end
else
if yy_act <= 34 then
if yy_act = 33 then
	yy_column := yy_column + 2
--|#line 146 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 146")
end
last_token := XPLAIN_GE
else
	yy_column := yy_column + 2
--|#line 147 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 147")
end
last_token := XPLAIN_LE
end
else
if yy_act = 35 then
	yy_column := yy_column + 1
--|#line 148 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 148")
end
last_token := Comma_code
else
	yy_column := yy_column + 1
--|#line 149 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 149")
end
last_token := Colon_code
end
end
end
end
end
else
if yy_act <= 54 then
if yy_act <= 45 then
if yy_act <= 41 then
if yy_act <= 39 then
if yy_act <= 38 then
if yy_act = 37 then
	yy_column := yy_column + 1
--|#line 150 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 150")
end
last_token := Left_parenthesis_code
else
	yy_column := yy_column + 1
--|#line 151 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 151")
end
last_token := Right_parenthesis_code
end
else
	yy_column := yy_column + 3
--|#line 156 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 156")
end
 last_token := XPLAIN_AND 
end
else
if yy_act = 40 then
	yy_end := yy_start + yy_more_len + 3
	yy_column := yy_column + 3
--|#line 157 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 157")
end
 last_token := XPLAIN_AND 
else
	yy_column := yy_column + 3
--|#line 158 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 158")
end
 last_token := XPLAIN_ANY 
end
end
else
if yy_act <= 43 then
if yy_act = 42 then
	yy_column := yy_column + 2
--|#line 159 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 159")
end
 last_token := XPLAIN_AS 
else
	yy_column := yy_column + 6
--|#line 160 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 160")
end
 last_token := XPLAIN_ASSERT 
end
else
if yy_act = 44 then
	yy_column := yy_column + 4
--|#line 161 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 161")
end
 last_token := XPLAIN_BASE; expect_domain := True 
else
	yy_column := yy_column + 7
--|#line 162 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 162")
end
 last_token := XPLAIN_CASCADE 
end
end
end
else
if yy_act <= 50 then
if yy_act <= 48 then
if yy_act <= 47 then
if yy_act = 46 then
	yy_column := yy_column + 4
--|#line 163 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 163")
end
 last_token := XPLAIN_CASE 
else
	yy_column := yy_column + 5
--|#line 164 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 164")
end
 last_token := XPLAIN_CHECK 
end
else
	yy_column := yy_column + 9
--|#line 165 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 165")
end
 last_token := XPLAIN_CLUSTERED 
end
else
if yy_act = 49 then
	yy_column := yy_column + 8
--|#line 166 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 166")
end
 last_token := XPLAIN_CONSTANT; expect_domain := True 
else
	yy_column := yy_column + 5
--|#line 167 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 167")
end
 last_token := XPLAIN_COUNT 
end
end
else
if yy_act <= 52 then
if yy_act = 51 then
	yy_column := yy_column + 8
--|#line 168 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 168")
end
 last_token := XPLAIN_DATABASE 
else
	yy_column := yy_column + 7
--|#line 169 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 169")
end
 last_token := XPLAIN_DEFAULT 
end
else
if yy_act = 53 then
	yy_column := yy_column + 6
--|#line 170 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 170")
end
 last_token := XPLAIN_DELETE 
else
	yy_column := yy_column + 4
--|#line 171 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 171")
end
 last_token := XPLAIN_ECHO 
end
end
end
end
else
if yy_act <= 63 then
if yy_act <= 59 then
if yy_act <= 57 then
if yy_act <= 56 then
if yy_act = 55 then
	yy_column := yy_column + 4
--|#line 172 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 172")
end
 last_token := XPLAIN_ELSE 
else
	yy_end := yy_start + yy_more_len + 4
	yy_column := yy_column + 4
--|#line 173 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 173")
end
 last_token := XPLAIN_ELSE 
end
else
	yy_column := yy_column + 3
--|#line 174 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 174")
end
 last_token := XPLAIN_END 
end
else
if yy_act = 58 then
	yy_column := yy_column + 7
--|#line 175 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 175")
end
 last_token := XPLAIN_ENDPROC 
else
	yy_column := yy_column + 6
--|#line 176 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 176")
end
 last_token := XPLAIN_EXTEND; expect_domain := True 
end
end
else
if yy_act <= 61 then
if yy_act = 60 then
	yy_column := yy_column + 5
--|#line 177 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 177")
end
 last_token := XPLAIN_FALSE 
else
	yy_column := yy_column + 3
--|#line 178 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 178")
end
 last_token := XPLAIN_GET 
end
else
if yy_act = 62 then
	yy_column := yy_column + 2
--|#line 179 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 179")
end
 last_token := XPLAIN_IF 
else
	yy_end := yy_start + yy_more_len + 2
	yy_column := yy_column + 2
--|#line 180 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 180")
end
 last_token := XPLAIN_IF 
end
end
end
else
if yy_act <= 68 then
if yy_act <= 66 then
if yy_act <= 65 then
if yy_act = 64 then
	yy_column := yy_column + 5
--|#line 181 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 181")
end
 last_token := XPLAIN_INDEX 
else
	yy_column := yy_column + 4
--|#line 182 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 182")
end
 last_token := XPLAIN_INIT 
end
else
	yy_column := yy_column + 5
--|#line 183 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 183")
end
 last_token := XPLAIN_INPUT 
end
else
if yy_act = 67 then
	yy_column := yy_column + 6
--|#line 184 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 184")
end
 last_token := XPLAIN_INSERT 
else
	yy_column := yy_column + 8
--|#line 185 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 185")
end
 last_token := XPLAIN_INSERTED 
end
end
else
if yy_act <= 70 then
if yy_act = 69 then
	yy_column := yy_column + 3
--|#line 186 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 186")
end
 last_token := XPLAIN_ITS 
else
	yy_column := yy_column + 9
--|#line 187 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 187")
end
 last_token := XPLAIN_LOGINNAME 
end
else
if yy_act = 71 then
	yy_column := yy_column + 3
--|#line 188 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 188")
end
 last_token := XPLAIN_MAX 
else
	yy_column := yy_column + 3
--|#line 189 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 189")
end
 last_token := XPLAIN_MIN 
end
end
end
end
end
end
else
if yy_act <= 108 then
if yy_act <= 90 then
if yy_act <= 81 then
if yy_act <= 77 then
if yy_act <= 75 then
if yy_act <= 74 then
if yy_act = 73 then
	yy_column := yy_column + 7
--|#line 190 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 190")
end
 last_token := XPLAIN_NEWLINE 
else
	yy_column := yy_column + 3
--|#line 191 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 191")
end
 last_token := XPLAIN_NIL 
end
else
	yy_column := yy_column + 3
--|#line 192 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 192")
end
 last_token := XPLAIN_NOT 
end
else
if yy_act = 76 then
	yy_end := yy_start + yy_more_len + 3
	yy_column := yy_column + 3
--|#line 193 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 193")
end
 last_token := XPLAIN_NOT 
else
	yy_column := yy_column + 4
--|#line 194 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 194")
end
 last_token := XPLAIN_NULL 
end
end
else
if yy_act <= 79 then
if yy_act = 78 then
	yy_column := yy_column + 2
--|#line 195 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 195")
end
 last_token := XPLAIN_OF 
else
	yy_column := yy_column + 8
--|#line 196 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 196")
end
 last_token := XPLAIN_OPTIONAL 
end
else
if yy_act = 80 then
	yy_column := yy_column + 2
--|#line 197 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 197")
end
 last_token := XPLAIN_OR 
else
	yy_end := yy_start + yy_more_len + 2
	yy_column := yy_column + 2
--|#line 198 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 198")
end
 last_token := XPLAIN_OR 
end
end
end
else
if yy_act <= 86 then
if yy_act <= 84 then
if yy_act <= 83 then
if yy_act = 82 then
	yy_column := yy_column + 3
--|#line 199 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 199")
end
 last_token := XPLAIN_PER 
else
	yy_column := yy_column + 9
--|#line 200 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 200")
end
 last_token := XPLAIN_PROCEDURE 
end
else
	yy_column := yy_column + 5
--|#line 201 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 201")
end
 last_token := XPLAIN_PURGE 
end
else
if yy_act = 85 then
yy_set_line_column
--|#line 202 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 202")
end
 last_token := XPLAIN_RECOMPILED_PROCEDURE 
else
yy_set_line_column
--|#line 203 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 203")
end
 last_token := XPLAIN_TRIGGER_PROCEDURE 
end
end
else
if yy_act <= 88 then
if yy_act = 87 then
	yy_column := yy_column + 8
--|#line 204 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 204")
end
 last_token := XPLAIN_REQUIRED 
else
	yy_column := yy_column + 4
--|#line 205 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 205")
end
 last_token := XPLAIN_SOME 
end
else
if yy_act = 89 then
	yy_column := yy_column + 10
--|#line 206 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 206")
end
 last_token := XPLAIN_SYSTEMDATE 
else
	yy_column := yy_column + 4
--|#line 207 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 207")
end
 last_token := XPLAIN_THEN 
end
end
end
end
else
if yy_act <= 99 then
if yy_act <= 95 then
if yy_act <= 93 then
if yy_act <= 92 then
if yy_act = 91 then
	yy_end := yy_start + yy_more_len + 4
	yy_column := yy_column + 4
--|#line 208 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 208")
end
 last_token := XPLAIN_THEN 
else
	yy_column := yy_column + 5
--|#line 209 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 209")
end
 last_token := XPLAIN_TOTAL 
end
else
	yy_column := yy_column + 4
--|#line 210 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 210")
end
 last_token := XPLAIN_TRUE 
end
else
if yy_act = 94 then
	yy_column := yy_column + 4
--|#line 211 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 211")
end
 last_token := XPLAIN_TYPE; expect_domain := True 
else
	yy_column := yy_column + 6
--|#line 212 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 212")
end
 last_token := XPLAIN_UNIQUE 
end
end
else
if yy_act <= 97 then
if yy_act = 96 then
	yy_column := yy_column + 6
--|#line 213 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 213")
end
 last_token := XPLAIN_UPDATE 
else
	yy_column := yy_column + 5
--|#line 214 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 214")
end
 last_token := XPLAIN_VALUE 
end
else
if yy_act = 98 then
	yy_column := yy_column + 4
--|#line 215 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 215")
end
 last_token := XPLAIN_WITH 
else
	yy_column := yy_column + 5
--|#line 216 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 216")
end
 last_token := XPLAIN_WHERE 
end
end
end
else
if yy_act <= 104 then
if yy_act <= 102 then
if yy_act <= 101 then
if yy_act = 100 then
yy_set_line_column
--|#line 221 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 221")
end
 last_token := XPLAIN_COMBINE 
else
yy_set_line_column
--|#line 222 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 222")
end
 last_token := XPLAIN_HEAD 
end
else
yy_set_line_column
--|#line 223 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 223")
end
 last_token := XPLAIN_TAIL 
end
else
if yy_act = 103 then
yy_set_line_column
--|#line 228 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 228")
end
 last_token := XPLAIN_DATEF 
else
yy_set_line_column
--|#line 229 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 229")
end
 last_token := XPLAIN_INTEGERF 
end
end
else
if yy_act <= 106 then
if yy_act = 105 then
yy_set_line_column
--|#line 230 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 230")
end
 last_token := XPLAIN_REALF 
else
yy_set_line_column
--|#line 231 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 231")
end
 last_token := XPLAIN_STRINGF 
end
else
if yy_act = 107 then
yy_set_line_column
--|#line 236 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 236")
end
 last_token := XPLAIN_DAYF 
else
yy_set_line_column
--|#line 237 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 237")
end
 last_token := XPLAIN_ISDATE 
end
end
end
end
end
else
if yy_act <= 126 then
if yy_act <= 117 then
if yy_act <= 113 then
if yy_act <= 111 then
if yy_act <= 110 then
if yy_act = 109 then
yy_set_line_column
--|#line 238 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 238")
end
 last_token := XPLAIN_MONTHF 
else
yy_set_line_column
--|#line 239 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 239")
end
 last_token := XPLAIN_NEWDATE 
end
else
yy_set_line_column
--|#line 240 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 240")
end
 last_token := XPLAIN_TIMEDIF 
end
else
if yy_act = 112 then
yy_set_line_column
--|#line 241 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 241")
end
 last_token := XPLAIN_YEARF 
else
yy_set_line_column
--|#line 242 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 242")
end
 last_token := XPLAIN_WDAYF 
end
end
else
if yy_act <= 115 then
if yy_act = 114 then
yy_set_line_column
--|#line 247 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 247")
end
 last_token := XPLAIN_POW 
else
yy_set_line_column
--|#line 248 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 248")
end
 last_token := XPLAIN_ABS 
end
else
if yy_act = 116 then
yy_set_line_column
--|#line 249 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 249")
end
 last_token := XPLAIN_MAXF 
else
yy_set_line_column
--|#line 250 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 250")
end
 last_token := XPLAIN_MINF 
end
end
end
else
if yy_act <= 122 then
if yy_act <= 120 then
if yy_act <= 119 then
if yy_act = 118 then
yy_set_line_column
--|#line 251 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 251")
end
 last_token := XPLAIN_SQRT 
else
yy_set_line_column
--|#line 252 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 252")
end
 last_token := XPLAIN_EXP 
end
else
yy_set_line_column
--|#line 253 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 253")
end
 last_token := XPLAIN_LN 
end
else
if yy_act = 121 then
yy_set_line_column
--|#line 254 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 254")
end
 last_token := XPLAIN_LOG10 
else
yy_set_line_column
--|#line 255 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 255")
end
 last_token := XPLAIN_SIN 
end
end
else
if yy_act <= 124 then
if yy_act = 123 then
yy_set_line_column
--|#line 256 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 256")
end
 last_token := XPLAIN_COS 
else
yy_set_line_column
--|#line 257 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 257")
end
 last_token := XPLAIN_TAN 
end
else
if yy_act = 125 then
yy_set_line_column
--|#line 258 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 258")
end
 last_token := XPLAIN_ASIN 
else
yy_set_line_column
--|#line 259 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 259")
end
 last_token := XPLAIN_ACOS 
end
end
end
end
else
if yy_act <= 135 then
if yy_act <= 131 then
if yy_act <= 129 then
if yy_act <= 128 then
if yy_act = 127 then
yy_set_line_column
--|#line 260 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 260")
end
 last_token := XPLAIN_ATAN 
else
yy_set_line_column
--|#line 261 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 261")
end
 last_token := XPLAIN_SINH 
end
else
yy_set_line_column
--|#line 262 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 262")
end
 last_token := XPLAIN_COSH 
end
else
if yy_act = 130 then
yy_set_line_column
--|#line 263 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 263")
end
 last_token := XPLAIN_TANH 
else
yy_set_line_column
--|#line 264 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 264")
end
 last_token := XPLAIN_ASINH 
end
end
else
if yy_act <= 133 then
if yy_act = 132 then
yy_set_line_column
--|#line 265 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 265")
end
 last_token := XPLAIN_ACOSH 
else
yy_set_line_column
--|#line 266 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 266")
end
 last_token := XPLAIN_ATANH 
end
else
if yy_act = 134 then
yy_set_line_column
--|#line 271 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 271")
end
 last_token := XPLAIN_ID 
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 276 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 276")
end

		  last_token := XPLAIN_IDENTIFIER
		  last_string_value := text
		  last_string_value.right_adjust
		
end
end
end
else
if yy_act <= 139 then
if yy_act <= 137 then
if yy_act = 136 then
yy_set_line_column
--|#line 283 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 283")
end

		 last_token := XPLAIN_IDENTIFIER
		 last_string_value := text.substring(2, text.count-1)
	
else
yy_set_line_column
--|#line 291 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 291")
end

	if text.count = 2 then
		last_string_value := ""
	else
		last_string_value := unquote_string (text.substring(2, text.count-1))
	end
	last_token := XPLAIN_STRING
	
end
else
if yy_act = 138 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 300 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 300")
end

	last_token := XPLAIN_INTEGER
	last_integer_value := text.to_integer
	
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 304 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 304")
end

	last_token := XPLAIN_DOUBLE
	last_string_value := text
	
end
end
else
if yy_act <= 141 then
if yy_act = 140 then
	yy_column := yy_column + 8
--|#line 312 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 312")
end
 preprocessor_include 
else
	yy_column := yy_column + 4
--|#line 313 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 313")
end
 preprocessor_use 
end
else
if yy_act = 142 then
	yy_column := yy_column + 1
--|#line 322 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 322")
end
last_token := text_item (1).code
else
yy_set_line_column
--|#line 0 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 0")
end
default_action
end
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0, 1, 2, 3 then
--|#line 0 "xplain_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'xplain_scanner.l' at line 0")
end

	terminate
	std.output.put_string("%N")
	
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make (0, 1662)
			yy_nxt_template_1 (an_array)
			yy_nxt_template_2 (an_array)
			Result := yy_fixed_array (an_array)
		end

	yy_nxt_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			    0,   10,   11,   12,   11,   11,   13,   14,   10,   15,
			   16,   17,   18,   19,   20,   21,   22,   23,   23,   23,
			   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
			   34,   35,   36,   37,   37,   38,   39,   40,   41,   42,
			   37,   43,   44,   45,   46,   47,   48,   37,   49,   50,
			   51,   10,   54,   55,   54,   55,   57,   58,   57,   58,
			   60,   60,   60,   60,   60,   60,   60,   60,   72,   74,
			   77,   73,   73,   73,   79,   78,   73,   73,   73,   80,
			   81,   83,   83,   83,   83,  537,   75,   60,   60,   60,
			   60,   83,  536,   83,   83,  151,  151,  151,   76,   83,

			   90,   83,  101,  139,   59,  102,   59,   63,   64,   65,
			   66,   85,   86,   95,   83,   67,  103,   96,   83,   68,
			   91,   83,   69,   87,   70,   83,   71,   92,   88,   89,
			   83,   93,   83,   83,   94,   97,  153,   83,   83,  535,
			   83,  534,  533,  104,   98,  105,   99,   83,  125,  111,
			  109,  110,  532,  106,   83,  121,  100,  112,  107,  108,
			  114,   83,  118,  113,  115,  122,  154,  126,  123,   83,
			  116,  124,  119,  127,  120,  128,  117,  143,  129,  137,
			  131,  138,   79,  130,   73,   73,   73,  132,  133,   83,
			   83,  140,   83,   83,  134,  141,  142,  135,   83,   83,

			   83,  152,  152,  152,  136,   83,   83,   83,   83,   83,
			   83,   83,  155,   83,  531,   83,   83,  159,   83,  157,
			   83,  530,   83,  162,   83,   83,  179,  529,  528,  158,
			  160,   83,   83,  156,  170,  172,  161,  164,  165,   83,
			  171,   83,  174,  166,  163,  167,  168,  189,  173,  175,
			  190,  169,  177,  176,  178,  180,  180,  180,  181,   83,
			  195,  184,  182,  196,  197,  198,  185,  191,  191,  191,
			  192,  199,   83,  186,  193,   83,  187,  188,   83,   83,
			   83,   83,   83,   83,  194,   83,   83,   83,   83,   83,
			   83,   83,  527,   83,  526,   83,   83,   83,   83,   83,

			  151,  151,  151,   83,  208,  201,  209,   83,  525,   83,
			  200,   83,  227,  226,  206,  204,  202,  212,  207,  211,
			  210,  205,  218,  216,  213,  214,  219,  215,  217,  220,
			  221,  223,  228,  225,  224,   83,  229,  152,  234,  234,
			  234,  235,  222,   83,   83,  236,   83,   83,   83,  152,
			  152,  152,   83,   83,  230,   83,   83,   83,  249,  249,
			  249,  250,   83,   83,   83,  251,   83,   83,   83,  240,
			   83,  242,   83,  243,  245,  244,  239,  247,   83,  241,
			  237,   83,  254,   83,   83,  257,  255,  252,  256,   83,
			  258,   83,  246,  248,  253,  260,  262,  262,  262,  263,

			  524,  259,   83,  264,  261,  522,  265,  180,  180,  180,
			  180,  267,   83,  397,  182,  266,  180,  180,  180,  181,
			  272,   83,  271,  182,  183,  270,  182,  182,  182,  182,
			   83,  152,  152,  152,  268,  273,  269,  269,  269,  191,
			  191,  191,  191,   83,  274,   83,  193,   83,   83,  275,
			  191,  191,  191,  192,   83,   83,  276,  193,   83,   83,
			  519,  278,  278,  278,  279,  152,  152,  152,  280,  285,
			  277,  281,  281,  281,  282,  289,  203,  286,  283,  291,
			  291,  291,  292,  284,  288,   83,  293,   83,  290,  290,
			  290,   83,  297,   83,  298,  299,  299,  299,  300,   83,

			   83,   83,  301,   83,   83,   83,  294,  308,  308,  308,
			  309,   83,  295,   83,  310,   83,  303,   83,   83,   83,
			   83,  296,   83,  314,  302,   83,   83,  305,  313,   83,
			   83,   83,   83,  307,   83,   83,  311,  304,  315,  306,
			  316,  317,   83,  312,  319,   83,   83,   83,  323,  340,
			  318,   83,  234,  234,  234,  234,   83,   83,  320,  236,
			  341,  370,  322,  321,   83,  324,  234,  234,  234,  235,
			  335,  349,  343,  236,  238,   83,   83,  326,  326,  326,
			  327,  152,  152,  152,  328,  342,  330,  330,  330,  331,
			  331,  331,  332,   83,  344,  348,  333,  336,  336,  336,

			  337,   83,   83,  354,  338,   83,  329,  249,  249,  249,
			  249,   83,  357,  355,  251,   83,   83,  350,  334,   83,
			   83,   83,   83,  269,  371,  359,  339,  249,  249,  249,
			  250,  368,   83,  358,  251,  269,  269,  269,  345,  345,
			  345,  346,  152,  152,  152,  347,  351,  351,  351,  352,
			  400,  365,  369,  353,  262,  262,  262,  262,  363,  364,
			   83,  264,  262,  262,  262,  263,   83,   83,   83,  264,
			  367,   83,   83,  360,  360,  360,  361,  152,  152,  152,
			  362,  278,  278,  278,  278,  366,   83,  420,  280,  278,
			  278,  278,  279,  372,  375,  376,  280,   83,  380,   83,

			  281,  281,  281,  281,  152,  152,  152,  283,  281,  281,
			  281,  282,   83,   83,  287,  283,   83,  290,   83,  374,
			  389,   83,   83,  152,  152,  152,  373,  373,  373,  290,
			  290,  290,  291,  291,  291,  291,   83,  401,  399,  293,
			  291,  291,  291,  292,  388,  381,  398,  293,   83,   83,
			   83,  377,  377,  377,  378,  152,  152,  152,  379,  299,
			  299,  299,  299,  447,   83,   83,  301,  299,  299,  299,
			  300,  402,  417,  403,  301,   83,   83,   83,  382,  382,
			  382,  383,  152,  152,  152,  384,  385,  385,  385,  386,
			   83,   83,   83,  387,  390,  390,  390,  391,  404,  442,

			  405,  392,  308,  308,  308,  308,  330,   83,   83,  310,
			  308,  308,  308,  309,  418,  413,   83,  310,  330,  330,
			  330,  393,  393,  393,  394,  152,  152,  152,  395,  326,
			  326,  326,  326,   83,   83,  421,  328,  326,  326,  326,
			  327,   83,   83,  443,  328,   83,  430,   83,  407,  407,
			  407,  408,  152,  152,  152,  409,  331,  331,  331,  331,
			  478,   83,   83,  333,  331,  331,  331,  332,  426,  429,
			  459,  333,  425,  419,   83,  410,  410,  410,  411,  152,
			  152,  152,  412,  336,  336,  336,  336,  356,   83,   83,
			  338,  336,  336,  336,  337,  428,   83,  431,  338,  427,

			  427,  427,  414,  414,  414,  415,  152,  152,  152,  416,
			  345,  345,  345,  345,  444,   83,   83,  347,  345,  345,
			  345,  346,   83,   83,  466,  347,   83,   83,  436,  422,
			  422,  422,  423,  152,  152,  152,  424,  351,  351,  351,
			  351,   83,   83,   83,  353,  351,  351,  351,  352,  432,
			   83,  437,  353,  438,  439,  440,  360,  360,  360,  360,
			  152,  152,  152,  362,  360,  360,  360,  361,   83,   83,
			   83,  362,  373,  445,  497,  433,  433,  433,  434,  152,
			  152,  152,  435,  396,  373,  373,  373,  462,  486,  470,
			  441,  377,  377,  377,  377,  446,  446,  446,  379,  377, yy_Dummy>>,
			1, 1000, 0)
		end

	yy_nxt_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			  377,  377,  378,   83,   83,   83,  379,  463,   83,   83,
			  382,  382,  382,  382,  152,  152,  152,  384,  382,  382,
			  382,  383,   83,   83,   83,  384,  448,  449,  450,  385,
			  385,  385,  385,  152,  152,  152,  387,  385,  385,  385,
			  386,  461,   83,   83,  387,  458,  460,  465,  390,  390,
			  390,  390,  152,  152,  152,  392,  390,  390,  390,  391,
			   83,   83,   83,  392,  464,  474,   83,  393,  393,  393,
			  393,  152,  152,  152,  395,  393,  393,  393,  394,   83,
			  476,   83,  395,  475,   83,  479,  451,  451,  451,  452,
			  152,  152,  152,  453,  454,  454,  454,  455,   83,   83,

			  505,  456,  407,  407,  407,  407,  427,   83,  484,  409,
			  407,  407,  407,  408,   83,  485,   83,  409,  427,  427,
			  427,  410,  410,  410,  410,  152,  152,  152,  412,  410,
			  410,  410,  411,   83,   83,  502,  412,  477,  483,   83,
			  414,  414,  414,  414,  152,  152,  152,  416,  414,  414,
			  414,  415,  491,   83,   83,  416,  487,  492,   83,  422,
			  422,  422,  422,  152,  152,  152,  424,  422,  422,  422,
			  423,  457,   83,   83,  424,  493,  504,   83,  467,  467,
			  467,  468,  152,  152,  152,  469,  433,  433,  433,  433,
			  446,   83,   83,  435,  433,  433,  433,  434,   83,  511,

			   83,  435,  446,  446,  446,  471,  471,  471,  472,  152,
			  152,  152,  473,  480,  480,  480,  481,   83,   83,   83,
			  482,  451,  451,  451,  451,   83,   83,   83,  453,  451,
			  451,  451,  452,   83,  406,   83,  453,   83,  515,  517,
			  454,  454,  454,  454,  152,  152,  152,  456,  454,  454,
			  454,  455,   83,   83,  396,  456,  501,  503,  512,  488,
			  488,  488,  489,  152,  152,  152,  490,  494,  494,  494,
			  495,   83,   83,   83,  496,  467,  467,  467,  467,  356,
			   83,   83,  469,  467,  467,  467,  468,   83,   83,   83,
			  469,   83,  325,   83,  471,  471,  471,  471,  152,  152,

			  152,  473,  471,  471,  471,  472,  287,   83,   83,  473,
			  513,  514,  518,  498,  498,  498,  499,  152,  152,  152,
			  500,  480,  480,  480,  480,   83,   83,  238,  482,  480,
			  480,  480,  481,  233,  232,  231,  482,  203,   83,  183,
			  506,  506,  506,  507,  152,  152,  152,  508,  509,  509,
			  509,  510,  488,  488,  488,  488,   83,  150,  149,  490,
			  488,  488,  488,  489,  148,  147,   61,  490,   62,   83,
			   82,  494,  494,  494,  494,  152,  152,  152,  496,  494,
			  494,  494,  495,   62,  538,  538,  496,  538,  538,  538,
			  498,  498,  498,  498,  152,  152,  152,  500,  498,  498,

			  498,  499,  538,  538,  538,  500,  538,  538,  538,  506,
			  506,  506,  506,  152,  152,  152,  508,  506,  506,  506,
			  507,  538,  538,  538,  508,  509,  509,  509,  509,  538,
			  538,  538,  152,  152,  152,  520,  520,  520,  521,  520,
			  520,  520,  520,   84,  538,   84,   84,   84,   84,  146,
			  538,  146,  146,  146,  146,  146,  146,  538,  538,  538,
			  538,  538,  516,  509,  509,  509,  510,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  523,  538,  152,  152,
			  152,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,

			  516,  520,  520,  520,  521,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  152,  152,  152,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  523,   52,
			   52,   52,   52,   52,   52,   52,   52,   52,   53,   53,
			   53,   53,   53,   53,   53,   53,   53,   56,   56,   56,
			   56,   56,   56,   56,   56,   56,   61,   61,   61,   61,
			   61,   61,   61,   61,   61,  144,  144,  144,  538,  144,
			  144,  144,  144,  144,  145,  538,  145,  145,  145,  145,
			  145,  145,  145,   77,   77,   77,   77,   77,   77,   77,

			   77,   77,   78,   78,   78,   78,   78,   78,   78,   78,
			   78,    9,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538, yy_Dummy>>,
			1, 663, 1000)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make (0, 1662)
			yy_chk_template_1 (an_array)
			yy_chk_template_2 (an_array)
			Result := yy_fixed_array (an_array)
		end

	yy_chk_template_1 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    5,    6,    6,    7,    7,    8,    8,
			   11,   11,   11,   11,   12,   12,   12,   12,   20,   21,
			   22,   20,   20,   20,   23,   22,   23,   23,   23,   25,
			   25,   29,   34,   33,   47,  536,   21,   60,   60,   60,
			   60,   28,  535,   35,   31,   79,   79,   79,   21,   85,

			   29,   30,   33,   47,    7,   34,    8,   15,   15,   15,
			   15,   28,   28,   31,   32,   15,   35,   31,   38,   15,
			   30,   36,   15,   28,   15,   43,   15,   30,   28,   28,
			   39,   30,   42,   86,   30,   32,   85,   40,   41,  533,
			   44,  532,  531,   36,   32,   36,   32,   46,   43,   39,
			   38,   38,  530,   36,   49,   42,   32,   39,   36,   36,
			   40,   45,   41,   39,   40,   42,   86,   44,   42,   48,
			   40,   42,   41,   44,   41,   44,   40,   49,   44,   46,
			   45,   46,   73,   44,   73,   73,   73,   45,   45,   83,
			   87,   48,   88,   90,   45,   48,   48,   45,   89,   91,

			   92,   83,   83,   83,   45,   93,   94,  103,   95,   97,
			   96,   98,   87,  108,  529,  100,  102,   89,  111,   88,
			   99,  528,  101,   92,  114,  107,  103,  527,  526,   88,
			   90,  112,  113,   87,   96,   97,   91,   94,   94,  106,
			   96,  115,   99,   94,   93,   94,   95,  107,   98,  100,
			  108,   95,  101,  100,  102,  104,  104,  104,  104,  110,
			  111,  106,  104,  112,  113,  114,  106,  109,  109,  109,
			  109,  115,  116,  106,  109,  117,  106,  106,  119,  121,
			  122,  123,  124,  139,  110,  125,  127,  126,  128,  129,
			  130,  134,  525,  140,  524,  133,  131,  136,  142,  132,

			  151,  151,  151,  135,  125,  117,  125,  137,  523,  141,
			  116,  138,  140,  139,  123,  121,  119,  127,  124,  126,
			  125,  122,  132,  131,  128,  129,  133,  130,  131,  134,
			  135,  136,  141,  138,  137,  143,  142,  152,  153,  153,
			  153,  153,  135,  154,  157,  153,  158,  159,  160,  152,
			  152,  152,  161,  162,  143,  163,  165,  164,  166,  166,
			  166,  166,  167,  168,  169,  166,  170,  171,  172,  158,
			  174,  160,  173,  161,  162,  161,  157,  164,  177,  159,
			  154,  186,  168,  176,  185,  170,  168,  166,  169,  179,
			  171,  313,  163,  165,  167,  173,  175,  175,  175,  175,

			  522,  172,  184,  175,  174,  519,  176,  180,  180,  180,
			  180,  179,  187,  313,  180,  177,  181,  181,  181,  181,
			  186,  188,  185,  181,  183,  184,  182,  182,  182,  182,
			  189,  181,  181,  181,  182,  187,  183,  183,  183,  191,
			  191,  191,  191,  194,  188,  197,  191,  198,  202,  189,
			  192,  192,  192,  192,  201,  210,  194,  192,  518,  209,
			  516,  195,  195,  195,  195,  192,  192,  192,  195,  198,
			  194,  196,  196,  196,  196,  202,  203,  198,  196,  205,
			  205,  205,  205,  197,  201,  206,  205,  207,  203,  203,
			  203,  208,  209,  212,  210,  211,  211,  211,  211,  213,

			  214,  215,  211,  216,  220,  219,  206,  217,  217,  217,
			  217,  218,  207,  221,  217,  224,  212,  222,  223,  226,
			  227,  208,  229,  220,  211,  225,  228,  214,  219,  230,
			  243,  245,  513,  216,  240,  284,  217,  213,  221,  215,
			  222,  223,  512,  218,  225,  247,  511,  246,  229,  243,
			  224,  254,  234,  234,  234,  234,  248,  253,  226,  234,
			  245,  284,  228,  227,  257,  230,  235,  235,  235,  235,
			  240,  254,  247,  235,  238,  258,  261,  237,  237,  237,
			  237,  235,  235,  235,  237,  246,  238,  238,  238,  239,
			  239,  239,  239,  255,  248,  253,  239,  241,  241,  241,

			  241,  265,  266,  257,  241,  285,  237,  249,  249,  249,
			  249,  318,  261,  258,  249,  273,  270,  255,  239,  276,
			  277,  272,  504,  269,  285,  266,  241,  250,  250,  250,
			  250,  276,  275,  265,  250,  269,  269,  269,  252,  252,
			  252,  252,  250,  250,  250,  252,  256,  256,  256,  256,
			  318,  273,  277,  256,  262,  262,  262,  262,  270,  272,
			  274,  262,  263,  263,  263,  263,  286,  297,  344,  263,
			  275,  294,  295,  267,  267,  267,  267,  263,  263,  263,
			  267,  278,  278,  278,  278,  274,  289,  344,  278,  279,
			  279,  279,  279,  286,  294,  295,  279,  306,  297,  319,

			  281,  281,  281,  281,  279,  279,  279,  281,  282,  282,
			  282,  282,  305,  315,  287,  282,  314,  290,  298,  289,
			  306,  501,  493,  282,  282,  282,  287,  287,  287,  290,
			  290,  290,  291,  291,  291,  291,  397,  319,  315,  291,
			  292,  292,  292,  292,  305,  298,  314,  292,  320,  321,
			  340,  296,  296,  296,  296,  292,  292,  292,  296,  299,
			  299,  299,  299,  397,  492,  380,  299,  300,  300,  300,
			  300,  320,  340,  321,  300,  322,  324,  335,  302,  302,
			  302,  302,  300,  300,  300,  302,  304,  304,  304,  304,
			  491,  342,  475,  304,  307,  307,  307,  307,  322,  380,

			  324,  307,  308,  308,  308,  308,  330,  381,  365,  308,
			  309,  309,  309,  309,  342,  335,  349,  309,  330,  330,
			  330,  311,  311,  311,  311,  309,  309,  309,  311,  326,
			  326,  326,  326,  442,  418,  349,  326,  327,  327,  327,
			  327,  343,  354,  381,  327,  355,  365,  358,  329,  329,
			  329,  329,  327,  327,  327,  329,  331,  331,  331,  331,
			  442,  464,  357,  331,  332,  332,  332,  332,  355,  358,
			  418,  332,  354,  343,  366,  334,  334,  334,  334,  332,
			  332,  332,  334,  336,  336,  336,  336,  356,  431,  388,
			  336,  337,  337,  337,  337,  357,  369,  366,  337,  356,

			  356,  356,  339,  339,  339,  339,  337,  337,  337,  339,
			  345,  345,  345,  345,  388,  371,  463,  345,  346,  346,
			  346,  346,  372,  374,  431,  346,  367,  370,  369,  350,
			  350,  350,  350,  346,  346,  346,  350,  351,  351,  351,
			  351,  458,  389,  470,  351,  352,  352,  352,  352,  367,
			  421,  370,  352,  371,  372,  374,  360,  360,  360,  360,
			  352,  352,  352,  360,  361,  361,  361,  361,  375,  425,
			  436,  361,  373,  389,  470,  368,  368,  368,  368,  361,
			  361,  361,  368,  396,  373,  373,  373,  421,  457,  436,
			  375,  377,  377,  377,  377,  396,  396,  396,  377,  378, yy_Dummy>>,
			1, 1000, 0)
		end

	yy_chk_template_2 (an_array: ARRAY [INTEGER]) is
		do
			yy_array_subcopy (an_array, <<
			  378,  378,  378,  399,  400,  401,  378,  425,  450,  420,
			  382,  382,  382,  382,  378,  378,  378,  382,  383,  383,
			  383,  383,  417,  419,  430,  383,  399,  400,  401,  385,
			  385,  385,  385,  383,  383,  383,  385,  386,  386,  386,
			  386,  420,  438,  428,  386,  417,  419,  430,  390,  390,
			  390,  390,  386,  386,  386,  390,  391,  391,  391,  391,
			  439,  440,  443,  391,  428,  438,  449,  393,  393,  393,
			  393,  391,  391,  391,  393,  394,  394,  394,  394,  448,
			  440,  483,  394,  439,  447,  443,  403,  403,  403,  403,
			  394,  394,  394,  403,  405,  405,  405,  405,  441,  477,

			  483,  405,  407,  407,  407,  407,  427,  429,  447,  407,
			  408,  408,  408,  408,  461,  448,  445,  408,  427,  427,
			  427,  410,  410,  410,  410,  408,  408,  408,  410,  411,
			  411,  411,  411,  459,  462,  477,  411,  441,  445,  426,
			  414,  414,  414,  414,  411,  411,  411,  414,  415,  415,
			  415,  415,  461,  465,  479,  415,  459,  462,  413,  422,
			  422,  422,  422,  415,  415,  415,  422,  423,  423,  423,
			  423,  406,  404,  402,  423,  465,  479,  487,  432,  432,
			  432,  432,  423,  423,  423,  432,  433,  433,  433,  433,
			  446,  398,  376,  433,  434,  434,  434,  434,  364,  487,

			  505,  434,  446,  446,  446,  437,  437,  437,  437,  434,
			  434,  434,  437,  444,  444,  444,  444,  514,  363,  359,
			  444,  451,  451,  451,  451,  348,  476,  478,  451,  452,
			  452,  452,  452,  341,  325,  497,  452,  323,  505,  514,
			  454,  454,  454,  454,  452,  452,  452,  454,  455,  455,
			  455,  455,  317,  316,  312,  455,  476,  478,  497,  460,
			  460,  460,  460,  455,  455,  455,  460,  466,  466,  466,
			  466,  303,  288,  271,  466,  467,  467,  467,  467,  260,
			  259,  244,  467,  468,  468,  468,  468,  502,  503,  515,
			  468,  242,  232,  204,  471,  471,  471,  471,  468,  468,

			  468,  471,  472,  472,  472,  472,  200,  199,  190,  472,
			  502,  503,  515,  474,  474,  474,  474,  472,  472,  472,
			  474,  480,  480,  480,  480,  178,  156,  155,  480,  481,
			  481,  481,  481,  148,  147,  144,  481,  120,  118,  105,
			  484,  484,  484,  484,  481,  481,  481,  484,  485,  485,
			  485,  485,  488,  488,  488,  488,   84,   78,   77,  488,
			  489,  489,  489,  489,   76,   75,   62,  489,   61,   37,
			   27,  494,  494,  494,  494,  489,  489,  489,  494,  495,
			  495,  495,  495,   13,    9,    0,  495,    0,    0,    0,
			  498,  498,  498,  498,  495,  495,  495,  498,  499,  499,

			  499,  499,    0,    0,    0,  499,    0,    0,    0,  506,
			  506,  506,  506,  499,  499,  499,  506,  507,  507,  507,
			  507,    0,    0,    0,  507,  509,  509,  509,  509,    0,
			    0,    0,  507,  507,  507,  517,  517,  517,  517,  520,
			  520,  520,  520,  543,    0,  543,  543,  543,  543,  546,
			    0,  546,  546,  546,  546,  546,  546,    0,    0,    0,
			    0,    0,  509,  510,  510,  510,  510,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  520,    0,  510,  510,
			  510,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			  510,  521,  521,  521,  521,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  521,  521,  521,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  521,  539,
			  539,  539,  539,  539,  539,  539,  539,  539,  540,  540,
			  540,  540,  540,  540,  540,  540,  540,  541,  541,  541,
			  541,  541,  541,  541,  541,  541,  542,  542,  542,  542,
			  542,  542,  542,  542,  542,  544,  544,  544,    0,  544,
			  544,  544,  544,  544,  545,    0,  545,  545,  545,  545,
			  545,  545,  545,  547,  547,  547,  547,  547,  547,  547,

			  547,  547,  548,  548,  548,  548,  548,  548,  548,  548,
			  548,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538, yy_Dummy>>,
			1, 663, 1000)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,   49,   51,   53,   55, 1384,
			 1611,   58,   62, 1377, 1611,   83, 1611, 1611, 1611, 1611,
			   54,   54,   59,   59, 1611,   57, 1611, 1348,   86,   76,
			   96,   89,  109,   78,   77,   88,  116, 1364,  113,  125,
			  132,  133,  127,  120,  135,  156,  142,   79,  164,  149,
			    0, 1611, 1611,    0, 1611, 1611,    0, 1611, 1611, 1611,
			   85, 1362, 1360, 1611, 1611, 1611, 1611, 1611, 1611, 1611,
			 1611, 1611, 1611,  167, 1611, 1328, 1322, 1355, 1354,   78,
			 1611, 1611, 1611,  184, 1351,   94,  128,  185,  187,  193,
			  188,  194,  195,  200,  201,  203,  205,  204,  206,  215,

			  210,  217,  211,  202,  253, 1334,  234,  220,  208,  265,
			  254,  213,  226,  227,  219,  236,  267,  270, 1333,  273,
			 1332,  274,  275,  276,  277,  280,  282,  281,  283,  284,
			  285,  291,  294,  290,  286,  298,  292,  302,  306,  278,
			  288,  304,  293,  330, 1327,    0,    0, 1308, 1305, 1611,
			 1611,  283,  332,  336,  338, 1322, 1321,  339,  341,  342,
			  343,  347,  348,  350,  352,  351,  356,  357,  358,  359,
			  361,  362,  363,  367,  365,  394,  378,  373, 1320,  384,
			  405,  414,  424,  419,  397,  379,  376,  407,  416,  425,
			 1303,  437,  448, 1611,  438,  459,  469,  440,  442, 1302,

			 1301,  449,  443,  471, 1288,  477,  480,  482,  486,  454,
			  450,  493,  488,  494,  495,  496,  498,  505,  506,  500,
			  499,  508,  512,  513,  510,  520,  514,  515,  521,  517,
			  524, 1611, 1257, 1611,  550,  564, 1611,  575,  569,  587,
			  529,  595, 1286,  525, 1276,  526,  542,  540,  551,  605,
			  625, 1611,  636,  552,  546,  588,  644,  559,  570, 1275,
			 1274,  571,  652,  660, 1611,  596,  597,  671, 1611,  618,
			  611, 1268,  616,  610,  655,  627,  614,  615,  679,  687,
			 1611,  698,  706, 1611,  530,  600,  661,  709, 1267,  681,
			  712,  730,  738, 1611,  666,  667,  749,  662,  713,  757,

			  765, 1611,  776, 1266,  784,  707,  692,  792,  800,  808,
			 1611,  819, 1249,  386,  711,  708, 1248, 1247,  606,  694,
			  743,  744,  770, 1232,  771, 1190,  827,  835, 1611,  846,
			  801,  854,  862, 1611,  873,  772,  881,  889, 1611,  900,
			  745, 1228,  786,  836,  663,  908,  916, 1611, 1220,  811,
			  927,  935,  943, 1611,  837,  840,  882,  857,  842, 1214,
			  954,  962, 1611, 1213, 1193,  803,  869,  921,  973,  891,
			  922,  910,  917,  967,  918,  963, 1187,  989,  997, 1611,
			  760,  802, 1008, 1016, 1611, 1027, 1035, 1611,  884,  937,
			 1046, 1054, 1611, 1065, 1073, 1611,  978,  731, 1186,  998,

			  999, 1000, 1168, 1084, 1167, 1092, 1144, 1100, 1108, 1611,
			 1119, 1127, 1611, 1153, 1138, 1146, 1611, 1017,  829, 1018,
			 1004,  945, 1157, 1165, 1611,  964, 1134, 1101, 1038, 1102,
			 1019,  883, 1176, 1184, 1192, 1611,  965, 1203, 1037, 1055,
			 1056, 1093,  828, 1057, 1211, 1111, 1185, 1079, 1074, 1061,
			 1003, 1219, 1227, 1611, 1238, 1246, 1611,  960,  936, 1128,
			 1257, 1109, 1129,  911,  856, 1148, 1265, 1273, 1281, 1611,
			  938, 1292, 1300, 1611, 1311,  787, 1221, 1094, 1222, 1149,
			 1319, 1327, 1611, 1076, 1338, 1346, 1611, 1172, 1350, 1358,
			 1611,  785,  759,  717, 1369, 1377, 1611, 1230, 1388, 1396,

			 1611,  716, 1282, 1283,  617, 1195, 1407, 1415, 1611, 1423,
			 1461,  541,  537,  527, 1212, 1284,  419, 1433,  453,  367,
			 1437, 1499,  374,  267,  266,  254,  201,  201,  177,  186,
			  111,  115,  113,   95, 1611,   51,   57, 1611, 1611, 1538,
			 1547, 1556, 1565, 1440, 1574, 1583, 1448, 1592, 1601, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  538,    1,  539,  539,  540,  540,  541,  541,  538,
			  538,  538,  538,  542,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  544,  538,  538,  545,  538,  538,  546,  538,  538,  538,
			  538,  542,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  547,  548,  538,
			  538,  538,  538,  538,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,

			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  544,  545,  546,  538,  538,  538,
			  538,  538,  538,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  538,  538,  538,  538,  543,  543,  543,  543,  543,  543,
			  543,  538,  538,  538,  543,  543,  543,  543,  543,  543,

			  543,  543,  543,  538,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  538,  538,  538,  538,  538,  538,  543,  538,  543,
			  543,  543,  543,  543,  543,  543,  543,  543,  543,  538,
			  538,  538,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  538,  538,  538,  543,  543,  543,  538,  538,
			  543,  543,  543,  543,  543,  543,  543,  543,  538,  538,
			  538,  538,  538,  538,  543,  543,  543,  538,  543,  543,
			  538,  538,  538,  538,  543,  543,  543,  543,  543,  538,

			  538,  538,  543,  543,  543,  543,  543,  543,  538,  538,
			  538,  543,  543,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  538,  538,  538,  538,  543,
			  538,  538,  538,  538,  543,  543,  538,  538,  538,  543,
			  543,  543,  543,  543,  543,  538,  538,  538,  543,  543,
			  543,  538,  538,  538,  543,  543,  538,  543,  543,  543,
			  538,  538,  538,  543,  543,  543,  543,  543,  543,  543,
			  543,  543,  543,  538,  543,  543,  543,  538,  538,  538,
			  543,  543,  538,  538,  538,  538,  538,  538,  543,  543,
			  538,  538,  538,  538,  538,  538,  538,  543,  543,  543,

			  543,  543,  543,  543,  543,  543,  538,  538,  538,  538,
			  538,  538,  538,  543,  538,  538,  538,  543,  543,  543,
			  543,  543,  538,  538,  538,  543,  543,  538,  543,  543,
			  543,  543,  543,  538,  538,  538,  543,  543,  543,  543,
			  543,  543,  543,  543,  543,  543,  538,  543,  543,  543,
			  543,  538,  538,  538,  538,  538,  538,  538,  543,  543,
			  543,  543,  543,  543,  543,  543,  543,  538,  538,  538,
			  543,  538,  538,  538,  543,  543,  543,  543,  543,  543,
			  538,  538,  538,  543,  543,  543,  538,  543,  538,  538,
			  538,  543,  543,  543,  538,  538,  538,  543,  538,  538,

			  538,  543,  543,  543,  543,  543,  538,  538,  538,  538,
			  538,  543,  543,  543,  543,  543,  538,  543,  543,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,    0,  538,
			  538,  538,  538,  538,  538,  538,  538,  538,  538, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    1,    6,    7,    1,    1,    1,    8,
			    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
			   19,   19,   19,   19,   19,   19,   19,   19,   20,    1,
			   21,   22,   23,    1,    1,   24,   25,   26,   27,   28,
			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
			   33,    1,    1,    1,    1,    1,   49,   24,   25,   26,

			   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
			   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
			   47,   48,   33,   50,    1,   51,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    2,    3,    1,    1,    4,    1,
			    1,    1,    1,    1,    1,    1,    1,    3,    5,    6,
			    1,    1,    1,    1,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    3,    3,    3,    3,    7,    8,    1,
			    1,    9, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    6,    6,   10,   10,  144,
			  142,    1,    1,  142,    4,   37,   38,   25,   24,   35,
			   23,   31,   26,  138,   36,   29,   27,   28,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  142,    9,  143,    6,    8,    7,   10,   11,   12,   13,
			    1,    0,  137,   14,   15,   16,   17,   18,   19,   20,
			   21,   22,    5,  138,   32,    0,    0,    3,    2,    0,
			   34,   30,   33,    0,  135,  135,  135,  135,   42,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,

			  135,  135,  135,  135,  135,   62,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,   78,  135,
			   80,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,    0,    6,   10,    0,    0,    3,
			    2,  139,  135,  135,  135,   39,   41,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,   57,  135,  135,  135,   61,  135,
			    0,    0,    0,    0,  135,  135,  135,  135,  135,  135,
			   69,    0,    0,  120,  135,   71,   72,  135,  135,   74,

			   75,  135,  135,    0,   82,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
			  135,  136,    0,  141,    0,    0,  115,  135,    0,  135,
			  135,  135,   44,  135,   46,  135,  135,  135,  135,    0,
			    0,  123,  135,  135,  135,  135,  135,  135,  135,   54,
			   55,  135,    0,    0,  119,  135,  135,  135,  134,   63,
			  135,   65,  135,  135,  135,  135,  135,  135,    0,    0,
			  116,    0,    0,  117,  135,  135,  135,    0,   77,  135,
			   81,    0,    0,  114,  135,  135,  135,  135,  135,    0,

			    0,  122,  135,   88,  135,  135,  135,  135,    0,    0,
			  124,  135,   90,  135,  135,  135,   93,   94,  135,  135,
			  135,  135,  135,   98,  135,    0,    0,    0,  126,  135,
			   40,    0,    0,  125,  135,  135,    0,    0,  127,  135,
			  135,   47,  135,  135,  135,    0,    0,  129,   50,  135,
			  135,    0,    0,  107,  135,  135,    0,  135,  135,   60,
			    0,    0,  101,   64,   66,  135,  135,  135,  135,  135,
			  135,  135,  135,   76,  135,  135,   84,    0,    0,  105,
			  135,  135,    0,    0,  128,    0,    0,  118,  135,  135,
			    0,    0,  102,    0,    0,  130,    0,  135,   92,  135,

			  135,  135,   97,  135,   99,  135,    0,    0,    0,  132,
			    0,    0,  131,   43,    0,    0,  133,  135,  135,  135,
			  135,  135,    0,    0,  103,  135,   53,   56,  135,   59,
			   67,  135,  135,    0,    0,  121,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,   91,  135,  135,   95,
			   96,    0,    0,  113,    0,    0,  112,    0,   45,  135,
			  135,  135,  135,   52,   58,  135,  135,    0,    0,  108,
			  135,    0,    0,  109,  135,   73,  135,  135,  135,  135,
			    0,    0,  106,  135,  135,  135,  140,  135,    0,    0,
			  100,   49,   51,   68,    0,    0,  104,  135,    0,    0,

			  110,   79,  135,  135,   87,  135,    0,    0,  111,    0,
			    0,   48,   70,   83,  135,  135,    0,  135,   89,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,   86,    0,    0,   85,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 1611
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 538
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 539
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 143
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 144
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	comment: INTEGER is 1
	comment_sql: INTEGER is 2
	cond_literal_sql: INTEGER is 3
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make_with_file (a_file: KI_CHARACTER_INPUT_STREAM) is
		local
			state: XPLAIN_SCANNER_STATE
		do
			do_make
			make_compressed_scanner_skeleton_with_file (a_file)
			create state.make_file (input_buffer, a_file.name)
			saved_state.put_last (state)
		ensure
			has_state: not saved_state.is_empty
		end

	make_with_stdin is
		local
			state: XPLAIN_SCANNER_STATE
		do
			do_make
			create state.make_stdin (input_buffer)
			saved_state.put_last (state)
		ensure
			has_state: not saved_state.is_empty
		end


feature {NONE} -- Initialization

	do_make is
			-- Create a new Xplain scanner.
		do
			make_compressed_scanner_skeleton
			create saved_state.make
		end

	execute is
			-- Analyze files `arguments (1..argument_count)'.
		local
			j, n: INTEGER
			a_filename: STRING
			a_file: KL_TEXT_INPUT_FILE
		do
			make_compressed_scanner_skeleton
			n := Arguments.argument_count
			if n = 0 then
				std.error.put_string ("usage: xplain_scanner filename ...%N")
				Exceptions.die (1)
			else
				from j := 1 until j > n loop
					a_filename := Arguments.argument (j)
					create a_file.make (a_filename)
					a_file.open_read
					if a_file.is_open_read then
						set_input_buffer (new_file_buffer (a_file))
						scan
						a_file.close
					else
						std.error.put_string ("xplain_scanner: cannot read %'")
						std.error.put_string (a_filename)
						std.error.put_string ("%'%N")
					end
					j := j + 1
				end
			end
		end


feature -- Scanning specials

	expect_domain: BOOLEAN
			-- internal state to see a (A or (V only as domain when needed.

	conditional_parse_domain (token: INTEGER) is
			-- call when scanner thinks domain is being parsed
		do
			if expect_domain then
				read_character
				inspect
					last_character
				when '0'..'9',')' then
				  less (2) -- back character just read
				  last_token := token
				else
					less (1) -- no domain, eat up only '('
					last_token := Left_parenthesis_code
				end
				expect_domain := False
			else
				less (1) -- no domain, eat up only '('
				last_token := Left_parenthesis_code
			end
		end


feature -- Error handling

	report_error (a_message: STRING) is
			-- Print error message.
		local
		  state: XPLAIN_SCANNER_STATE
		do
			if saved_state.is_empty then
				std.error.put_string (a_message)
			else
				state := saved_state.last
				if state.filename /= Void then
					std.error.put_string (state.filename)
					std.error.put_string (", line ")
				else
					std.error.put_string ("line ")
				end
				std.error.put_integer (line)
				std.error.put_string (", column ")
				std.error.put_integer (column)
				std.error.put_string (": ")
				std.error.put_string (a_message)
			end
			std.error.put_character ('%N')
		end

	report_warning (a_message: STRING) is
			-- Print error message.
		local
		  state: XPLAIN_SCANNER_STATE
		do
			std.error.put_string ("Warning: ")
			if saved_state.is_empty then
				std.error.put_string (a_message)
			else
				state := saved_state.last
				if state.filename /= Void then
					std.error.put_string (state.filename)
					std.error.put_string (", line ")
				else
					std.error.put_string ("line ")
				end
				std.error.put_integer (line)
				std.error.put_string (", column ")
				std.error.put_integer (column)
				std.error.put_string (": ")
				std.error.put_string (a_message)
			end
			std.error.put_character ('%N')
		end


feature -- dirty, should be implemented by parser

	pending_init: XPLAIN_TYPE
			-- set if for a type inits need to be processed

	write_pending_statement is
		do
			-- ignore
		end


feature -- Outside

	sqlgenerator: SQL_GENERATOR

	set_sqlgenerator (sqlg: SQL_GENERATOR) is
		do
			sqlgenerator := sqlg
		end


feature {NONE} -- .include/.use support

	saved_state: DS_LINKED_LIST [XPLAIN_SCANNER_STATE]

	make_relative_path (name: STRING): STRING is
			-- `name' if an absolute path, else `name' relative from
			-- currently parsed filename
		require
			name_not_empty: name /= Void and then not name.is_empty
		local
			current_dir: STRING
		do
			current_dir := saved_state.last.directory
			if current_dir = Void then
				Result := name
			else
				if name.item (1) = '/' then
					Result := name
				else
					Result := current_dir + name
				end
			end
		end

	use_mode: BOOLEAN is
			-- We're in use mode if there is a single .use mode on the
			-- stack.
		local
			c: DS_BILINEAR_CURSOR [XPLAIN_SCANNER_STATE]
		do
			c := saved_state.new_cursor
			from
				c.finish
			until
				Result or else
				c.before
			loop
				Result := c.item.use_mode
				c.back
			end
		end

	wrap: BOOLEAN is
			-- Should we continue at EOF?
			-- We do, unless no more state.
		do
			write_pending_statement
			saved_state.remove_last
			if saved_state.is_empty then
				Result := True
			else
				set_input_buffer (saved_state.last.input_buffer)
			end
		ensure then
			definition: Result implies not old saved_state.is_empty
		end

	procedure_mode: BOOLEAN
			-- Set when creating a stored procedure to delay output of code.

	immediate_output_mode: BOOLEAN is
			-- True if output should be generated immediately. Until full
			-- AST building is in place, we need this trick.
		do
			Result := not use_mode and then not procedure_mode
		end


feature {NONE} -- Implementation

	my_sql: STRING

	unquote_string (s: STRING): STRING is
			-- Make sure a quoted double quote in `s' is unquoted.
		require
			s_not_void: s /= Void
		local
			i: INTEGER
		do
			Result := s.twin
			if not Result.is_empty then
				from
					i := 1
				invariant
					Result.count >= 1
				variant
					Result.count - (i - 1)
				until
					i >= Result.count
				loop
					if
						Result.item (i) = '%"' and then
						Result.item (i + 1) = '%"'
					then
						Result.remove (i)
					end
					i := i + 1
				end
			end
		ensure
			unquote_string_not_void: Result /= Void
			unquote_string_not_empty: not s.is_empty implies not Result.is_empty
		end


feature {NONE} -- Preprocessor commands

	preprocessor_include is
		local
			include_name: STRING
			included_file: KL_TEXT_INPUT_FILE
			state: XPLAIN_SCANNER_STATE
		do
			read_token
			if last_token = XPLAIN_STRING then
				include_name := make_relative_path (last_string_value)
				create included_file.make (include_name)
				included_file.open_read
				if included_file.is_open_read then
					set_input_buffer (new_file_buffer (included_file))
					create state.make_include (input_buffer, include_name)
					saved_state.put_last (state)
				else
					report_error (format ("Included file $s skipped, because it could not be opened.", <<include_name>>))
				end
			else
				report_error ("filename, surrounded by double quotes, expected after .include.")
			end
			read_token
		end

	preprocessor_use is
		local
			use_name: STRING
			use_file: KL_TEXT_INPUT_FILE
			state: XPLAIN_SCANNER_STATE
		do
			read_token
			if last_token = XPLAIN_STRING then
				use_name := make_relative_path (last_string_value)
				create use_file.make (use_name)
				use_file.open_read
				if use_file.is_open_read then
					set_input_buffer (new_file_buffer (use_file))
					create state.make_use (input_buffer, use_name)
					saved_state.put_last (state)
				else
					report_error (format ("Used file $s skipped, because it could not be opened.", <<use_name>>))
				end
			else
				report_error ("string expected after .use")
			end
			read_token
		end


invariant

	has_state: last_token /= 0 implies not saved_state.is_empty

end
