indexing

	description: "Describes a single Xplain statement like type, get or insert."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2002, Berend de Boer"
	date:       "$Date: 2007/01/22 $"
	revision:   "$Revision: #3 $"


deferred class

	XPLAIN_STATEMENT


feature -- Generate output

	write (a_generator: ABSTRACT_GENERATOR) is
			-- Write output according to this generator.
		require
			generator_not_void: a_generator /= Void
		deferred
		end


feature -- Cleanup

	cleanup is
			-- When statement is used in procedure, values and extends
			-- are temporal and should be removed from the universe.
			-- Override in descendents to do the proper cleanup.
		do
			-- Nothing
		end


feature --  Warnings

	uses_parameter (a_parameter: XPLAIN_ATTRIBUTE_NAME): BOOLEAN is
			-- Is parameter `a_parameter' used by this statement?
		require
			parameter_not_void: a_parameter /= Void
		deferred
		end


end
