indexing

	description:

		"XPLain parser%
		%%
		%Parser derived from Xplain 5.8 manual%
		%(not yet complete, but we're getting there)%
		%%
		%Standard Xplain deviations:%
		%1. Supports additional representations for memo fields, %
		%   picture fields, .... %
		%2. Date field includes time.%
		%3. Supports renaming columns by using the `as' keyword."

	known_bugs:
	"3. Error reporting can be improved.%
	%4. No cascade support.%
	%5. Certain types of expressions are not always allowed, this is %
	%   not checked (use of values or constants for example).%
	%   A constant expression also accepts values if previously defined. %
	%   Should only accept constants.%
	%7. check constraint is not supported.%
	%9. purging inits is not yet supported.%
	%10. input is not supported.%
	%11. case keyword in inheritance not supported.%
	%12. It seems we're more strict in ordering of types than Xplain.%
	%    Generally, a type should exist, before you can use it as an %
	%    attribute.%
	%13. 'its' list parsing not strict enough. Accepts some times an %
	%    attribute that is not correct. Probably dumps core later...%
	%15. names are case-sensitive, but should not be.%
	%16. No newline keyword support (parse as string??).%
	%17. Extend with explicitly given domain not supported.%
	%18. Doesn't check if a column used as boolean is really a boolean.%
	%    So 'get person where name' is ok.%
	%19. When there is an init for an attribute, no value is allowed %
	%    in insert. This is not checked although the input is overwritten.%
	%21. Don't put comments between a type and an init (default), else%
	%    the init (defaults) are silently ignored (2005-12-01: works slightly better now).%
	%23. update allows update a * its attr = 1, shouldn't allow *."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 1999-2007 Berend de Boer, see forum.txt"
	date:       "$Date: 2008/07/26 $"
	revision:   "$Revision: #15 $"


class

	XPLAIN_PARSER


inherit

	YY_PARSER_SKELETON
		rename
			make as make_parser_skeleton
		undefine
			report_error
		end

	XPLAIN_SCANNER
		rename
			make_with_file as make_scanner_with_file,
			make_with_stdin as make_scanner_with_stdin
		redefine
			write_pending_statement
		end

	XPLAIN_UNIVERSE_ACCESSOR
		export
			{NONE} all
		end


create

	make_with_file,
	make_with_stdin



feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks is
			-- Create value stacks.
		do
		end

	yy_init_value_stacks is
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
			yyvsp8 := -1
			yyvsp9 := -1
			yyvsp10 := -1
			yyvsp11 := -1
			yyvsp12 := -1
			yyvsp13 := -1
			yyvsp14 := -1
			yyvsp15 := -1
			yyvsp16 := -1
			yyvsp17 := -1
			yyvsp18 := -1
			yyvsp19 := -1
			yyvsp20 := -1
			yyvsp21 := -1
			yyvsp22 := -1
			yyvsp23 := -1
			yyvsp24 := -1
			yyvsp25 := -1
			yyvsp26 := -1
			yyvsp27 := -1
			yyvsp28 := -1
			yyvsp29 := -1
			yyvsp30 := -1
			yyvsp31 := -1
			yyvsp32 := -1
			yyvsp33 := -1
			yyvsp34 := -1
			yyvsp35 := -1
			yyvsp36 := -1
			yyvsp37 := -1
			yyvsp38 := -1
			yyvsp39 := -1
			yyvsp40 := -1
			yyvsp41 := -1
			yyvsp42 := -1
			yyvsp43 := -1
			yyvsp44 := -1
			yyvsp45 := -1
			yyvsp46 := -1
		end

	yy_clear_value_stacks is
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			if yyvs1 /= Void then
				yyvs1.clear_all
			end
			if yyvs2 /= Void then
				yyvs2.clear_all
			end
			if yyvs3 /= Void then
				yyvs3.clear_all
			end
			if yyvs4 /= Void then
				yyvs4.clear_all
			end
			if yyvs5 /= Void then
				yyvs5.clear_all
			end
			if yyvs6 /= Void then
				yyvs6.clear_all
			end
			if yyvs7 /= Void then
				yyvs7.clear_all
			end
			if yyvs8 /= Void then
				yyvs8.clear_all
			end
			if yyvs9 /= Void then
				yyvs9.clear_all
			end
			if yyvs10 /= Void then
				yyvs10.clear_all
			end
			if yyvs11 /= Void then
				yyvs11.clear_all
			end
			if yyvs12 /= Void then
				yyvs12.clear_all
			end
			if yyvs13 /= Void then
				yyvs13.clear_all
			end
			if yyvs14 /= Void then
				yyvs14.clear_all
			end
			if yyvs15 /= Void then
				yyvs15.clear_all
			end
			if yyvs16 /= Void then
				yyvs16.clear_all
			end
			if yyvs17 /= Void then
				yyvs17.clear_all
			end
			if yyvs18 /= Void then
				yyvs18.clear_all
			end
			if yyvs19 /= Void then
				yyvs19.clear_all
			end
			if yyvs20 /= Void then
				yyvs20.clear_all
			end
			if yyvs21 /= Void then
				yyvs21.clear_all
			end
			if yyvs22 /= Void then
				yyvs22.clear_all
			end
			if yyvs23 /= Void then
				yyvs23.clear_all
			end
			if yyvs24 /= Void then
				yyvs24.clear_all
			end
			if yyvs25 /= Void then
				yyvs25.clear_all
			end
			if yyvs26 /= Void then
				yyvs26.clear_all
			end
			if yyvs27 /= Void then
				yyvs27.clear_all
			end
			if yyvs28 /= Void then
				yyvs28.clear_all
			end
			if yyvs29 /= Void then
				yyvs29.clear_all
			end
			if yyvs30 /= Void then
				yyvs30.clear_all
			end
			if yyvs31 /= Void then
				yyvs31.clear_all
			end
			if yyvs32 /= Void then
				yyvs32.clear_all
			end
			if yyvs33 /= Void then
				yyvs33.clear_all
			end
			if yyvs34 /= Void then
				yyvs34.clear_all
			end
			if yyvs35 /= Void then
				yyvs35.clear_all
			end
			if yyvs36 /= Void then
				yyvs36.clear_all
			end
			if yyvs37 /= Void then
				yyvs37.clear_all
			end
			if yyvs38 /= Void then
				yyvs38.clear_all
			end
			if yyvs39 /= Void then
				yyvs39.clear_all
			end
			if yyvs40 /= Void then
				yyvs40.clear_all
			end
			if yyvs41 /= Void then
				yyvs41.clear_all
			end
			if yyvs42 /= Void then
				yyvs42.clear_all
			end
			if yyvs43 /= Void then
				yyvs43.clear_all
			end
			if yyvs44 /= Void then
				yyvs44.clear_all
			end
			if yyvs45 /= Void then
				yyvs45.clear_all
			end
			if yyvs46 /= Void then
				yyvs46.clear_all
			end
		end

	yy_push_last_value (yychar1: INTEGER) is
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					if yyvs1 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs1")
						end
						create yyspecial_routines1
						yyvsc1 := yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.make (yyvsc1)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs1")
						end
						yyvsc1 := yyvsc1 + yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
					end
				end
				yyvs1.put (last_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					if yyvs2 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs2")
						end
						create yyspecial_routines2
						yyvsc2 := yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.make (yyvsc2)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs2")
						end
						yyvsc2 := yyvsc2 + yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
					end
				end
				yyvs2.put (last_string_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					if yyvs3 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs3")
						end
						create yyspecial_routines3
						yyvsc3 := yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.make (yyvsc3)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs3")
						end
						yyvsc3 := yyvsc3 + yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
					end
				end
				yyvs3.put (last_integer_value, yyvsp3)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value is
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				if yyvs1 = Void then
					debug ("GEYACC")
						std.error.put_line ("Create yyvs1")
					end
					create yyspecial_routines1
					yyvsc1 := yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.make (yyvsc1)
				else
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
				end
			end
			yyvs1.put (yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER) is
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			when 8 then
				yyvsp8 := yyvsp8 - 1
			when 9 then
				yyvsp9 := yyvsp9 - 1
			when 10 then
				yyvsp10 := yyvsp10 - 1
			when 11 then
				yyvsp11 := yyvsp11 - 1
			when 12 then
				yyvsp12 := yyvsp12 - 1
			when 13 then
				yyvsp13 := yyvsp13 - 1
			when 14 then
				yyvsp14 := yyvsp14 - 1
			when 15 then
				yyvsp15 := yyvsp15 - 1
			when 16 then
				yyvsp16 := yyvsp16 - 1
			when 17 then
				yyvsp17 := yyvsp17 - 1
			when 18 then
				yyvsp18 := yyvsp18 - 1
			when 19 then
				yyvsp19 := yyvsp19 - 1
			when 20 then
				yyvsp20 := yyvsp20 - 1
			when 21 then
				yyvsp21 := yyvsp21 - 1
			when 22 then
				yyvsp22 := yyvsp22 - 1
			when 23 then
				yyvsp23 := yyvsp23 - 1
			when 24 then
				yyvsp24 := yyvsp24 - 1
			when 25 then
				yyvsp25 := yyvsp25 - 1
			when 26 then
				yyvsp26 := yyvsp26 - 1
			when 27 then
				yyvsp27 := yyvsp27 - 1
			when 28 then
				yyvsp28 := yyvsp28 - 1
			when 29 then
				yyvsp29 := yyvsp29 - 1
			when 30 then
				yyvsp30 := yyvsp30 - 1
			when 31 then
				yyvsp31 := yyvsp31 - 1
			when 32 then
				yyvsp32 := yyvsp32 - 1
			when 33 then
				yyvsp33 := yyvsp33 - 1
			when 34 then
				yyvsp34 := yyvsp34 - 1
			when 35 then
				yyvsp35 := yyvsp35 - 1
			when 36 then
				yyvsp36 := yyvsp36 - 1
			when 37 then
				yyvsp37 := yyvsp37 - 1
			when 38 then
				yyvsp38 := yyvsp38 - 1
			when 39 then
				yyvsp39 := yyvsp39 - 1
			when 40 then
				yyvsp40 := yyvsp40 - 1
			when 41 then
				yyvsp41 := yyvsp41 - 1
			when 42 then
				yyvsp42 := yyvsp42 - 1
			when 43 then
				yyvsp43 := yyvsp43 - 1
			when 44 then
				yyvsp44 := yyvsp44 - 1
			when 45 then
				yyvsp45 := yyvsp45 - 1
			when 46 then
				yyvsp46 := yyvsp46 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval1: ANY
			yyval2: STRING
			yyval33: XPLAIN_STATEMENT
			yyval35: XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT
			yyval4: XPLAIN_BASE
			yyval43: XPLAIN_TYPE_STATEMENT
			yyval34: XPLAIN_CONSTANT_STATEMENT
			yyval5: XPLAIN_DOMAIN_RESTRICTION
			yyval6: XPLAIN_A_NODE
			yyval7: XPLAIN_I_NODE
			yyval8: XPLAIN_LOGICAL_EXPRESSION
			yyval9: XPLAIN_EXPRESSION
			yyval10: XPLAIN_LOGICAL_VALUE_EXPRESSION
			yyval11: XPLAIN_SYSTEM_EXPRESSION
			yyval12: XPLAIN_ATTRIBUTE_NAME_NODE
			yyval13: XPLAIN_ATTRIBUTE_NAME
			yyval14: XPLAIN_TYPE
			yyval15: XPLAIN_REPRESENTATION
			yyval16: XPLAIN_PK_REPRESENTATION
			yyval17: XPLAIN_ATTRIBUTE_NODE
			yyval18: XPLAIN_ATTRIBUTE
			yyval3: INTEGER
			yyval19: XPLAIN_ASSERTION
			yyval20: XPLAIN_ASSIGNMENT_NODE
			yyval21: XPLAIN_ASSIGNMENT
			yyval36: XPLAIN_CASCADE_STATEMENT
			yyval37: XPLAIN_CASCADE_FUNCTION_EXPRESSION
			yyval38: XPLAIN_DELETE_STATEMENT
			yyval22: XPLAIN_SUBJECT
			yyval44: XPLAIN_UPDATE_STATEMENT
			yyval45: XPLAIN_VALUE_STATEMENT
			yyval46: XPLAIN_VALUE_SELECTION_STATEMENT
			yyval23: XPLAIN_SELECTION_FUNCTION
			yyval40: XPLAIN_GET_STATEMENT
			yyval39: XPLAIN_EXTEND_STATEMENT
			yyval24: XPLAIN_EXTENSION
			yyval25: XPLAIN_EXTEND_ATTRIBUTE
			yyval26: XPLAIN_EXTENSION_EXPRESSION
			yyval27: XPLAIN_SELECTION
			yyval28: XPLAIN_SELECTION_LIST
			yyval29: XPLAIN_SORT_NODE
			yyval30: XPLAIN_FUNCTION
			yyval31: XPLAIN_EXPRESSION_NODE
			yyval41: XPLAIN_PROCEDURE_STATEMENT
			yyval32: XPLAIN_STATEMENT_NODE
			yyval42: XPLAIN_SQL_STATEMENT
		do
			inspect yy_act
when 1 then
--|#line 278 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 278")
end

			write_pending_statement
			sqlgenerator.write_end (yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 2 then
--|#line 283 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 283")
end

			report_error ("Additional end detected after parsing the end belonging to the database command.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 3 then
--|#line 288 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 288")
end

			report_error ("Additional input after end of database.: " + text)
			abort
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 4 then
--|#line 293 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 293")
end

			report_error ("Script should start with the 'database' command instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 5 then
--|#line 301 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 301")
end

			sqlgenerator.write_use_database (yyvs2.item (yyvsp2))
			yyval2 := yyvs2.item (yyvsp2)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs2.put (yyval2, yyvsp2)
end
when 6 then
--|#line 309 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 309")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 7 then
--|#line 314 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 314")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 8 then
--|#line 315 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 315")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 9 then
--|#line 319 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 319")
end

			if not use_mode then
				if yyvs33.item (yyvsp33) /= Void then -- because statement support is partial at the moment
					statements.add (yyvs33.item (yyvsp33))
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp33 := yyvsp33 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 10 then
--|#line 327 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 327")
end

statements.add (yyvs42.item (yyvsp42)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp42 := yyvsp42 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 11 then
--|#line 329 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 329")
end

statements.add (yyvs42.item (yyvsp42)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 12 then
--|#line 331 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 331")
end

			if not use_mode then
				if yyvs33.item (yyvsp33) /= Void then -- because statement support is partial at the moment
					statements.add (yyvs33.item (yyvsp33))
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp33 := yyvsp33 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 13 then
--|#line 339 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 339")
end

			if equal (text, "end") then
				report_error ("Unexpected 'end'. '.' missing?")
				abort
			elseif equal (text, "") then
				report_error ("Unexpected end of input. 'end.' missing?")
				abort
			else
				report_error ("Unknown or unexpected command: " + text)
				abort
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 14 then
--|#line 355 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 355")
end

yyval33 := yyvs33.item (yyvsp33) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs33.put (yyval33, yyvsp33)
end
when 15 then
--|#line 357 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 357")
end

yyval33 := yyvs33.item (yyvsp33) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs33.put (yyval33, yyvsp33)
end
when 16 then
--|#line 359 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 359")
end

yyval33 := yyvs41.item (yyvsp41) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp41 := yyvsp41 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 17 then
--|#line 369 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 369")
end

yyval33 := yyvs33.item (yyvsp33) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs33.put (yyval33, yyvsp33)
end
when 18 then
--|#line 371 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 371")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 19 then
--|#line 372 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 372")
end

yyval33 := yyvs35.item (yyvsp35) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp35 := yyvsp35 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 20 then
--|#line 377 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 377")
end

yyval33 := yyvs43.item (yyvsp43) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp43 := yyvsp43 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 21 then
--|#line 379 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 379")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 22 then
--|#line 380 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 380")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 23 then
--|#line 381 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 381")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 24 then
--|#line 382 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 382")
end

yyval33 := yyvs34.item (yyvsp34) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp34 := yyvsp34 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 25 then
--|#line 385 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 385")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp19 := yyvsp19 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 26 then
--|#line 386 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 386")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 27 then
--|#line 388 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 388")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 28 then
--|#line 392 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 392")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 29 then
--|#line 393 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 393")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 30 then
--|#line 397 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 397")
end

write_pending_statement
			myvariable := universe.find_variable(yyvs2.item (yyvsp2))
			if myvariable = Void then
				report_error ("Not a valid variable: " + yyvs2.item (yyvsp2))
				abort
			else
				if not use_mode then
					sqlgenerator.write_constant_assignment (myvariable, yyvs9.item (yyvsp9))
				end
				myvariable.set_value (yyvs9.item (yyvsp9))
			end
			create yyval35.make (myvariable, yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp35 := yyvsp35 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvsp9 := yyvsp9 -1
	if yyvsp35 >= yyvsc35 then
		if yyvs35 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs35")
			end
			create yyspecial_routines35
			yyvsc35 := yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.make (yyvsc35)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs35")
			end
			yyvsc35 := yyvsc35 + yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.resize (yyvs35, yyvsc35)
		end
	end
	yyvs35.put (yyval35, yyvsp35)
end
when 31 then
--|#line 411 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 411")
end

			report_error ("A constant assignment expression should be surrounded by parentheses")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp35 := yyvsp35 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp35 >= yyvsc35 then
		if yyvs35 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs35")
			end
			create yyspecial_routines35
			yyvsc35 := yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.make (yyvsc35)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs35")
			end
			yyvsc35 := yyvsc35 + yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.resize (yyvs35, yyvsc35)
		end
	end
	yyvs35.put (yyval35, yyvsp35)
end
when 32 then
--|#line 421 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 421")
end

		write_pending_statement
		if yyvs15.item (yyvsp15).domain.is_equal ("(B)") then
			create {XPLAIN_B_RESTRICTION} dummyrestriction.make (False)
		else
			create {XPLAIN_REQUIRED} dummyrestriction.make (False)
		end
		yyvs15.item (yyvsp15).set_domain_restriction (sqlgenerator, dummyrestriction)
		create {XPLAIN_BASE} yyval4.make (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15))
		if not use_mode then
			sqlgenerator.write_base(yyval4)
		end
		universe.add(yyval4)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 33 then
--|#line 436 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 436")
end

		write_pending_statement
		if yyvs15.item (yyvsp15).domain.is_equal ("(B)") then
			create {XPLAIN_B_RESTRICTION} dummyrestriction.make (True)
		else
			create {XPLAIN_REQUIRED} dummyrestriction.make (True)
		end
		yyvs15.item (yyvsp15).set_domain_restriction (sqlgenerator, dummyrestriction)
		create {XPLAIN_BASE} yyval4.make (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15))
		if not use_mode then
			sqlgenerator.write_base(yyval4)
		end
		universe.add(yyval4)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 34 then
--|#line 451 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 451")
end

write_pending_statement
		yyvs15.item (yyvsp15).set_domain_restriction (sqlgenerator, yyvs5.item (yyvsp5))
		create {XPLAIN_BASE} yyval4.make (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15))
		if not use_mode then
			sqlgenerator.write_base(yyval4)
		end
		universe.add (yyval4)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp4 := yyvsp4 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp4 >= yyvsc4 then
		if yyvs4 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs4")
			end
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs4")
			end
			yyvsc4 := yyvsc4 + yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
		end
	end
	yyvs4.put (yyval4, yyvsp4)
end
when 35 then
--|#line 463 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 463")
end

			write_pending_statement
			create mytype.make (yyvs2.item (yyvsp2), yyvs16.item (yyvsp16), yyvs17.item (yyvsp17))
			universe.add (mytype)
			pending_type := mytype
			create yyval43.make (mytype)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp43 := yyvsp43 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp16 := yyvsp16 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp43 >= yyvsc43 then
		if yyvs43 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs43")
			end
			create yyspecial_routines43
			yyvsc43 := yyInitial_yyvs_size
			yyvs43 := yyspecial_routines43.make (yyvsc43)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs43")
			end
			yyvsc43 := yyvsc43 + yyInitial_yyvs_size
			yyvs43 := yyspecial_routines43.resize (yyvs43, yyvsc43)
		end
	end
	yyvs43.put (yyval43, yyvsp43)
end
when 36 then
--|#line 474 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 474")
end

			if pending_init /= yyvs14.item (yyvsp14) then
				write_pending_init
			end
			if yyvs14.item (yyvsp14) /= Void then
				pending_init := yyvs14.item (yyvsp14)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp14 := yyvsp14 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 37 then
--|#line 474 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 474")
end

is_init_default := False 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 38 then
--|#line 488 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 488")
end

			if pending_init /= yyvs14.item (yyvsp14) then
				write_pending_init
			end
			if yyvs14.item (yyvsp14) /= Void then
				pending_init := yyvs14.item (yyvsp14)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp14 := yyvsp14 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 39 then
--|#line 488 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 488")
end

is_init_default := True 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 40 then
--|#line 502 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 502")
end

			write_pending_statement
			create {XPLAIN_REQUIRED} dummyrestriction.make (False)
			yyvs15.item (yyvsp15).set_domain_restriction (sqlgenerator, dummyrestriction)
			create myvariable.make (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15))
			if not use_mode then
				sqlgenerator.write_constant (myvariable)
			end
			universe.add(myvariable)
			create yyval34.make (myvariable)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp34 := yyvsp34 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp34 >= yyvsc34 then
		if yyvs34 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs34")
			end
			create yyspecial_routines34
			yyvsc34 := yyInitial_yyvs_size
			yyvs34 := yyspecial_routines34.make (yyvsc34)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs34")
			end
			yyvsc34 := yyvsc34 + yyInitial_yyvs_size
			yyvs34 := yyspecial_routines34.resize (yyvs34, yyvsc34)
		end
	end
	yyvs34.put (yyval34, yyvsp34)
end
when 41 then
--|#line 516 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 516")
end

write_pending_statement
		myobject := get_known_object (yyvs2.item (yyvsp2))
		if myobject /= Void then
			if immediate_output_mode then
				sqlgenerator.write_drop (myobject)
			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 42 then
--|#line 528 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 528")
end

			write_pending_statement
			myattribute := subject_type.find_attribute (yyvs13.item (yyvsp13))
			if myattribute = Void then
				error_unknown_attribute (yyvs2.item (yyvsp2), yyvs13.item (yyvsp13))
			else
				if immediate_output_mode then
					subject_type.write_drop_attribute	(sqlgenerator, myattribute)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp13 := yyvsp13 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 43 then
--|#line 528 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 528")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 44 then
--|#line 541 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 541")
end

report_warning ("Purging of inits is not yet supported.") 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp13 := yyvsp13 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 45 then
--|#line 541 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 541")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 46 then
--|#line 548 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 548")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs5.put (yyval5, yyvsp5)
end
when 47 then
--|#line 550 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 550")
end

create {XPLAIN_A_PATTERN} yyval5.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 48 then
--|#line 552 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 552")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 49 then
--|#line 554 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 554")
end

			report_error ("Domain restriction not supported for this data type or error in domain restriction definition.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 50 then
--|#line 562 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 562")
end

create {XPLAIN_A_ENUMERATION} yyval5.make (yyvs6.item (yyvsp6)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 51 then
--|#line 564 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 564")
end

create {XPLAIN_I_ENUMERATION} yyval5.make (yyvs7.item (yyvsp7)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 52 then
--|#line 569 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 569")
end

create {XPLAIN_A_NODE} yyval6.make (yyvs2.item (yyvsp2), void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 53 then
--|#line 571 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 571")
end

create {XPLAIN_A_NODE} yyval6.make (yyvs2.item (yyvsp2), yyvs6.item (yyvsp6)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs6.put (yyval6, yyvsp6)
end
when 54 then
--|#line 576 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 576")
end

create {XPLAIN_I_NODE} yyval7.make (yyvs3.item (yyvsp3), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp7 := yyvsp7 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 55 then
--|#line 578 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 578")
end

create {XPLAIN_I_NODE} yyval7.make (yyvs3.item (yyvsp3), yyvs7.item (yyvsp7)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs7.put (yyval7, yyvsp7)
end
when 56 then
--|#line 580 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 580")
end

			report_error ("An integer enumeration cannot contain a %"..%". If you want to specify a trajectory, the format should be (I2) (1..*) for example.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp7 := yyvsp7 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 57 then
--|#line 588 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 588")
end

			if yyvs2.item (yyvsp2 - 1).is_integer and then yyvs2.item (yyvsp2).is_integer then
				if yyvs2.item (yyvsp2 - 1).to_integer > yyvs2.item (yyvsp2).to_integer then
					report_error ("Trajectory's lower value " + yyvs2.item (yyvsp2 - 1) + " is more than the upper value " + yyvs2.item (yyvsp2) + ".")
					abort
				end
			end
			create {XPLAIN_TRAJECTORY} yyval5.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 58 then
--|#line 601 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 601")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 59 then
--|#line 603 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 603")
end

			create yyval2.make_filled ('9', last_width)
			yyval2.insert_character ('-', 1)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 60 then
--|#line 611 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 611")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 61 then
--|#line 613 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 613")
end

create yyval2.make_filled ('9', last_width) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 62 then
--|#line 618 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 618")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 63 then
--|#line 622 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 622")
end

yyval2 := "+" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 64 then
--|#line 624 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 624")
end

yyval2 := "-" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 65 then
--|#line 628 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 628")
end

yyval2 := "*" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 66 then
--|#line 630 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 630")
end

yyval2 := "/" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 67 then
--|#line 632 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 632")
end

yyval2 := "%%" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 68 then
--|#line 637 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 637")
end

		  create {XPLAIN_LOGICAL_INFIX_EXPRESSION} dummye.make (yyvs9.item (yyvsp9), once "or", yyvs8.item (yyvsp8))
		  create yyval8.make (dummye)
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs8.put (yyval8, yyvsp8)
end
when 69 then
--|#line 642 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 642")
end

			create yyval8.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp8 := yyvsp8 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp8 >= yyvsc8 then
		if yyvs8 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs8")
			end
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs8")
			end
			yyvsc8 := yyvsc8 + yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.resize (yyvs8, yyvsc8)
		end
	end
	yyvs8.put (yyval8, yyvsp8)
end
when 70 then
--|#line 649 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 649")
end

create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), once "and", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 71 then
--|#line 651 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 651")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 72 then
--|#line 661 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 661")
end

			if subject_type /= Void then
				myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
				if myobject /= Void then
					-- the last object in the tree knows what expression to build here
					dummye := last_object_in_tree.create_expression (yyvs12.item (yyvsp12))
					if dummye.is_logical_expression then
						create {XPLAIN_NOTNOT_EXPRESSION} yyval9.make (dummye)
					else
						yyval9 := dummye
					end
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 73 then
--|#line 679 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 679")
end

			if subject_type /= Void then
				myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
				if myobject /= Void then
					-- the last object in the tree knows what expression to build here
					dummye := last_object_in_tree.create_expression (yyvs12.item (yyvsp12))
					create {XPLAIN_NOT_EXPRESSION} yyval9.make (dummye)
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
			end

		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 74 then
--|#line 694 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 694")
end

			if is_parameter_declared (yyvs13.item (yyvsp13)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13))
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 75 then
--|#line 700 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 700")
end

			if is_parameter_declared (yyvs13.item (yyvsp13)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13))
				create {XPLAIN_NOT_EXPRESSION} yyval9.make (yyval9)
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 76 then
--|#line 707 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 707")
end

create {XPLAIN_EQ_NULL_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 77 then
--|#line 709 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 709")
end

create {XPLAIN_NE_NULL_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 78 then
--|#line 711 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 711")
end

			yyval9 := new_logical_infix_expression (yyvs9.item (yyvsp9 - 1), yyvs2.item (yyvsp2), yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 79 then
--|#line 715 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 715")
end

			dummye := new_logical_infix_expression (yyvs9.item (yyvsp9 - 1), yyvs2.item (yyvsp2), yyvs9.item (yyvsp9))
			create {XPLAIN_NOT_EXPRESSION} yyval9.make (dummye)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 80 then
--|#line 720 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 720")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs8.item (yyvsp8)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 81 then
--|#line 722 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 722")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs8.item (yyvsp8))
		  create {XPLAIN_NOT_EXPRESSION} yyval9.make (yyval9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 82 then
--|#line 725 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 725")
end

yyval9 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 83 then
--|#line 727 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 727")
end

create {XPLAIN_NOT_EXPRESSION} yyval9.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 84 then
--|#line 731 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 731")
end

yyval2 := "<" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 85 then
--|#line 733 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 733")
end

yyval2 := "<=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 86 then
--|#line 735 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 735")
end

yyval2 := ">" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 87 then
--|#line 737 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 737")
end

yyval2 := ">=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 88 then
--|#line 739 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 739")
end

yyval2 := "=" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 89 then
--|#line 741 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 741")
end

yyval2 := "<>" 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 90 then
--|#line 746 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 746")
end

create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (True) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp10 >= yyvsc10 then
		if yyvs10 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs10")
			end
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs10")
			end
			yyvsc10 := yyvsc10 + yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.resize (yyvs10, yyvsc10)
		end
	end
	yyvs10.put (yyval10, yyvsp10)
end
when 91 then
--|#line 748 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 748")
end

create {XPLAIN_LOGICAL_VALUE_EXPRESSION} yyval10.make (False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp10 := yyvsp10 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp10 >= yyvsc10 then
		if yyvs10 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs10")
			end
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs10")
			end
			yyvsc10 := yyvsc10 + yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.resize (yyvs10, yyvsc10)
		end
	end
	yyvs10.put (yyval10, yyvsp10)
end
when 92 then
--|#line 753 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 753")
end

create {XPLAIN_SYSTEMDATE_EXPRESSION} yyval11 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp11 := yyvsp11 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp11 >= yyvsc11 then
		if yyvs11 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs11")
			end
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs11")
			end
			yyvsc11 := yyvsc11 + yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.resize (yyvs11, yyvsc11)
		end
	end
	yyvs11.put (yyval11, yyvsp11)
end
when 93 then
--|#line 755 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 755")
end

create {XPLAIN_LOGINNAME_EXPRESSION}yyval11 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp11 := yyvsp11 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp11 >= yyvsc11 then
		if yyvs11 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs11")
			end
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs11")
			end
			yyvsc11 := yyvsc11 + yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.resize (yyvs11, yyvsc11)
		end
	end
	yyvs11.put (yyval11, yyvsp11)
end
when 94 then
--|#line 760 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 760")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), yyvs2.item (yyvsp2), yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 95 then
--|#line 762 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 762")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 96 then
--|#line 764 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 764")
end

create {XPLAIN_IF_EXPRESSION} yyval9.make (yyvs8.item (yyvsp8), yyvs9.item (yyvsp9 - 1), yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -3
	yyvsp8 := yyvsp8 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 97 then
--|#line 769 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 769")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), yyvs2.item (yyvsp2), yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 98 then
--|#line 771 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 771")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 99 then
--|#line 776 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 776")
end

			-- we have something here that can be an
			-- attribute/extension/value/variable.
			-- let's get the correct object associated with this tree
			if subject_type /= Void then
				myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
				if myobject /= Void then
					-- the last object in the tree knows what expression to build here
					yyval9 := last_object_in_tree.create_expression (yyvs12.item (yyvsp12))
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 100 then
--|#line 792 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 792")
end

			if subject_type /= Void then
				myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
				if myobject /= Void then
					-- the last object in the tree knows what expression to build here
					dummye := last_object_in_tree.create_expression (yyvs12.item (yyvsp12))
					create {XPLAIN_PREFIX_EXPRESSION} yyval9.make ("-", dummye)
				end
			else
				report_error ("type or attribute name not valid here.")
				abort
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 101 then
--|#line 806 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 806")
end

yyval9 := yyvs11.item (yyvsp11) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp11 := yyvsp11 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 102 then
--|#line 810 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 810")
end

			create {XPLAIN_COMBINE_FUNCTION} yyval9.make (yyvs31.item (yyvsp31))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp31 := yyvsp31 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 103 then
--|#line 818 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 818")
end

			create {XPLAIN_DATEF_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 104 then
--|#line 822 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 822")
end

			create {XPLAIN_INTEGER_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 105 then
--|#line 826 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 826")
end

			create {XPLAIN_REAL_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 106 then
--|#line 830 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 830")
end

			create {XPLAIN_STRING_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 107 then
--|#line 838 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 838")
end

create {XPLAIN_ID_FUNCTION} yyval9.make (subject_type) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 108 then
--|#line 841 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 841")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 109 then
--|#line 843 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 843")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9))
		  create {XPLAIN_PREFIX_EXPRESSION} yyval9.make ("-", yyval9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs9.put (yyval9, yyvsp9)
end
when 110 then
--|#line 846 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 846")
end

create {XPLAIN_STRING_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 111 then
--|#line 848 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 848")
end

create {XPLAIN_NUMBER_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 112 then
--|#line 850 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 850")
end

yyval9 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 113 then
--|#line 852 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 852")
end

create {XPLAIN_UNMANAGED_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13).full_name) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 114 then
--|#line 854 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 854")
end

			if is_parameter_declared (yyvs13.item (yyvsp13)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13))
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 115 then
--|#line 862 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 862")
end

			create {XPLAIN_USER_FUNCTION} yyval9.make (yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 116 then
--|#line 866 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 866")
end

			create {XPLAIN_USER_FUNCTION} yyval9.make (yyvs2.item (yyvsp2), yyvs31.item (yyvsp31))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 117 then
--|#line 872 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 872")
end

create {XPLAIN_SQL_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 118 then
--|#line 876 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 876")
end

yyval2 := yyvs3.item (yyvsp3).out 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 119 then
--|#line 878 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 878")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 120 then
--|#line 883 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 883")
end

create yyval12.make (yyvs13.item (yyvsp13), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp12 := yyvsp12 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 121 then
--|#line 885 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 885")
end

create yyval12.make (yyvs13.item (yyvsp13), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	yyvs12.put (yyval12, yyvsp12)
end
when 122 then
--|#line 891 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 891")
end

create yyval13.make (Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 123 then
--|#line 893 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 893")
end

create yyval13.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 124 then
--|#line 898 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 898")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs13.put (yyval13, yyvsp13)
end
when 125 then
--|#line 902 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 902")
end

			myattribute := subject_type.find_attribute (yyvs13.item (yyvsp13))
			if myattribute = Void then
				error_unknown_attribute (yyvs2.item (yyvsp2), yyvs13.item (yyvsp13))
			else
				if myattribute.init /= Void then
					report_warning (format ("Attribute `$s' already has an initialization expression.", <<myattribute.full_name>>))
				end
				if is_init_default then
					myattribute.set_init_default (yyvs9.item (yyvsp9))
				else
					myattribute.set_init (yyvs9.item (yyvsp9))
				end
				yyval14 := subject_type
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp13 := yyvsp13 -1
	yyvsp9 := yyvsp9 -1
	yyvs14.put (yyval14, yyvsp14)
end
when 126 then
--|#line 902 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 902")
end

subject_type := get_known_type (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp14 := yyvsp14 + 1
	if yyvsp14 >= yyvsc14 then
		if yyvs14 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs14")
			end
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs14")
			end
			yyvsc14 := yyvsc14 + yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.resize (yyvs14, yyvsc14)
		end
	end
	yyvs14.put (yyval14, yyvsp14)
end
when 127 then
--|#line 925 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 925")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 128 then
--|#line 927 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 927")
end

yyval9 := yyvs8.item (yyvsp8) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 129 then
--|#line 929 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 929")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs9.put (yyval9, yyvsp9)
end
when 130 then
--|#line 933 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 933")
end

yyval8 := yyvs8.item (yyvsp8) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs8.put (yyval8, yyvsp8)
end
when 131 then
--|#line 938 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 938")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 132 then
--|#line 943 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 943")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 133 then
--|#line 946 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 946")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 134 then
--|#line 947 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 947")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 135 then
--|#line 950 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 950")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp9 := yyvsp9 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 136 then
--|#line 953 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 953")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 137 then
--|#line 954 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 954")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 138 then
--|#line 957 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 957")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp9 := yyvsp9 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 139 then
--|#line 961 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 961")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_A_REPRESENTATION} yyval15.make (last_width)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 140 then
--|#line 966 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 966")
end

create {XPLAIN_B_REPRESENTATION} yyval15 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 141 then
--|#line 968 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 968")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_C_REPRESENTATION} yyval15.make (last_width)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 142 then
--|#line 973 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 973")
end

create {XPLAIN_D_REPRESENTATION} yyval15 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 143 then
--|#line 975 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 975")
end

			last_width := yyvs3.item (yyvsp3)
			create {XPLAIN_I_REPRESENTATION} yyval15.make (yyvs3.item (yyvsp3))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 144 then
--|#line 980 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 980")
end

create {XPLAIN_M_REPRESENTATION} yyval15 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 145 then
--|#line 982 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 982")
end

create {XPLAIN_P_REPRESENTATION} yyval15 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 146 then
--|#line 984 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 984")
end

			last_width := yyvs3.item (yyvsp3 - 1)
			create {XPLAIN_R_REPRESENTATION} yyval15.make (yyvs3.item (yyvsp3 - 1), yyvs3.item (yyvsp3))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp3 := yyvsp3 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 147 then
--|#line 989 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 989")
end

create {XPLAIN_T_REPRESENTATION} yyval15 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 148 then
--|#line 991 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 991")
end

			report_error ("Comma expected in R representation instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 149 then
--|#line 996 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 996")
end

			report_error ("Representation expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp15 := yyvsp15 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp15 >= yyvsc15 then
		if yyvs15 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs15")
			end
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs15")
			end
			yyvsc15 := yyvsc15 + yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.resize (yyvs15, yyvsc15)
		end
	end
	yyvs15.put (yyval15, yyvsp15)
end
when 150 then
--|#line 1004 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1004")
end

			create {XPLAIN_PK_A_REPRESENTATION} yyval16.make (yyvs3.item (yyvsp3))
			create {XPLAIN_A_REFERENCES} dummya.make
			yyval16.set_domain_restriction(sqlgenerator, dummya)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 151 then
--|#line 1010 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1010")
end

			create {XPLAIN_PK_I_REPRESENTATION}yyval16.make (yyvs3.item (yyvsp3))
			create {XPLAIN_I_REFERENCES} dummyi.make
			yyval16.set_domain_restriction(sqlgenerator, dummyi)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 152 then
--|#line 1016 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1016")
end

			report_error ("type identification expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp16 := yyvsp16 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp16 >= yyvsc16 then
		if yyvs16 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs16")
			end
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs16")
			end
			yyvsc16 := yyvsc16 + yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.resize (yyvs16, yyvsc16)
		end
	end
	yyvs16.put (yyval16, yyvsp16)
end
when 153 then
--|#line 1024 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1024")
end

yyval2 := yyvs2.item (yyvsp2); current_type_name := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 154 then
--|#line 1028 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1028")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 155 then
--|#line 1032 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1032")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 156 then
--|#line 1036 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1036")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 157 then
--|#line 1040 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1040")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 158 then
--|#line 1045 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1045")
end

create {XPLAIN_ATTRIBUTE_NODE} yyval17.make (yyvs18.item (yyvsp18), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp17 := yyvsp17 + 1
	yyvsp18 := yyvsp18 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 159 then
--|#line 1047 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1047")
end

create {XPLAIN_ATTRIBUTE_NODE} yyval17.make (yyvs18.item (yyvsp18), yyvs17.item (yyvsp17)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp18 := yyvsp18 -1
	yyvsp1 := yyvsp1 -1
	yyvs17.put (yyval17, yyvsp17)
end
when 160 then
--|#line 1049 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1049")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp17 := yyvsp17 + 1
	yyvsp18 := yyvsp18 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp17 >= yyvsc17 then
		if yyvs17 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs17")
			end
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs17")
			end
			yyvsc17 := yyvsc17 + yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.resize (yyvs17, yyvsc17)
		end
	end
	yyvs17.put (yyval17, yyvsp17)
end
when 161 then
--|#line 1056 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1056")
end

create {XPLAIN_ATTRIBUTE} yyval18.make (
			yyvs13.item (yyvsp13).role, yyvs13.item (yyvsp13).abstracttype_if_known,
			True, sqlgenerator.check_if_required (yyvs13.item (yyvsp13).abstracttype_if_known),
			True, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp13 := yyvsp13 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 162 then
--|#line 1061 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1061")
end

create {XPLAIN_ATTRIBUTE} yyval18.make (
			yyvs13.item (yyvsp13).role, yyvs13.item (yyvsp13).abstracttype_if_known,
			True, sqlgenerator.check_if_required (yyvs13.item (yyvsp13).abstracttype_if_known),
			False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp18 := yyvsp18 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 163 then
--|#line 1066 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1066")
end

create {XPLAIN_ATTRIBUTE} yyval18.make (
			yyvs13.item (yyvsp13).role, yyvs13.item (yyvsp13).abstracttype_if_known,
		True, False, False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 164 then
--|#line 1070 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1070")
end

create {XPLAIN_ATTRIBUTE} yyval18.make (
			yyvs13.item (yyvsp13).role, yyvs13.item (yyvsp13).abstracttype_if_known,
			True, True, False, False) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 165 then
--|#line 1074 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1074")
end

create {XPLAIN_ATTRIBUTE} yyval18.make (
		yyvs13.item (yyvsp13).role, yyvs13.item (yyvsp13).abstracttype_if_known,
		True, True, False, True) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp18 := yyvsp18 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp18 >= yyvsc18 then
		if yyvs18 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs18")
			end
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs18")
			end
			yyvsc18 := yyvsc18 + yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.resize (yyvs18, yyvsc18)
		end
	end
	yyvs18.put (yyval18, yyvsp18)
end
when 166 then
--|#line 1082 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1082")
end

		myabstracttype := get_known_base_or_type (yyvs2.item (yyvsp2))
		create yyval13.make (Void, yyvs2.item (yyvsp2))
		if myabstracttype /= Void then
			-- when self reference, it is valid to be Void
			yyval13.set_object (myabstracttype)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 167 then
--|#line 1091 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1091")
end

		myabstracttype := get_known_base_or_type (yyvs2.item (yyvsp2))
		create yyval13.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		if myabstracttype /= Void then
			-- when self reference, it is valid to be Void
			yyval13.set_object (myabstracttype)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 168 then
--|#line 1103 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1103")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 169 then
--|#line 1105 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1105")
end

yyval2  := yyvs2.item (yyvsp2 - 1) + " " + yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 170 then
--|#line 1109 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1109")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 171 then
--|#line 1113 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1113")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 172 then
--|#line 1120 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1120")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 173 then
--|#line 1128 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1128")
end

yyval9 := yyvs8.item (yyvsp8) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 174 then
--|#line 1133 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1133")
end

			dummyl ?= yyvs9.item (yyvsp9)
			if dummyl = Void then
				create yyval8.make (yyvs9.item (yyvsp9))
			else
				yyval8 := dummyl
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp8 := yyvsp8 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp8 >= yyvsc8 then
		if yyvs8 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs8")
			end
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs8")
			end
			yyvsc8 := yyvsc8 + yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.resize (yyvs8, yyvsc8)
		end
	end
	yyvs8.put (yyval8, yyvsp8)
end
when 175 then
--|#line 1142 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1142")
end

			create {XPLAIN_LOGICAL_INFIX_EXPRESSION} dummye.make (yyvs9.item (yyvsp9), "or", yyvs8.item (yyvsp8))
			create yyval8.make (dummye)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs8.put (yyval8, yyvsp8)
end
when 176 then
--|#line 1150 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1150")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 177 then
--|#line 1152 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1152")
end

create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), "and", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 178 then
--|#line 1157 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1157")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs8.item (yyvsp8)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 179 then
--|#line 1159 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1159")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs8.item (yyvsp8))
		  create {XPLAIN_NOT_EXPRESSION} yyval9.make (yyval9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 180 then
--|#line 1162 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1162")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 181 then
--|#line 1164 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1164")
end

		-- @@BdB: This seems tricky: I shouldn't be able to assign a
		-- variable to a constant. And it looks like that isn't
		-- forbidden in the following code:
		myvariable := universe.find_variable (yyvs2.item (yyvsp2))
		if myvariable = Void then
			-- not a variable, maybe a value?
			-- depends on context, not checked now
			myvalue := universe.find_value (yyvs2.item (yyvsp2))
			if myvalue = Void then
				report_error ("Not a known variable: " + yyvs2.item (yyvsp2))
				abort
			else
				create {XPLAIN_VALUE_EXPRESSION} dummye.make (myvalue)
				create {XPLAIN_NOT_EXPRESSION} yyval9.make (dummye)
			end
		else
			create {XPLAIN_VARIABLE_EXPRESSION} dummye.make (myvariable)
			create {XPLAIN_NOT_EXPRESSION} yyval9.make (dummye)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 182 then
--|#line 1186 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1186")
end

create {XPLAIN_STRING_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 183 then
--|#line 1188 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1188")
end

yyval9 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 184 then
--|#line 1190 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1190")
end

create {XPLAIN_NOT_EXPRESSION} yyval9.make (yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 185 then
--|#line 1192 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1192")
end

			create {XPLAIN_LOGICAL_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), yyvs2.item (yyvsp2), yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 186 then
--|#line 1201 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1201")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), "+", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 187 then
--|#line 1203 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1203")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), "-", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 188 then
--|#line 1205 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1205")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 189 then
--|#line 1210 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1210")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), "*", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 190 then
--|#line 1212 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1212")
end

create {XPLAIN_INFIX_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9 - 1), "/", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 -1
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 191 then
--|#line 1214 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1214")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 192 then
--|#line 1219 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1219")
end

create {XPLAIN_PARENTHESIS_EXPRESSION} yyval9.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 193 then
--|#line 1221 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1221")
end

create {XPLAIN_NUMBER_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 194 then
--|#line 1223 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1223")
end

create {XPLAIN_PREFIX_EXPRESSION} yyval9.make ("-", yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 195 then
--|#line 1225 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1225")
end

myvariable := universe.find_variable (yyvs2.item (yyvsp2))
		if myvariable = Void then
			-- not a variable, maybe a value?
			-- depends on context, not checked now
			myvalue := universe.find_value (yyvs2.item (yyvsp2))
			if myvalue = Void then
				report_error ("Not a known variable: " + yyvs2.item (yyvsp2))
				abort
			else
				create {XPLAIN_VALUE_EXPRESSION} yyval9.make (myvalue)
			end
		else
			create {XPLAIN_VARIABLE_EXPRESSION} yyval9.make (myvariable)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 196 then
--|#line 1249 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1249")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp5 := yyvsp5 + 1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 197 then
--|#line 1250 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1250")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 198 then
--|#line 1253 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1253")
end

		create {XPLAIN_ASSERTION} yyval19.make (sqlgenerator, extend_type, yyvs2.item (yyvsp2), yyvs5.item (yyvsp5), yyvs26.item (yyvsp26))
		if immediate_output_mode and then
			(yyval19.is_function or else yyval19.is_complex or else not sqlgenerator.CalculatedColumnsSupported) then
			write_pending_statement
			sqlgenerator.write_assertion (yyval19)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -1
	yyvsp26 := yyvsp26 -1
	yyvs19.put (yyval19, yyvsp19)
end
when 199 then
--|#line 1253 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1253")
end

		extend_type := get_known_type (yyvs2.item (yyvsp2))
		subject_type := extend_type            -- in case of expression extension
		last_width := 1 -- hack, incorrect restriction for assert, must base * on max width of expression
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp19 := yyvsp19 + 1
	if yyvsp19 >= yyvsc19 then
		if yyvs19 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs19")
			end
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs19")
			end
			yyvsc19 := yyvsc19 + yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.resize (yyvs19, yyvsc19)
		end
	end
	yyvs19.put (yyval19, yyvsp19)
end
when 200 then
--|#line 1268 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1268")
end

		report_warning ("Virtual value assertion not yet supported. No code will be generated.")
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp19 := yyvsp19 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp5 := yyvsp5 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp19 >= yyvsc19 then
		if yyvs19 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs19")
			end
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs19")
			end
			yyvsc19 := yyvsc19 + yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.resize (yyvs19, yyvsc19)
		end
	end
	yyvs19.put (yyval19, yyvsp19)
end
when 201 then
--|#line 1274 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1274")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 202 then
--|#line 1278 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1278")
end

yyval1 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 203 then
--|#line 1282 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1282")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 204 then
--|#line 1286 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1286")
end

		create myindex.make (subject_type, yyvs2.item (yyvsp2), False, False, yyvs12.item (yyvsp12))
		if not use_mode then
			sqlgenerator.write_index (myindex)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 205 then
--|#line 1286 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1286")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 206 then
--|#line 1298 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1298")
end

		create myindex.make (subject_type, yyvs2.item (yyvsp2), True, False, yyvs12.item (yyvsp12))
		if not use_mode then
			sqlgenerator.write_index (myindex)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 207 then
--|#line 1298 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1298")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 208 then
--|#line 1309 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1309")
end

		create myindex.make (subject_type, yyvs2.item (yyvsp2), False, True, yyvs12.item (yyvsp12))
		if not use_mode then
			sqlgenerator.write_index (myindex)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 209 then
--|#line 1309 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1309")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 210 then
--|#line 1320 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1320")
end

		create myindex.make (subject_type, yyvs2.item (yyvsp2), True, True, yyvs12.item (yyvsp12))
		if not use_mode then
			sqlgenerator.write_index (myindex)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp1 := yyvsp1 -5
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 211 then
--|#line 1320 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1320")
end

write_pending_statement
		subject_type := get_known_type (yyvs2.item (yyvsp2))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 212 then
--|#line 1334 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1334")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp12 := yyvsp12 + 1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 213 then
--|#line 1335 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1335")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs12.put (yyval12, yyvsp12)
end
when 214 then
--|#line 1339 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1339")
end

			myattribute := subject_type.find_attribute (yyvs13.item (yyvsp13))
			if myattribute = Void then
				error_unknown_attribute (subject_type.name, yyvs13.item (yyvsp13))
			else
			  create yyval12.make (yyvs13.item (yyvsp13), Void)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp12 := yyvsp12 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 215 then
--|#line 1348 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1348")
end

			myattribute := subject_type.find_attribute (yyvs13.item (yyvsp13))
			if myattribute = Void then
				error_unknown_attribute (subject_type.name, yyvs13.item (yyvsp13))
			else
				create yyval12.make (yyvs13.item (yyvsp13), yyvs12.item (yyvsp12))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	yyvs12.put (yyval12, yyvsp12)
end
when 216 then
--|#line 1357 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1357")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp12 := yyvsp12 + 1
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 217 then
--|#line 1372 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1372")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 218 then
--|#line 1373 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1373")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 219 then
--|#line 1377 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1377")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 220 then
--|#line 1378 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1378")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp38 := yyvsp38 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 221 then
--|#line 1379 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1379")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp33 := yyvsp33 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 222 then
--|#line 1380 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1380")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 223 then
--|#line 1384 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1384")
end

			write_pending_statement
			mytype := yyvs22.item (yyvsp22).type
			warn_attributes_with_inits (yyvs20.item (yyvsp20))
			if
				yyvs22.item (yyvsp22).identification = Void
			then
				report_error ("Identification expected.")
				abort
			elseif
				mytype.representation.is_integer and then
				not yyvs22.item (yyvsp22).identification.sqlvalue (sqlgenerator).is_integer
			then
				report_error (format ("Primary key %"$s%" is not an integer.", <<yyvs22.item (yyvsp22).identification.sqlvalue (sqlgenerator)>>))
				abort
			else
				create {XPLAIN_INSERT_STATEMENT} yyval33.make (mytype, yyvs22.item (yyvsp22).identification, yyvs20.item (yyvsp20))
				if immediate_output_mode then
					sqlgenerator.write_insert (mytype, yyvs22.item (yyvsp22).identification, yyvs20.item (yyvsp20))
				end
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp22 := yyvsp22 -1
	yyvsp20 := yyvsp20 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 224 then
--|#line 1408 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1408")
end

			write_pending_statement
			mytype := yyvs22.item (yyvsp22).type
			if not sqlgenerator.CreateAutoPrimaryKey
			then
				-- Can't abort as it might be output for a dialect that
				-- doesn't support auto primary keys.
				report_warning ("auto primary key support disabled, but insert with '*' as primary key specified.")
			elseif
				not mytype.representation.is_integer
			then
				report_error ("Auto-primary keys on character instance identification not supported.")
				abort
			end
			create {XPLAIN_INSERT_STATEMENT} yyval33.make (mytype, Void, yyvs20.item (yyvsp20))
			if immediate_output_mode then
				sqlgenerator.write_insert (mytype, Void, yyvs20.item (yyvsp20))
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp22 := yyvsp22 -1
	yyvsp20 := yyvsp20 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 225 then
--|#line 1429 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1429")
end

			report_error ("its expected instead of: '" + text + "'")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp22 := yyvsp22 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 226 then
--|#line 1434 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1434")
end

			write_pending_statement
			mytype := yyvs22.item (yyvsp22).type
			create {XPLAIN_GET_INSERT_STATEMENT} yyval33.make (yyvs28.item (yyvsp28), mytype, False, yyvs12.item (yyvsp12))
			if immediate_output_mode then
				yyval33.write (sqlgenerator)
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp28 := yyvsp28 -1
	yyvsp22 := yyvsp22 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 227 then
--|#line 1444 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1444")
end

			write_pending_statement
			mytype := yyvs22.item (yyvsp22).type
			if not sqlgenerator.CreateAutoPrimaryKey
			then
				-- Can't abort as it might be output for a dialect that
				-- doesn't support auto primary keys.
				report_warning ("auto primary key support disabled, but insert with '*' as primary key specified.")
			elseif
				not mytype.representation.is_integer
			then
				report_error ("Auto-primary keys on character instance identification not supported.")
				abort
			end
			create {XPLAIN_GET_INSERT_STATEMENT} yyval33.make (yyvs28.item (yyvsp28), mytype, True, yyvs12.item (yyvsp12))
			if immediate_output_mode then
				yyval33.write (sqlgenerator)
			end
			subject_type := Void
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp33 := yyvsp33 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp28 := yyvsp28 -1
	yyvsp22 := yyvsp22 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 228 then
--|#line 1468 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1468")
end

create {XPLAIN_ASSIGNMENT_NODE} yyval20.make (yyvs21.item (yyvsp21), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp20 := yyvsp20 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp20 >= yyvsc20 then
		if yyvs20 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs20")
			end
			create yyspecial_routines20
			yyvsc20 := yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.make (yyvsc20)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs20")
			end
			yyvsc20 := yyvsc20 + yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.resize (yyvs20, yyvsc20)
		end
	end
	yyvs20.put (yyval20, yyvsp20)
end
when 229 then
--|#line 1470 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1470")
end

create {XPLAIN_ASSIGNMENT_NODE} yyval20.make (yyvs21.item (yyvsp21), yyvs20.item (yyvsp20)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp21 := yyvsp21 -1
	yyvsp1 := yyvsp1 -1
	yyvs20.put (yyval20, yyvsp20)
end
when 230 then
--|#line 1472 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1472")
end

			report_error ("comma or dot expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp20 := yyvsp20 + 1
	yyvsp21 := yyvsp21 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp20 >= yyvsc20 then
		if yyvs20 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs20")
			end
			create yyspecial_routines20
			yyvsc20 := yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.make (yyvsc20)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs20")
			end
			yyvsc20 := yyvsc20 + yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.resize (yyvs20, yyvsc20)
		end
	end
	yyvs20.put (yyval20, yyvsp20)
end
when 231 then
--|#line 1480 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1480")
end

create {XPLAIN_ASSIGNMENT} yyval21.make (yyvs13.item (yyvsp13), yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp21 := yyvsp21 + 1
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp21 >= yyvsc21 then
		if yyvs21 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs21")
			end
			create yyspecial_routines21
			yyvsc21 := yyInitial_yyvs_size
			yyvs21 := yyspecial_routines21.make (yyvsc21)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs21")
			end
			yyvsc21 := yyvsc21 + yyInitial_yyvs_size
			yyvs21 := yyspecial_routines21.resize (yyvs21, yyvsc21)
		end
	end
	yyvs21.put (yyval21, yyvsp21)
end
when 232 then
--|#line 1485 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1485")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 233 then
--|#line 1487 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1487")
end

yyval9 := yyvs8.item (yyvsp8) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 234 then
--|#line 1492 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1492")
end

			if yyvs37.item (yyvsp37) /= Void then
				subject_type := get_known_type (yyvs2.item (yyvsp2)) -- subject_type changed by cascade_definition I think
				create yyval36.make (sqlgenerator, subject_type, yyvs13.item (yyvsp13), yyvs37.item (yyvsp37))
				if immediate_output_mode then
					yyval36.write (sqlgenerator)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp13 := yyvsp13 -1
	yyvsp37 := yyvsp37 -1
	yyvs36.put (yyval36, yyvsp36)
end
when 235 then
--|#line 1492 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1492")
end

			subject_type := get_known_type (yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		if yyvs36 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs36")
			end
			create yyspecial_routines36
			yyvsc36 := yyInitial_yyvs_size
			yyvs36 := yyspecial_routines36.make (yyvsc36)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs36")
			end
			yyvsc36 := yyvsc36 + yyInitial_yyvs_size
			yyvs36 := yyspecial_routines36.resize (yyvs36, yyvsc36)
		end
	end
	yyvs36.put (yyval36, yyvsp36)
end
when 236 then
--|#line 1514 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1514")
end

			myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
			if myobject /= Void then
				create {XPLAIN_CASCADE_FUNCTION_EXPRESSION} yyval37.make (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp37 := yyvsp37 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp1 := yyvsp1 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp37 >= yyvsc37 then
		if yyvs37 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs37")
			end
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs37")
			end
			yyvsc37 := yyvsc37 + yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.resize (yyvs37, yyvsc37)
		end
	end
	yyvs37.put (yyval37, yyvsp37)
end
when 237 then
--|#line 1521 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1521")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp37 := yyvsp37 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp37 >= yyvsc37 then
		if yyvs37 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs37")
			end
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs37")
			end
			yyvsc37 := yyvsc37 + yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.resize (yyvs37, yyvsc37)
		end
	end
	yyvs37.put (yyval37, yyvsp37)
end
when 238 then
--|#line 1522 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1522")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp37 := yyvsp37 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp37 >= yyvsc37 then
		if yyvs37 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs37")
			end
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs37")
			end
			yyvsc37 := yyvsc37 + yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.resize (yyvs37, yyvsc37)
		end
	end
	yyvs37.put (yyval37, yyvsp37)
end
when 239 then
--|#line 1528 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1528")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs12.put (yyval12, yyvsp12)
end
when 240 then
--|#line 1532 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1532")
end

		write_pending_statement
		if immediate_output_mode then
			sqlgenerator.write_delete (yyvs22.item (yyvsp22), yyvs9.item (yyvsp9))
		end
		subject_type := Void
		create yyval38.make (yyvs22.item (yyvsp22), yyvs9.item (yyvsp9))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp38 := yyvsp38 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp22 := yyvsp22 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp38 >= yyvsc38 then
		if yyvs38 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs38")
			end
			create yyspecial_routines38
			yyvsc38 := yyInitial_yyvs_size
			yyvs38 := yyspecial_routines38.make (yyvsc38)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs38")
			end
			yyvsc38 := yyvsc38 + yyInitial_yyvs_size
			yyvs38 := yyspecial_routines38.resize (yyvs38, yyvsc38)
		end
	end
	yyvs38.put (yyval38, yyvsp38)
end
when 241 then
--|#line 1544 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1544")
end

			subject_type := get_known_type (yyvs2.item (yyvsp2))
			if subject_type = Void then
				report_error ("Type `" + yyvs2.item (yyvsp2) + "' not known.")
				abort
			else
				my_str ?= yyvs9.item (yyvsp9)
				if my_str /= Void and then subject_type.representation.length < my_str.value.count then
					report_error ("Instance identification %"" + my_str.value + "%" does not fit in domain " + subject_type.representation.domain + " of type " + subject_type.name + ".")
					abort
				else
					create {XPLAIN_SUBJECT} yyval22.make (subject_type, yyvs9.item (yyvsp9))
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp22 := yyvsp22 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp22 >= yyvsc22 then
		if yyvs22 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs22")
			end
			create yyspecial_routines22
			yyvsc22 := yyInitial_yyvs_size
			yyvs22 := yyspecial_routines22.make (yyvsc22)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs22")
			end
			yyvsc22 := yyvsc22 + yyInitial_yyvs_size
			yyvs22 := yyspecial_routines22.resize (yyvs22, yyvsc22)
		end
	end
	yyvs22.put (yyval22, yyvsp22)
end
when 242 then
--|#line 1563 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1563")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp9 := yyvsp9 + 1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 243 then
--|#line 1564 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1564")
end

			-- number or string
			if yyvs2.item (yyvsp2).is_integer then
				create {XPLAIN_NUMBER_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2))
			else
				create {XPLAIN_STRING_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 244 then
--|#line 1576 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1576")
end

			if is_parameter_declared (yyvs13.item (yyvsp13)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 245 then
--|#line 1582 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1582")
end

			myvalue := get_known_value (yyvs2.item (yyvsp2))
			if myvalue /= Void then
				create {XPLAIN_VALUE_EXPRESSION} yyval9.make (myvalue)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 246 then
--|#line 1589 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1589")
end

			report_error ("name of a value expected instead of: " + text)
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 247 then
--|#line 1597 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1597")
end

		write_pending_statement
		if immediate_output_mode then
			sqlgenerator.write_update (yyvs22.item (yyvsp22), yyvs20.item (yyvsp20), yyvs9.item (yyvsp9))
		end
		subject_type := Void
		create yyval44.make (yyvs22.item (yyvsp22), yyvs20.item (yyvsp20), yyvs9.item (yyvsp9))
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp22 := yyvsp22 -1
	yyvsp20 := yyvsp20 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp44 >= yyvsc44 then
		if yyvs44 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs44")
			end
			create yyspecial_routines44
			yyvsc44 := yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.make (yyvsc44)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs44")
			end
			yyvsc44 := yyvsc44 + yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.resize (yyvs44, yyvsc44)
		end
	end
	yyvs44.put (yyval44, yyvsp44)
end
when 248 then
--|#line 1606 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1606")
end

report_error ("its expected instead of: '" + text + "'")
		  abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp44 := yyvsp44 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp22 := yyvsp22 -1
	if yyvsp44 >= yyvsc44 then
		if yyvs44 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs44")
			end
			create yyspecial_routines44
			yyvsc44 := yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.make (yyvsc44)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs44")
			end
			yyvsc44 := yyvsc44 + yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.resize (yyvs44, yyvsc44)
		end
	end
	yyvs44.put (yyval44, yyvsp44)
end
when 249 then
--|#line 1611 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1611")
end

		create {XPLAIN_ATTRIBUTE_NAME} yyval13.make (Void, yyvs2.item (yyvsp2))
		myattribute := subject_type.find_attribute (yyval13)
		if myattribute = Void then
			error_unknown_attribute (subject_type.name, yyval13)
		else
			yyval13.set_attribute (myattribute)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 250 then
--|#line 1621 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1621")
end

		create {XPLAIN_ATTRIBUTE_NAME} yyval13.make (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2))
		myattribute := subject_type.find_attribute (yyval13)
		if myattribute = Void then
			error_unknown_attribute (subject_type.name, yyval13)
		else
			yyval13.set_attribute (myattribute)
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp13 >= yyvsc13 then
		if yyvs13 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs13")
			end
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs13")
			end
			yyvsc13 := yyvsc13 + yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.resize (yyvs13, yyvsc13)
		end
	end
	yyvs13.put (yyval13, yyvsp13)
end
when 251 then
--|#line 1633 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1633")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp40 := yyvsp40 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 252 then
--|#line 1634 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1634")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp39 := yyvsp39 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 253 then
--|#line 1635 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1635")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp45 := yyvsp45 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 254 then
--|#line 1636 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1636")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 255 then
--|#line 1638 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1638")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp46 := yyvsp46 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 256 then
--|#line 1642 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1642")
end

			write_pending_statement
			create myvalue.make (sqlgenerator, yyvs2.item (yyvsp2), yyvs9.item (yyvsp9))
			if immediate_output_mode then
				sqlgenerator.write_value (myvalue)
			end
			universe.add (myvalue)
			create yyval45.make (myvalue)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp45 := yyvsp45 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp2 := yyvsp2 -1
	yyvsp9 := yyvsp9 -1
	if yyvsp45 >= yyvsc45 then
		if yyvs45 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs45")
			end
			create yyspecial_routines45
			yyvsc45 := yyInitial_yyvs_size
			yyvs45 := yyspecial_routines45.make (yyvsc45)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs45")
			end
			yyvsc45 := yyvsc45 + yyInitial_yyvs_size
			yyvs45 := yyspecial_routines45.resize (yyvs45, yyvsc45)
		end
	end
	yyvs45.put (yyval45, yyvsp45)
end
when 257 then
--|#line 1655 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1655")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs9.put (yyval9, yyvsp9)
end
when 258 then
--|#line 1657 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1657")
end

create {XPLAIN_SELECTION_EXPRESSION} yyval9.make (yyvs23.item (yyvsp23)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp23 := yyvsp23 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 259 then
--|#line 1659 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1659")
end

			mytype := get_known_type (yyvs2.item (yyvsp2))
			if not sqlgenerator.CreateAutoPrimaryKey then
				report_error ("Auto primary key support disabled or not supported. Cannot retrieve auto-generated primary key.")
			end
			if mytype /= Void then
				create {XPLAIN_LAST_AUTO_PK_EXPRESSION} yyval9.make (mytype)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 260 then
--|#line 1669 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1669")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 261 then
--|#line 1670 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1670")
end

create {XPLAIN_UNMANAGED_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13).full_name) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 262 then
--|#line 1672 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1672")
end

			if is_parameter_declared (yyvs13.item (yyvsp13)) then
				create {XPLAIN_PARAMETER_EXPRESSION} yyval9.make (yyvs13.item (yyvsp13))
			end
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp13 := yyvsp13 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 263 then
--|#line 1680 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1680")
end

			create {XPLAIN_DATEF_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 264 then
--|#line 1684 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1684")
end

			create {XPLAIN_INTEGER_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 265 then
--|#line 1688 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1688")
end

			create {XPLAIN_REAL_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 266 then
--|#line 1692 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1692")
end

			create {XPLAIN_STRING_FUNCTION} yyval9.make (yyvs9.item (yyvsp9))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs9.put (yyval9, yyvsp9)
end
when 267 then
--|#line 1698 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1698")
end

			create {XPLAIN_USER_FUNCTION} yyval9.make (yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 268 then
--|#line 1702 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1702")
end

			create {XPLAIN_USER_FUNCTION} yyval9.make (yyvs2.item (yyvsp2), yyvs31.item (yyvsp31))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 269 then
--|#line 1706 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1706")
end

create {XPLAIN_SQL_EXPRESSION} yyval9.make (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 270 then
--|#line 1711 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1711")
end

			write_pending_statement
			myvalue := get_known_value (yyvs2.item (yyvsp2))
			if myvalue /= Void then
				if immediate_output_mode then
					sqlgenerator.write_select_value (myvalue)
				end
				create yyval46.make (myvalue)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp46 >= yyvsc46 then
		if yyvs46 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs46")
			end
			create yyspecial_routines46
			yyvsc46 := yyInitial_yyvs_size
			yyvs46 := yyspecial_routines46.make (yyvsc46)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs46")
			end
			yyvsc46 := yyvsc46 + yyInitial_yyvs_size
			yyvs46 := yyspecial_routines46.resize (yyvs46, yyvsc46)
		end
	end
	yyvs46.put (yyval46, yyvsp46)
end
when 271 then
--|#line 1725 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1725")
end

			report_error ("Input not yet supported.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp15 := yyvsp15 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 272 then
--|#line 1730 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1730")
end

			report_error ("Input not yet supported.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp15 := yyvsp15 -1
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 273 then
--|#line 1738 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1738")
end

create yyval23.make (yyvs30.item (yyvsp30), yyvs22.item (yyvsp22), yyvs9.item (yyvsp9 - 1), yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp23 := yyvsp23 + 1
	yyvsp30 := yyvsp30 -1
	yyvsp22 := yyvsp22 -1
	yyvsp9 := yyvsp9 -2
	if yyvsp23 >= yyvsc23 then
		if yyvs23 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs23")
			end
			create yyspecial_routines23
			yyvsc23 := yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.make (yyvsc23)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs23")
			end
			yyvsc23 := yyvsc23 + yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.resize (yyvs23, yyvsc23)
		end
	end
	yyvs23.put (yyval23, yyvsp23)
end
when 274 then
--|#line 1744 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1744")
end

		create {XPLAIN_GET_STATEMENT} yyval40.make (yyvs27.item (yyvsp27))
		write_pending_statement
		if immediate_output_mode then
			sqlgenerator.write_select (yyvs27.item (yyvsp27))
		end
		subject_type := Void
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp40 := yyvsp40 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp27 := yyvsp27 -1
	if yyvsp40 >= yyvsc40 then
		if yyvs40 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs40")
			end
			create yyspecial_routines40
			yyvsc40 := yyInitial_yyvs_size
			yyvs40 := yyspecial_routines40.make (yyvsc40)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs40")
			end
			yyvsc40 := yyvsc40 + yyInitial_yyvs_size
			yyvs40 := yyspecial_routines40.resize (yyvs40, yyvsc40)
		end
	end
	yyvs40.put (yyval40, yyvsp40)
end
when 275 then
--|#line 1756 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1756")
end

			if immediate_output_mode then
				sqlgenerator.write_extend (yyvs24.item (yyvsp24))
			end
			subject_type := Void
			create yyval39.make (yyvs24.item (yyvsp24))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp39 := yyvsp39 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp24 := yyvsp24 -1
	if yyvsp39 >= yyvsc39 then
		if yyvs39 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs39")
			end
			create yyspecial_routines39
			yyvsc39 := yyInitial_yyvs_size
			yyvs39 := yyspecial_routines39.make (yyvsc39)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs39")
			end
			yyvsc39 := yyvsc39 + yyInitial_yyvs_size
			yyvs39 := yyspecial_routines39.resize (yyvs39, yyvsc39)
		end
	end
	yyvs39.put (yyval39, yyvsp39)
end
when 276 then
--|#line 1767 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1767")
end

			if extend_type.has_attribute (Void, yyvs25.item (yyvsp25).name) then
				report_error (format ("Cannot extend type `$s' with attribute `$s', because it already has an attribute with that name.", <<yyvs2.item (yyvsp2), yyvs25.item (yyvsp25).name>>))
				abort
			else
				if universe.has (yyvs25.item (yyvsp25).name) then
					report_error (format ("There is already an object (constant, value, base or type) with name `$s'. The name of an extend must be unique to avoid ambiguous expressions.", <<yyvs25.item (yyvsp25).name>>))
					abort
				else
					create yyval24.make (sqlgenerator, extend_type, yyvs25.item (yyvsp25), yyvs26.item (yyvsp26))
					--extend_type.add_extension ($$)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp25 := yyvsp25 -1
	yyvsp26 := yyvsp26 -1
	yyvs24.put (yyval24, yyvsp24)
end
when 277 then
--|#line 1767 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1767")
end

			write_pending_statement
			extend_type := get_known_type (yyvs2.item (yyvsp2))
			subject_type := extend_type -- in case of expression extension
			
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp24 := yyvsp24 + 1
	if yyvsp24 >= yyvsc24 then
		if yyvs24 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs24")
			end
			create yyspecial_routines24
			yyvsc24 := yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.make (yyvsc24)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs24")
			end
			yyvsc24 := yyvsc24 + yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.resize (yyvs24, yyvsc24)
		end
	end
	yyvs24.put (yyval24, yyvsp24)
end
when 278 then
--|#line 1788 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1788")
end

			report_error ("Use with instead of its in the extend expression.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp24 := yyvsp24 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp24 >= yyvsc24 then
		if yyvs24 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs24")
			end
			create yyspecial_routines24
			yyvsc24 := yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.make (yyvsc24)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs24")
			end
			yyvsc24 := yyvsc24 + yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.resize (yyvs24, yyvsc24)
		end
	end
	yyvs24.put (yyval24, yyvsp24)
end
when 279 then
--|#line 1796 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1796")
end

create yyval25.make (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp25 >= yyvsc25 then
		if yyvs25 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs25")
			end
			create yyspecial_routines25
			yyvsc25 := yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.make (yyvsc25)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs25")
			end
			yyvsc25 := yyvsc25 + yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.resize (yyvs25, yyvsc25)
		end
	end
	yyvs25.put (yyval25, yyvsp25)
end
when 280 then
--|#line 1798 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1798")
end

create yyval25.make (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)); yyvs15.item (yyvsp15).set_domain_restriction (sqlgenerator, dummyrestriction) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp25 >= yyvsc25 then
		if yyvs25 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs25")
			end
			create yyspecial_routines25
			yyvsc25 := yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.make (yyvsc25)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs25")
			end
			yyvsc25 := yyvsc25 + yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.resize (yyvs25, yyvsc25)
		end
	end
	yyvs25.put (yyval25, yyvsp25)
end
when 281 then
--|#line 1803 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1803")
end

create {XPLAIN_EXTENSION_EXPRESSION_EXPRESSION} yyval26.make (yyvs9.item (yyvsp9)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp26 := yyvsp26 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp26 >= yyvsc26 then
		if yyvs26 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs26")
			end
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs26")
			end
			yyvsc26 := yyvsc26 + yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.resize (yyvs26, yyvsc26)
		end
	end
	yyvs26.put (yyval26, yyvsp26)
end
when 282 then
--|#line 1805 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1805")
end

create {XPLAIN_EXTENSION_EXPRESSION_EXPRESSION} yyval26.make (yyvs8.item (yyvsp8)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp26 := yyvsp26 + 1
	yyvsp1 := yyvsp1 -2
	yyvsp8 := yyvsp8 -1
	if yyvsp26 >= yyvsc26 then
		if yyvs26 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs26")
			end
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs26")
			end
			yyvsc26 := yyvsc26 + yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.resize (yyvs26, yyvsc26)
		end
	end
	yyvs26.put (yyval26, yyvsp26)
end
when 283 then
--|#line 1807 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1807")
end

-- check per attribute tree for validness
		myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
		if myobject /= Void then
			if yyvs12.item (yyvsp12).last.item.object = extend_type then
				create {XPLAIN_EXTENSION_FUNCTION_EXPRESSION} yyval26.make (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12))
			else
				report_error ("Error in per clause. The given type is `" + yyvs12.item (yyvsp12).last.item.object.name + "', while the expected type is `" + extend_type.name + "'. Make sure the per property ends in the same type that is being extended.")
				abort
			end

-- 			mytype ?= $3.last.item.object
-- 			if mytype /= Void then
-- 				create {XPLAIN_EXTENSION_FUNCTION_EXPRESSION} $$.make ($1, $3)
-- 			else
-- 				report_error ("Per property must be a type, cannot be a base.")
-- 				abort
-- 			end
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp26 := yyvsp26 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp1 := yyvsp1 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp26 >= yyvsc26 then
		if yyvs26 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs26")
			end
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs26")
			end
			yyvsc26 := yyvsc26 + yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.resize (yyvs26, yyvsc26)
		end
	end
	yyvs26.put (yyval26, yyvsp26)
end
when 284 then
--|#line 1827 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1827")
end

report_error("per keyword expected instead of: " + text)
		abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp26 >= yyvsc26 then
		if yyvs26 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs26")
			end
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs26")
			end
			yyvsc26 := yyvsc26 + yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.resize (yyvs26, yyvsc26)
		end
	end
	yyvs26.put (yyval26, yyvsp26)
end
when 285 then
--|#line 1833 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1833")
end

yyval27 := yyvs28.item (yyvsp28) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp27 := yyvsp27 + 1
	yyvsp28 := yyvsp28 -1
	if yyvsp27 >= yyvsc27 then
		if yyvs27 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs27")
			end
			create yyspecial_routines27
			yyvsc27 := yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.make (yyvsc27)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs27")
			end
			yyvsc27 := yyvsc27 + yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.resize (yyvs27, yyvsc27)
		end
	end
	yyvs27.put (yyval27, yyvsp27)
end
when 286 then
--|#line 1835 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1835")
end

yyval27 := yyvs23.item (yyvsp23) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp27 := yyvsp27 + 1
	yyvsp23 := yyvsp23 -1
	if yyvsp27 >= yyvsc27 then
		if yyvs27 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs27")
			end
			create yyspecial_routines27
			yyvsc27 := yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.make (yyvsc27)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs27")
			end
			yyvsc27 := yyvsc27 + yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.resize (yyvs27, yyvsc27)
		end
	end
	yyvs27.put (yyval27, yyvsp27)
end
when 287 then
--|#line 1840 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1840")
end

create {XPLAIN_SELECTION_LIST} yyval28.make (yyvs22.item (yyvsp22), yyvs31.item (yyvsp31), yyvs9.item (yyvsp9), yyvs29.item (yyvsp29))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp28 := yyvsp28 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp31 := yyvsp31 -1
	yyvsp9 := yyvsp9 -1
	yyvsp29 := yyvsp29 -1
	if yyvsp28 >= yyvsc28 then
		if yyvs28 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs28")
			end
			create yyspecial_routines28
			yyvsc28 := yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.make (yyvsc28)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs28")
			end
			yyvsc28 := yyvsc28 + yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.resize (yyvs28, yyvsc28)
		end
	end
	yyvs28.put (yyval28, yyvsp28)
end
when 288 then
--|#line 1843 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1843")
end

		  create {XPLAIN_SELECTION_LIST} yyval28.make (yyvs22.item (yyvsp22), yyvs31.item (yyvsp31), yyvs9.item (yyvsp9), yyvs29.item (yyvsp29))
			yyval28.set_identification_text (yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp28 := yyvsp28 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp22 := yyvsp22 -1
	yyvsp31 := yyvsp31 -1
	yyvsp9 := yyvsp9 -1
	yyvsp29 := yyvsp29 -1
	if yyvsp28 >= yyvsc28 then
		if yyvs28 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs28")
			end
			create yyspecial_routines28
			yyvsc28 := yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.make (yyvsc28)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs28")
			end
			yyvsc28 := yyvsc28 + yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.resize (yyvs28, yyvsc28)
		end
	end
	yyvs28.put (yyval28, yyvsp28)
end
when 289 then
--|#line 1850 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1850")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp29 := yyvsp29 + 1
	if yyvsp29 >= yyvsc29 then
		if yyvs29 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs29")
			end
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs29")
			end
			yyvsc29 := yyvsc29 + yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.resize (yyvs29, yyvsc29)
		end
	end
	yyvs29.put (yyval29, yyvsp29)
end
when 290 then
--|#line 1851 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1851")
end

yyval29 := yyvs29.item (yyvsp29) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs29.put (yyval29, yyvsp29)
end
when 291 then
--|#line 1856 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1856")
end

		myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
		if myobject /= Void then
			create {XPLAIN_SORT_NODE} yyval29.make (yyvs12.item (yyvsp12), True, Void)
		end 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp29 >= yyvsc29 then
		if yyvs29 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs29")
			end
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs29")
			end
			yyvsc29 := yyvsc29 + yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.resize (yyvs29, yyvsc29)
		end
	end
	yyvs29.put (yyval29, yyvsp29)
end
when 292 then
--|#line 1861 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1861")
end

		myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
		if myobject /= Void then
			create {XPLAIN_SORT_NODE} yyval29.make (yyvs12.item (yyvsp12), False, Void)
		end 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp29 := yyvsp29 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp29 >= yyvsc29 then
		if yyvs29 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs29")
			end
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs29")
			end
			yyvsc29 := yyvsc29 + yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.resize (yyvs29, yyvsc29)
		end
	end
	yyvs29.put (yyval29, yyvsp29)
end
when 293 then
--|#line 1866 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1866")
end

		myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
		if myobject /= Void then
			create {XPLAIN_SORT_NODE} yyval29.make (yyvs12.item (yyvsp12), True, yyvs29.item (yyvsp29))
		end 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp12 := yyvsp12 -1
	yyvsp1 := yyvsp1 -1
	yyvs29.put (yyval29, yyvsp29)
end
when 294 then
--|#line 1871 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1871")
end

		myobject := get_object_if_valid_tree (yyvs12.item (yyvsp12))
		if myobject /= Void then
			create {XPLAIN_SORT_NODE} yyval29.make (yyvs12.item (yyvsp12), False, yyvs29.item (yyvsp29))
		end 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp12 := yyvsp12 -1
	yyvs29.put (yyval29, yyvsp29)
end
when 295 then
--|#line 1879 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1879")
end

			if yyvs30.item (yyvsp30).property_required = 0 and yyvs9.item (yyvsp9 - 1) /= Void then
				report_error ("Function " + yyvs30.item (yyvsp30).name + " does not allow a property to be present.")
				abort
			elseif yyvs30.item (yyvsp30).property_required = 1 and yyvs9.item (yyvsp9 - 1) = Void then
				report_error ("Function " + yyvs30.item (yyvsp30).name + " requires the presence of a property.")
				abort
			else
				create yyval23.make (yyvs30.item (yyvsp30), yyvs22.item (yyvsp22), yyvs9.item (yyvsp9 - 1), yyvs9.item (yyvsp9))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp23 := yyvsp23 + 1
	yyvsp30 := yyvsp30 -1
	yyvsp22 := yyvsp22 -1
	yyvsp9 := yyvsp9 -2
	if yyvsp23 >= yyvsc23 then
		if yyvs23 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs23")
			end
			create yyspecial_routines23
			yyvsc23 := yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.make (yyvsc23)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs23")
			end
			yyvsc23 := yyvsc23 + yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.resize (yyvs23, yyvsc23)
		end
	end
	yyvs23.put (yyval23, yyvsp23)
end
when 296 then
--|#line 1893 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1893")
end

create {XPLAIN_MAX_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 297 then
--|#line 1895 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1895")
end

create {XPLAIN_MIN_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 298 then
--|#line 1897 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1897")
end

create {XPLAIN_TOTAL_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 299 then
--|#line 1899 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1899")
end

create {XPLAIN_COUNT_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 300 then
--|#line 1901 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1901")
end

create {XPLAIN_ANY_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 301 then
--|#line 1903 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1903")
end

create {XPLAIN_NIL_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 302 then
--|#line 1905 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1905")
end

create {XPLAIN_SOME_FUNCTION} yyval30 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp30 := yyvsp30 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp30 >= yyvsc30 then
		if yyvs30 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs30")
			end
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs30")
			end
			yyvsc30 := yyvsc30 + yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.resize (yyvs30, yyvsc30)
		end
	end
	yyvs30.put (yyval30, yyvsp30)
end
when 303 then
--|#line 1916 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1916")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp31 := yyvsp31 + 1
	if yyvsp31 >= yyvsc31 then
		if yyvs31 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs31")
			end
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs31")
			end
			yyvsc31 := yyvsc31 + yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.resize (yyvs31, yyvsc31)
		end
	end
	yyvs31.put (yyval31, yyvsp31)
end
when 304 then
--|#line 1917 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1917")
end

			yyval31 := yyvs31.item (yyvsp31)
			yyval31.give_column_names (2) -- first column is always the instance id
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs31.put (yyval31, yyvsp31)
end
when 305 then
--|#line 1925 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1925")
end

create yyval31.make (yyvs9.item (yyvsp9), yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp31 >= yyvsc31 then
		if yyvs31 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs31")
			end
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs31")
			end
			yyvsc31 := yyvsc31 + yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.resize (yyvs31, yyvsc31)
		end
	end
	yyvs31.put (yyval31, yyvsp31)
end
when 306 then
--|#line 1927 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1927")
end

create yyval31.make (yyvs9.item (yyvsp9), yyvs2.item (yyvsp2), yyvs31.item (yyvsp31)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs31.put (yyval31, yyvsp31)
end
when 307 then
--|#line 1929 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1929")
end

			report_error ("its keyword should not appear after comma. Remove it.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp31 := yyvsp31 + 1
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp31 >= yyvsc31 then
		if yyvs31 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs31")
			end
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs31")
			end
			yyvsc31 := yyvsc31 + yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.resize (yyvs31, yyvsc31)
		end
	end
	yyvs31.put (yyval31, yyvsp31)
end
when 308 then
--|#line 1934 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1934")
end

			report_error ("Superfluous comma detected. Remove it.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp31 := yyvsp31 + 1
	yyvsp9 := yyvsp9 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp31 >= yyvsc31 then
		if yyvs31 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs31")
			end
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs31")
			end
			yyvsc31 := yyvsc31 + yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.resize (yyvs31, yyvsc31)
		end
	end
	yyvs31.put (yyval31, yyvsp31)
end
when 309 then
--|#line 1942 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1942")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp9 := yyvsp9 + 1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 310 then
--|#line 1943 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1943")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs9.put (yyval9, yyvsp9)
end
when 311 then
--|#line 1948 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1948")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 312 then
--|#line 1949 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1949")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 313 then
--|#line 1951 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1951")
end

			report_error ("The as keyword should be followed by a name (my name) or a quoted name (`my new name'), not by a string.")
			abort
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs2.put (yyval2, yyvsp2)
end
when 314 then
--|#line 1959 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1959")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp9 := yyvsp9 + 1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 315 then
--|#line 1960 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1960")
end

yyval9 := yyvs8.item (yyvsp8) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp9 := yyvsp9 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp8 := yyvsp8 -1
	if yyvsp9 >= yyvsc9 then
		if yyvs9 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs9")
			end
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs9")
			end
			yyvsc9 := yyvsc9 + yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.resize (yyvs9, yyvsc9)
		end
	end
	yyvs9.put (yyval9, yyvsp9)
end
when 316 then
--|#line 1965 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1965")
end

		if not use_mode then
			sqlgenerator.echo(yyvs2.item (yyvsp2))
			sqlgenerator.write_echo(yyvs2.item (yyvsp2))
		end
	
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 317 then
--|#line 1980 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1980")
end

			procedure_mode := False
			create myprocedure.make (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs3.item (yyvsp3), yyvs32.item (yyvsp32))
			universe.add (myprocedure)
			if immediate_output_mode then
				sqlgenerator.write_procedure (myprocedure)
			end
			create yyval41.make (myprocedure)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp41 := yyvsp41 -1
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp1 := yyvsp1 -2
	yyvsp32 := yyvsp32 -1
	yyvs41.put (yyval41, yyvsp41)
end
when 318 then
--|#line 1980 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1980")
end

			write_pending_statement
			procedure_mode := True
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp41 := yyvsp41 + 1
	if yyvsp41 >= yyvsc41 then
		if yyvs41 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs41")
			end
			create yyspecial_routines41
			yyvsc41 := yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.make (yyvsc41)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs41")
			end
			yyvsc41 := yyvsc41 + yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.resize (yyvs41, yyvsc41)
		end
	end
	yyvs41.put (yyval41, yyvsp41)
end
when 319 then
--|#line 1980 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 1980")
end

			my_parameters := yyvs12.item (yyvsp12)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp41 := yyvsp41 + 1
	if yyvsp41 >= yyvsc41 then
		if yyvs41 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs41")
			end
			create yyspecial_routines41
			yyvsc41 := yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.make (yyvsc41)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs41")
			end
			yyvsc41 := yyvsc41 + yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.resize (yyvs41, yyvsc41)
		end
	end
	yyvs41.put (yyval41, yyvsp41)
end
when 320 then
--|#line 2002 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2002")
end

yyval3 := 0 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 321 then
--|#line 2003 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2003")
end

yyval3 := 1 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 322 then
--|#line 2004 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2004")
end

yyval3 := 2 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 323 then
--|#line 2008 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2008")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp12 := yyvsp12 + 1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 324 then
--|#line 2009 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2009")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs12.put (yyval12, yyvsp12)
end
when 325 then
--|#line 2014 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2014")
end

create yyval12.make (yyvs13.item (yyvsp13), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp12 := yyvsp12 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp12 >= yyvsc12 then
		if yyvs12 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs12")
			end
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs12")
			end
			yyvsc12 := yyvsc12 + yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.resize (yyvs12, yyvsc12)
		end
	end
	yyvs12.put (yyval12, yyvsp12)
end
when 326 then
--|#line 2016 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2016")
end

create yyval12.make (yyvs13.item (yyvsp13), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp13 := yyvsp13 -1
	yyvsp1 := yyvsp1 -1
	yyvs12.put (yyval12, yyvsp12)
end
when 327 then
--|#line 2021 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2021")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp32 := yyvsp32 + 1
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 328 then
--|#line 2022 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2022")
end

yyval32 := yyvs32.item (yyvsp32) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs32.put (yyval32, yyvsp32)
end
when 329 then
--|#line 2027 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2027")
end

			create yyval32.make (yyvs33.item (yyvsp33), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp33 := yyvsp33 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 330 then
--|#line 2031 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2031")
end

			create yyval32.make (yyvs33.item (yyvsp33), yyvs32.item (yyvsp32))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 -1
	yyvsp1 := yyvsp1 -1
	yyvs32.put (yyval32, yyvsp32)
end
when 331 then
--|#line 2035 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2035")
end

			create yyval32.make (yyvs42.item (yyvsp42), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp42 := yyvsp42 -1
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 332 then
--|#line 2039 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2039")
end

			create yyval32.make (yyvs42.item (yyvsp42), yyvs32.item (yyvsp32))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 -1
	yyvs32.put (yyval32, yyvsp32)
end
when 333 then
--|#line 2043 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2043")
end

			if equal (text, "end") then
				report_error ("Unexpected 'end' in stored procedure. '.' missing in last statement?")
				abort
			else
				report_error ("Stumbled upon: " + text)
				abort
		end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 334 then
--|#line 2053 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2053")
end

report_error ("A base statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 335 then
--|#line 2055 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2055")
end

report_error ("A type statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 336 then
--|#line 2057 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2057")
end

report_error ("An assert statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 337 then
--|#line 2059 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2059")
end

report_error ("An init statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 338 then
--|#line 2061 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2061")
end

report_error ("A procedure statement cannot appear in a procedure."); abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp32 := yyvsp32 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp32 >= yyvsc32 then
		if yyvs32 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs32")
			end
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs32")
			end
			yyvsc32 := yyvsc32 + yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.resize (yyvs32, yyvsc32)
		end
	end
	yyvs32.put (yyval32, yyvsp32)
end
when 339 then
--|#line 2066 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2066")
end

yyval33 := yyvs39.item (yyvsp39) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp39 := yyvsp39 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 340 then
--|#line 2068 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2068")
end

yyval33 := yyvs38.item (yyvsp38) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp38 := yyvsp38 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 341 then
--|#line 2070 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2070")
end

yyval33 := yyvs33.item (yyvsp33) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs33.put (yyval33, yyvsp33)
end
when 342 then
--|#line 2072 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2072")
end

yyval33 := yyvs40.item (yyvsp40) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp40 := yyvsp40 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 343 then
--|#line 2074 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2074")
end

yyval33 := yyvs44.item (yyvsp44) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 344 then
--|#line 2076 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2076")
end

yyval33 := yyvs45.item (yyvsp45) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp45 := yyvsp45 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 345 then
--|#line 2078 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2078")
end

yyval33 := yyvs46.item (yyvsp46) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp33 := yyvsp33 + 1
	yyvsp46 := yyvsp46 -1
	if yyvsp33 >= yyvsc33 then
		if yyvs33 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs33")
			end
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs33")
			end
			yyvsc33 := yyvsc33 + yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.resize (yyvs33, yyvsc33)
		end
	end
	yyvs33.put (yyval33, yyvsp33)
end
when 346 then
--|#line 2088 "xplain_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'xplain_parser.y' at line 2088")
end

			create yyval42.make (yyvs2.item (yyvsp2))
			if immediate_output_mode then
				sqlgenerator.write_sql (yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp42 := yyvsp42 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp42 >= yyvsc42 then
		if yyvs42 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs42")
			end
			create yyspecial_routines42
			yyvsc42 := yyInitial_yyvs_size
			yyvs42 := yyspecial_routines42.make (yyvsc42)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs42")
			end
			yyvsc42 := yyvsc42 + yyInitial_yyvs_size
			yyvs42 := yyspecial_routines42.resize (yyvs42, yyvsc42)
		end
	end
	yyvs42.put (yyval42, yyvsp42)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 610 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER] is
			-- Template for `yytranslate'
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,  125,  117,    2,    2,
			  120,  121,  115,  113,  122,  114,  119,  116,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,  124,  127,
			  109,  107,  110,  123,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,  128,    2,  129,    2,  126,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  108,  111,  112,  118, yyDummy>>)
		end

	yyr1_template: SPECIAL [INTEGER] is
			-- Template for `yyr1'
		once
			Result := yyfixed_array (<<
			    0,  233,  233,  233,  233,  130,  131,  234,  234,  235,
			  235,  235,  235,  235,  213,  213,  213,  214,  214,  214,
			  216,  216,  216,  216,  216,  216,  216,  216,  236,  236,
			  218,  218,  132,  132,  132,  229,  237,  243,  238,  244,
			  217,  241,  242,  245,  242,  246,  134,  134,  134,  134,
			  135,  135,  136,  136,  137,  137,  137,  138,  139,  139,
			  140,  140,  141,  142,  142,  143,  143,  143,  144,  144,
			  146,  146,  145,  145,  145,  145,  145,  145,  145,  145,
			  145,  145,  145,  145,  147,  147,  147,  147,  147,  147,
			  148,  148,  149,  149,  150,  150,  150,  151,  151,  152,

			  152,  152,  152,  152,  152,  152,  152,  152,  152,  152,
			  152,  152,  152,  152,  152,  152,  152,  152,  153,  153,
			  154,  154,  155,  155,  156,  157,  247,  158,  158,  158,
			  159,  160,  248,  249,  249,  251,  252,  252,  250,  161,
			  161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
			  162,  162,  162,  163,  164,  165,  166,  167,  168,  168,
			  168,  169,  169,  169,  169,  169,  170,  170,  171,  171,
			  172,  173,  174,  175,  179,  179,  180,  180,  181,  181,
			  181,  181,  181,  181,  181,  181,  176,  176,  176,  177,
			  177,  177,  178,  178,  178,  178,  133,  133,  182,  253,

			  182,  183,  254,  239,  240,  255,  240,  256,  240,  257,
			  240,  258,  184,  184,  185,  185,  185,  215,  215,  260,
			  260,  260,  260,  225,  225,  225,  225,  225,  186,  186,
			  186,  187,  188,  188,  219,  261,  220,  220,  220,  221,
			  222,  189,  190,  190,  190,  190,  190,  230,  230,  191,
			  191,  259,  259,  259,  259,  259,  231,  192,  192,  192,
			  192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
			  232,  263,  263,  193,  224,  223,  194,  264,  194,  195,
			  195,  196,  196,  196,  196,  197,  197,  198,  198,  199,
			  199,  200,  200,  200,  200,  201,  202,  202,  202,  202,

			  202,  202,  202,  203,  203,  204,  204,  204,  204,  205,
			  205,  206,  206,  206,  207,  207,  262,  226,  265,  266,
			  227,  227,  227,  208,  208,  209,  209,  210,  210,  211,
			  211,  211,  211,  211,  211,  211,  211,  211,  211,  212,
			  212,  212,  212,  212,  212,  212,  228, yyDummy>>)
		end

	yytypes1_template: SPECIAL [INTEGER] is
			-- Template for `yytypes1'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    2,    2,    2,    2,    2,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    4,    2,    2,   19,   33,   33,   33,   33,   34,   35,
			   36,   38,   39,   40,   33,   41,    3,   42,   43,   44,
			   45,   46,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    2,    1,    1,    1,    2,    2,
			    1,    2,    2,   22,    2,    1,    2,    2,    2,   22,
			    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    2,   22,   27,   28,   23,   30,    2,   24,    2,   22,

			    2,    1,    2,    2,    2,    2,    2,    1,    1,    1,
			   41,    1,    1,    2,    1,    1,    2,    1,    1,    1,
			    2,    9,    1,    1,    1,    1,    1,   16,    2,    1,
			    1,    1,    1,    1,   14,    2,   22,    1,   31,    1,
			   22,    1,    1,    1,    9,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,   15,    1,   15,   19,    1,
			    1,    1,    5,    5,    2,    2,    1,    1,    1,    2,
			    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    3,    2,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,   10,    2,    2,    2,    3,    2,    9,    9,

			    9,    9,    8,    9,    9,    9,   23,   30,    1,   13,
			    2,   13,    2,    1,    2,    2,    2,   20,   21,   13,
			    3,    3,    1,    1,    1,    1,   20,   14,   14,   31,
			    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,   10,   11,    9,    9,    9,
			    2,   12,   13,    2,    2,    2,   31,    9,   22,    1,
			    9,   24,    1,    1,    1,    8,    9,    9,   10,    9,
			   12,    1,    3,    1,    1,    3,    1,    3,    1,    3,
			   36,    1,    5,    1,    1,    2,    2,    5,    6,    7,
			    2,    3,    1,    9,    1,   12,    1,    1,    1,    1,

			    2,    1,    2,   13,   13,    9,    8,    1,    9,    2,
			    9,    9,    9,    9,    1,   10,    2,   15,    1,    1,
			    1,    1,    1,    1,    1,    1,    2,    1,    1,    1,
			    1,   22,   15,    1,    1,    1,    9,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,   17,   18,   13,    1,
			   13,   20,    1,    9,    2,   13,   13,    9,    1,   12,
			    9,    9,    9,    9,   31,    8,    8,    1,    2,    1,
			    1,    2,    1,    1,    1,    2,    1,    1,    1,   29,
			    1,    1,   12,    9,    9,    2,   25,   13,    8,    9,
			    1,    1,   10,    9,   12,    1,    1,    1,    1,    2,

			    1,    1,    1,    1,    1,   13,    2,    2,    1,    1,
			    1,    1,    9,    1,   13,   12,    1,    1,    2,    1,
			    1,    2,    1,    1,    1,    9,    1,    1,    1,    1,
			    8,    9,    9,    9,    9,    9,    8,    9,    9,    2,
			    2,    2,   20,    1,    9,    9,   13,   13,   13,   13,
			    1,    1,   13,   13,   29,    1,    1,    9,    1,    1,
			    1,    1,    1,    1,    2,    2,    1,    9,    9,   12,
			    2,    1,   12,   29,   12,   13,   12,   15,    1,    1,
			   13,    8,    2,    9,    8,    1,    1,    9,    3,    1,
			    5,    5,    1,    2,    2,    6,    7,    1,    1,   41,

			    1,    2,   12,    1,    1,   31,    1,    9,    8,    1,
			   17,    1,    1,   31,    1,    9,    1,    1,   31,   12,
			    1,    1,    1,    1,    9,   26,   23,    1,    9,    1,
			    1,    9,   23,   37,    1,    1,   12,    1,    1,    1,
			    1,    1,    1,   32,   32,   33,   38,   39,   40,   33,
			   42,   44,   45,   46,   12,    1,   12,    1,    1,    1,
			    1,    9,    9,    1,    1,    1,   29,   12,    8,    1,
			    1,    8,    1,   26,    1,    1,    1,    1,    1,    1,
			    1,   32,   12,    8,    9,    9,    9,   29,    1,   12,
			    1,   12,   12,   32,    1,    1,    2,    3,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    9,    9,
			    1,    1,    1, yyDummy>>)
		end

	yytypes2_template: SPECIAL [INTEGER] is
			-- Template for `yytypes2'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    2,    2,    2,    2,    3,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER] is
			-- Template for `yydefact'
		once
			Result := yyfixed_array (<<
			    0,    0,    4,    0,  168,    0,    6,  346,    0,  322,
			  321,  320,    0,    0,    0,    0,    0,    0,    0,   37,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   13,
			   21,    0,  155,   25,    0,   14,   15,   17,   24,   19,
			  222,  220,  252,  251,  221,   16,  318,    0,   20,  219,
			  253,  255,    0,    8,   18,   22,   23,   26,   27,   28,
			   29,  217,  218,  254,  169,    5,    0,    0,  205,  153,
			    0,  270,  242,    0,    0,    0,   43,   41,  156,    0,
			   39,    0,  170,  298,  302,  301,  297,  296,  299,  300,
			    0,  303,  274,  285,  286,    0,    0,  275,  316,  314,

			    0,  203,    0,    0,  154,  199,  202,    0,    0,    0,
			    0,   11,    0,  207,    0,    0,  209,    0,    0,    0,
			  243,  241,    0,  248,    0,    0,  152,    0,   45,    0,
			    0,    0,  225,    0,   36,  126,  303,    0,  314,    0,
			  309,  277,  278,    0,  240,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  149,   40,  235,    0,    0,    0,
			    0,   49,    0,   48,   47,   62,    0,   31,   12,  323,
			    0,    0,  211,    0,    0,    0,    0,    0,    0,    0,
			  171,  172,  269,    0,    0,    0,    0,    0,   90,    0,
			    0,   91,  183,  193,  195,  182,  118,  119,  257,  180,

			  188,  191,  173,  174,  176,  256,  258,    0,    0,  244,
			    0,  124,  166,  246,    0,    0,  249,  314,    0,    0,
			    0,    0,    0,    0,    0,    0,  223,   38,    0,  314,
			    0,    0,    0,    0,    0,  117,  107,    0,    0,    0,
			    0,    0,   92,   93,    0,  112,  101,  311,   95,   98,
			  111,   99,  120,    0,  157,  110,  304,  289,  212,    0,
			  314,    0,    0,    0,    0,  315,   71,   69,  112,    0,
			   99,  147,    0,  145,  144,    0,  142,    0,  140,    0,
			    0,   33,   34,    0,   59,    0,   58,   46,   50,   51,
			   52,   54,    0,    0,    0,    0,    0,    3,    0,    0,

			    0,    0,    0,  261,  262,  180,    0,    0,  194,  259,
			    0,    0,    0,    0,    0,  184,  181,  271,    0,    0,
			   87,   85,   86,   84,   89,   88,    0,    0,    0,    0,
			    0,  309,    0,    0,  245,    0,  247,    0,  230,    0,
			  151,  150,    0,    0,    0,    0,   35,    0,  162,    0,
			   42,  224,    0,  289,    0,  113,  114,    0,    0,  100,
			    0,    0,    0,    0,    0,  130,    0,    0,  305,   64,
			   63,    0,   67,   66,   65,    0,    0,    0,    0,  287,
			  212,    0,  226,  310,  295,    0,    0,  114,    0,    0,
			    0,    0,  112,    0,   99,    0,    0,   89,   88,    0,

			    0,  148,  143,  141,  139,    0,  201,  196,    0,    0,
			    0,    0,  200,   30,  325,  324,  319,    2,    0,    0,
			    0,    0,    0,  192,  178,    0,  266,  265,  264,  263,
			    0,  187,  186,  185,  190,  189,  175,  177,  314,  272,
			  167,  250,  229,    0,  232,  231,    0,  165,  164,  163,
			    0,  160,   44,    0,  288,    0,  108,    0,  106,  105,
			  104,  103,  102,    0,  313,  312,    0,   94,   97,  121,
			  123,    0,  291,  290,  227,    0,  213,  280,    0,   80,
			  114,    0,    0,   70,   68,   77,   76,   78,    0,    0,
			    0,  197,   61,    0,   60,   53,   55,   56,    0,    0,

			    0,    0,  204,    0,  267,    0,  179,  273,    0,  161,
			  159,    0,  115,    0,  109,    0,  308,  307,  306,  292,
			    0,    0,  216,    0,  281,  276,    0,   81,   79,  146,
			    0,  237,    0,  234,    0,   57,  326,    0,    0,    0,
			    0,    0,  333,    0,  328,    0,  340,  339,  342,  341,
			    0,  343,  344,  345,  206,    0,  208,  268,  233,    0,
			    0,  127,  125,  116,    0,    0,  293,  215,    0,    0,
			  284,    0,    0,  198,  338,  335,  337,  334,  336,  317,
			    0,  332,  210,    0,  131,    0,   96,  294,  282,  283,
			  238,  239,  236,  330,  128,    0,  137,  136,  129,    0,

			    0,    0,    0,  132,  134,  133,    0,    0,  135,  138,
			    0,    0,    0, yyDummy>>)
		end

	yydefgoto_template: SPECIAL [INTEGER] is
			-- Template for `yydefgoto'
		once
			Result := yyfixed_array (<<
			    3,    5,   30,  490,  162,  287,  288,  289,  163,  285,
			  493,  164,  371,  375,  265,  266,  267,  326,  245,  246,
			  389,  248,  249,  250,  251,  252,  209,  134,  562,  366,
			  585,  155,  127,  135,  103,  194,   77,  253,  346,  347,
			  211,  254,  255,  196,  197,  198,  199,  200,  201,  202,
			  203,  204,   33,  407,  382,  476,  217,  218,  445,   73,
			  121,  219,  205,  206,   97,  386,  525,   92,   93,  379,
			  473,  526,  207,  138,  256,  260,  368,  144,  295,  415,
			  543,  544,  545,   34,   35,   36,   37,   38,   39,   40,
			  533,  592,   41,   42,   43,   44,   45,   46,   47,   48,

			   49,   50,   51,  610,   52,   53,   54,   55,   56,   57,
			   58,   59,   60,   81,  133,  129,  223,  228,  598,  599,
			  603,  600,  601,  158,  107,  115,  171,  174,  299,   61,
			   62,  280,   63,  208,  261,  110,  499, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER] is
			-- Template for `yypact'
		once
			Result := yyfixed_array (<<
			   72,    8, -32768, 1712,    8,  442, -32768, -32768,  128, -32768,
			 -32768, -32768,    8,  472,    8,    8,    8,  -13,    8,  541,
			  366,    8,  456,    8,    8,  549,    8,    8,    8, -32768,
			 -32768,  440, -32768, -32768,  426, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, 1659, -32768, -32768,
			 -32768, -32768,  526, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,    8,  459, -32768, -32768,
			    8,  432,  -62,   37,   90,    8, -32768, -32768,  505,   30,
			 -32768,    8, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			    8,  491, -32768,  513, -32768,    8,   33, -32768, -32768,  256,

			  592, -32768,  510,  592, -32768, -32768,  505,   89,   18, 1599,
			    8, -32768,  411, -32768,    8,  503, -32768, 1075,    8,   15,
			 -32768, -32768,    8, -32768,  431,  425, -32768,  418, -32768,  495,
			  493,    8, -32768,    8, -32768, -32768,  491, 1346,  256,    8,
			  390, -32768, -32768, 1224, -32768,  395,  415,  392,  388,  414,
			  386,  409,  384,  402, -32768, -32768, -32768,  240,  471,  236,
			  107, -32768,  391, -32768, -32768, -32768,  682, -32768, -32768,  444,
			   76,  470, -32768,    8,  467,    8,    8,    8,  682,  289,
			 -32768, -32768, -32768,    8, 1075, 1075, 1075, 1075, -32768,  166,
			  592, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  639,

			  115, -32768, -32768,  457,  486, -32768, -32768,    8,  152, -32768,
			  361, -32768,  354, -32768,  367,  358,  354,  256,   17,  372,
			  357,  356,  -54,  449,    8,    8, -32768, -32768,  448,  256,
			    8,    8,    8, 1346,  -55, -32768, -32768, 1346, 1346, 1346,
			 1346, 1346, -32768, -32768, 1224, -32768, -32768,  464,  205,   74,
			 -32768, -32768,  441,  342,  821, -32768, -32768,  379,   40, 1346,
			  256,    8,    8, 1224, 1467, -32768,  463,  429,  545,  610,
			  517, -32768,   12, -32768, -32768,  341, -32768,  337, -32768,  331,
			    8, -32768, -32768,    8, -32768,  325, -32768, -32768, -32768, -32768,
			  329,  -77, 1075,  321,    8,  338,  439, -32768,    8,  412,

			  328,    8,  308, -32768, -32768,  619,  306,  289, -32768, -32768,
			  305,  299,  298,  296,  682, -32768, -32768, -32768,  289,  289,
			 -32768, -32768, -32768, -32768, -32768, -32768,  289,  289,  289,  682,
			  682,  390,  246,    8, -32768,    8, -32768,    8, -32768, 1425,
			 -32768, -32768,    8,    8,    8,    8, -32768,   54, -32768,    8,
			 -32768, -32768,    8,  379,  290, -32768, -32768,  292, 1346, -32768,
			  291,  287,  280,  279,  278, -32768,  353,  221,  258, -32768,
			 -32768, 1346, -32768, -32768, -32768, 1538,    8,    8,  -46, -32768,
			  351,    8, -32768, -32768, -32768,  548,  268,  389,  253,  455,
			    8, 1224,  336,  563,  260, 1224, 1224,  340,  335, 1346,

			  270, -32768, -32768, -32768, -32768,  249, -32768,  228,  149,  246,
			  234,  323, -32768, -32768,  200, -32768, -32768, -32768,  210,    8,
			    8,  206, 1304, -32768, -32768,  -70, -32768, -32768, -32768, -32768,
			  187,  115,  115,  -64, -32768, -32768, -32768, -32768,  256, -32768,
			 -32768, -32768, -32768, 1224, -32768, -32768,  172, -32768, -32768, -32768,
			  -54, -32768, -32768,  185, -32768, 1216, -32768,  163, -32768, -32768,
			 -32768, -32768, -32768, 1346, -32768, -32768, 1125, -32768, -32768, -32768,
			 -32768,    8,  156, -32768, -32768,   41, -32768, -32768,  935, -32768,
			  204,  153, 1346, -32768, -32768, -32768, -32768, -32768,  148,  977,
			  159, -32768, -32768,  138, -32768, -32768, -32768, -32768,    8, 1764,

			    8,  129, -32768,    8, -32768,  126, -32768, -32768,  117, -32768,
			 -32768, 1117, -32768,  112, -32768,  211, -32768, -32768, -32768,  103,
			  -46,    8, -32768, 1224, -32768, -32768,   24, -32768, -32768, -32768,
			 1224, -32768,  170, -32768,  935, -32768, -32768,  214,  202,  199,
			  196,  192, -32768,  160, -32768,   42, -32768, -32768, -32768, -32768,
			 1489, -32768, -32768, -32768, -32768,    8, -32768, -32768, -32768, 1224,
			 1346, -32768, -32768, -32768, 1346,  -46, -32768, -32768,   50,    8,
			 -32768,    2,    8, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 1368, -32768, -32768,   -8, -32768,   64, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  107, -32768, -32768, -32768,    9,

			  -49,  -38,  -42, -32768, -32768, -32768, 1117, 1117, -32768, -32768,
			   75,   46, -32768, yyDummy>>)
		end

	yypgoto_template: SPECIAL [INTEGER] is
			-- Template for `yypgoto'
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768, -32768,  446, -32768,  191,  189,  188, -32768,
			 -32768, -32768, -32768, -32768, -209, -32768,  203, -241,  348, -32768,
			  105,  222, -32768,  502,  239,  359, -170,  458, -244, -32768,
			 -32768,  -79, -32768,   84, -32768,    6, -32768,  364,  134, -32768,
			 -201,  104,  -20, -145, -32768,  416, -158,   34, -171, -167,
			  248, -32768, -32768, -32768,  194, -386, -126, -32768, -32768,   -6,
			 -32768, -177, -115, -32768, -32768, -32768,   43, -32768, -32768,  220,
			 -498,  -17,  -19,  436, -239,  238, -32768, -134, -32768,   61,
			 -32768, -523, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -144, -159, -192, -223, -32768, -32768, -275, -32768,

			 -282, -318, -470, -32768, -32768,  -21, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  -41, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER] is
			-- Template for `yytable'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make (0, 1857)
			yytable_template_1 (an_array)
			yytable_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytable_template_1 (an_array: ARRAY [INTEGER]) is
			-- Fill chunk #1 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   90,   95,  364,   94,  257,  226,  303,  304,  308,   31,
			   75,  306,   79,  401,   91,  291,  213,   99,  338,  167,
			  305,  348,  566,  602,  157,  570,  111,  581,  399,  553,
			  100,  132,  345,   82,  502,  365,  344,  343,  123,    4,
			    4,  411,  522,  319,  318,  410,  612,  350,    4,  319,
			  318,  423,  120,   31,  388,  451,  131,  593,  119,  142,
			  569,  118,  356,  122, -228,  358,  381,  587,  471,  310,
			  311,  312,  313,    2,  342,  611,   -1,  297,  605,  141,
			  553,    4,  607,  336,  136,    1,  606,  165,  168,  140,
			  161,  126,  387,  414,  296,  353,   68,  195,  595,  351,

			   74,   76,    4,  405,   82,    6,  180,   32,   64,    4,
			  553,  317,  105,  594,  554,   31,   69,  556,   71,   72,
			   69,   78,   72,  590,   72,   96,  384,   72,   32,  332,
			  102,  104,  106,  258,  400,  567, -228,  165,  166,  337,
			  290,  446,  447,  448,  449,  130,  195,  430,  399,  425,
			  113,   32,  482,  154,  116,  380,  434,  435,  195,  128,
			 -214,  580,  436,  521,  195,  195,  195,  195,  433,  582,
			   69,  588,  452, -158,   69,  453,  450,  412,  579,   69,
			  475,  552,  481,  505,   82,   69,  191,  484,  125,  374,
			  373,  372,  124,  578,   72,  316,  160,  577,  172,   72,

			  576,  331,   82,  575,  180,  -75,  572,  -75,  188,  159,
			   67,  442,   66,   32,  169,  574,  513,  551,   69,  475,
			  480,   32,  212,  214,  550,  565,  216,  518,  564,  -75,
			  328,  327,  552,  563,  508,  216,  555,   69,  558,  -75,
			  -75,  161,  247,   72,  -75,  181,  180,  557,  269,  348,
			  153,  152,  151,  150,  149,  148,  147,  146,  145,  535,
			    4,  -73,  552,  -73,  492,  291,  534,  309,  551,  529,
			   32, -260,  195, -260,  527,  550,  549,  300,  520,  302,
			  212,  212,   32,   32,  514,  -73,  314,   69,   32,   32,
			   32,   32,  511,   32,  195,  -73,  -73,  414,  551,  475,

			  -73,  509,  475,  143,  507,  550,  477,  548,  506,  195,
			  195,   72,  439,  503,  568,    4,  464,  500,  370,  369,
			  475,  571,  498,  -75,  497,  -75,  212,  549,  216,  216,
			  281,  180,  181,  180,  354,   82,  212,  -83,  357,  -83,
			  547,   82,  360,  361,  362,  363,  247,  160,  159,  269,
			  583,  284,  431,  432,  475,  546,  489,  549,  548,  -32,
			  159,  -83,  608,  609,  383,  385,  212,  488,  486,  393,
			   89,  -83,  -83,  485,  479,  478,  -83,  381,   88,  -73,
			  466,  -73,  270,    4,  216,  181,  180,  406,  548,  290,
			  -74,  547,  -74,  463,   87,   86,   32,   85,  212,  462,

			  461,  460,  418,  179,   84,  421,  546,   83,  459,  307,
			  455,   32,  458,  456,  -74,  378,  259,  429,   32,  428,
			  427,  547,   32,   32,  -74,  -74,  426,  424,  422,  -74,
			   32,   32,   32,   32,   32,  420,  546,  440,  419,  441,
			  417,  216,  413,  408,  444,  416,  212,  212,  212,  212,
			  597,  409,  404,  216,  597,  -83,  216,  -83,  403,   95,
			    4,   82,  402,  457,  396,  192,  395,  376,  377,  367,
			   95,  465,  532,  359,  352,  349,  467,  341,  340,  339,
			 -157,  470,  210,  270,  335,  212,  215,  333,  334,  330,
			  294,  268,  329,  301,  212,  215,  298,  283,  292,  279,

			  269,  269,  270,  394,  487,  278,  277,  276,  -74,  274,
			  -74,  275,  272,  273,  192,   95,  271,  137,  -72,  225,
			  -72,  224,  221,  501,  212,  222,  192,  247,  220,  173,
			  170, -153,  192,  192,  192,  192,  156,  315,  139,  117,
			  210,  210,  -72,  114,  112,  109,  -82,  108,  -82,  154,
			  101,   98,  -72,  -72,  212,   80,   70,  -72,  604,  536,
			  247,   65,  398,  397,  323,  322,  321,  320,  515,  438,
			  -82,  247,  229,  454,  474,  596,  456,  573,  437,  596,
			  -82,  -82,  293,  524,  510,  -82,  210,  528,  215,  215,
			  355,  227,  268,  154,  531,  491,  210,  468,  483,  496,

			  495,    0,  212,  282,  212,    0,    0,  212,    0,    0,
			    0,  268,  392,    0,    0,  469,  561,  472,    0,  193,
			    0,    0,    0,    0,    0,  212,  210,    0,    0,    0,
			  270,    0,    0,    0,  270,  270,  -72,    0,  -72,  524,
			  192,    0,    0,    0,  215,    0,  153,  152,  151,  150,
			  149,  148,  147,  146,  145, -279,    0,    0,  210,  212,
			    0,  286,  192,    0,  -82,  584,  -82,    0,  193,  586,
			  325,  324,  323,  322,  321,  320,    0,  192,  192,    0,
			  193,  193,  270,    0,    0,    0,  193,  193,  193,  193,
			  153,  152,  151,  150,  149,  148,  147,  146,  145,    0,

			    0,  215,  191,    0,    0,    0,  210,  210,  210,  210,
			  519,  561,  561,  215,  189,    0,  215,  398,  397,  323,
			  322,  321,  320,    0,  188,    0,  325,  324,  323,  322,
			  321,  320,  319,  318,    0,    0,    0,    0,    0,  268,
			  423,    0,    0,  268,  268,  210,  325,  324,  323,  322,
			  321,  320,  319,  318,  210,    0,    0,    0,    0,  472,
			    0,    0,  270,    0,    0,    0,    0,    0,    0,  270,
			    0,    0,    0,    0,    0,    0,    4,   82,  181,  180,
			    0,    0,    0,    0,  210,    0,    0,    0,    0,    0,
			    0,  268,    0,    0,  193,    0,  179,    0,  270,    0,

			    0,    0,  178,    0,  472,    0,    0,    0,  589,  193,
			    0,  591,    0,    0,  210,    0,  193,    0,    0,    0,
			  193,  193, -122,    0, -122,    0, -122,    0,  193,  193,
			  193,  193,  193,    0,    0, -122,    0,    0, -122,    0,
			    0,    0,    0,    0,    0,    0, -122, -122,    0,    0,
			    0,    0,    0,    0,    0, -122, -122, -122,    0,    0,
			    0, -122,  210,    0,  210,    0,    0,  210, -122,    0,
			    0,  268,    0,    0,    0,    0,    0,    0,  268,    0,
			    0,    0,    0,    0,    0,  210,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,  268,    0,    0,
			  494,    0,    0,    0,    0,    0, -122,    0, -122,  210,
			    0,    0,    0,    0,    0,    0,    0,    0, -122, -122,
			 -122, -122, -122, -122, -122, -122, -122, -122, -122,   89,
			 -122,    0, -122, -122,    0,    0,    0,   88, -122,    0,
			    0,    0,    0,    0,    0,  191,    0,  244,    0,    0,
			    0,    0,  243,   87,   86,    0,   85,    0,    0,    0,
			    0,    0,    0,   84,  242,    0,   83,  188,    0,    0,
			    0,   89,    0,  241,    0,    0,    0,    0,    0,   88,
			    0,    0,    0,  240,  239,  238,  237,  191,    0,  244, yyDummy>>,
			1, 1000, 0)
		end

	yytable_template_2 (an_array: ARRAY [INTEGER]) is
			-- Fill chunk #2 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,  243,   87,   86,    0,   85,    0,
			    0,    0,    0,    0,    0,   84,  242,    0,   83,  188,
			    0,    0,    0,    0,    0,  241,    0,  236,  235,    4,
			   82,  181,  180,    0,    0,  240,  239,  238,  237,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  234,
			    0,    0,    0,    0,    0,  523,    0,    0,  232,  231,
			  230,    0,    0,    0,    0,    0,    0,    0,    0,  236,
			  235,    4,   82,  181,  180,    0,    0,    0,    0,   89,
			    0,    0,    0,    0,    0,    0,    0,   88,    0,    0,
			    0,  234,    0,    0,    0,  191,    0,  530,    0,  190,

			  232,  231,  230,   87,   86,    0,   85,  189,    0,    0,
			    0,    0,    0,   84,    0,    0,   83,  188,    0,    0,
			    0,    0,    0,    0,    0,    0,  560,    0,    0,    0,
			    0,    0,    0,  187,  186,  185,  184,  191,    0,  244,
			    0,    0,    0,    0,  243,  191,    0,  244,    0,    0,
			    0,  517,  243,    0,    0,    0,  242,    0,    0,  188,
			  183,    0,    0,    0,  242,  241,    0,  188,  182,    4,
			   82,  181,  180,  241,    0,  240,  239,  238,  237,    0,
			    0,    0,    0,  240,  239,  238,  237,    0,    0,  179,
			    0,    0,    0,    0,    0,  178,    0,    0,  177,  176,

			  175,    0,    0,    0,    0,    0,    0,    0,    0,  236,
			  235,    4,   82,  181,  180,    0,    0,  236,  235,    4,
			   82,  181,  180,    0,    0,    0,    0,    0,    0,    0,
			    0,  234,    0,    0,    0,    0,  191,  559,  244,  234,
			  232,  231,  230,  243,  191,  233,  244,  516,  232,  231,
			  230,  243,    0,    0,    0,  242,  264,    0,  188,    0,
			    0,    0,    0,  242,  241,    0,  188,    0,    0,    0,
			    0,    0,  241,    0,  240,  239,  238,  237,    0,    0,
			    0,    0,  240,  239,  238,  237,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,    0,  236,  235,
			    4,   82,  181,  180,    0,    0,  236,  235,    4,   82,
			  181,  180,    0,    0,  191,    0,  244,    0,    0,    0,
			  234,  243,    0,    0,    0,    0,  233,  512,  234,  232,
			  231,  230,    0,  242,  263,    0,  188,  262,  231,  230,
			    0,    0,  241,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  240,  239,  238,  237,  191,    0,  244,  542,
			    0,    0,    0,  243,  541,  540,    0,    0,    0,    0,
			    0,    0,    0,   23,    0,  242, -329,   21,  188,   20,
			    0,  539,    0,   18,  241,    0,  236,  235,    4,   82,

			  181,  180,    0,    0,  240,  239,  238,  237,    0,    0,
			    0,  538,   15,   14,    0,    0,    0,    0,  234,    0,
			    0,    0,    0,    0,  233,  504,    0,  232,  231,  230,
			    0,    0,    0,    0,    0,    0,    0,    0,  236,  235,
			    4,   82,  181,  180,    0,  191,    0,  244,    0,    0,
			    0,    0,  243,    0,    0,  537,    0,    0,    0,    0,
			  234,    7,    0,    0,  242,    0,  233,  188,    0,  232,
			  231,  230,    0,  241,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  240,  239,  238,  237,  191,    0,  244,
			  542,    0,    0,    0,  243,  541,  540,    0,    0,    0,

			    0,    0,    0,    0,   23,    0,  242, -331,   21,  188,
			   20,    0,  539,    0,   18,  241,    0,  236,  235,    4,
			   82,  181,  180,    0,    0,  240,  239,  238,  237,    0,
			    0,    0,  538,   15,   14,    0,    0,    0,    0,  234,
			    0,    0,    0,    0,    0,  443,    0,    0,  232,  231,
			  230,    0,    0,    0,    0,    0,    0,    0,  191,  236,
			  235,    4,   82,  181,  180,  243,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  537,  242,    0,    0,
			  188,  234,    7,    0,    0,    0,  241,  391,    0,    0,
			  390,  231,  230,    0,    0,    0,  240,  239,  238,  237,

			   29,    0,    0,    0,    0,   28,   27,   26,    0,   25,
			   24,    0,    0,    0,   23,   22,    0,   -9,   21,    0,
			   20,    0,   19,    0,   18,    0,    0,    0,    0,    0,
			  236,  235,    4,   82,  181,  180,   17,    0,    0,    0,
			    0,    0,   16,   15,   14,    0,    0,    0,    0,    0,
			    0,    0,  234,    0,    0,    0,    0,    0,  233,    0,
			   29,  232,  231,  230,    0,   28,   27,   26,    0,   25,
			   24,    0,    0,    0,   23,   22,    0,  -10,   21,    0,
			   20,   13,   19,   12,   18,    0,   11,   10,    9,    0,
			    8,    0,    7,    4,    0,    0,   17,    0,    0,    0,

			    0,    0,   16,   15,   14,    0,    0,    0,    0,    0,
			    0,    0,    0,   29,    0,    0,    0,    0,   28,   27,
			   26,    0,   25,   24,    0,    0,    0,   23,   22,    0,
			   -7,   21,    0,   20,    0,   19,    0,   18,    0,    0,
			    0,   13,    0,   12,    0,    0,   11,   10,    9,   17,
			    8,    0,    7,    4,    0,   16,   15,   14,    0,    0,
			    0,    0,    0,    0,    0,  542,    0,    0,    0,    0,
			  541,  540,    0,    0,    0,    0,    0,    0,    0,   23,
			    0,    0, -327,   21,    0,   20,    0,  539,    0,   18,
			    0,    0,    0,    0,   13,    0,   12,    0,    0,   11,

			   10,    9,    0,    8,    0,    7,    4,  538,   15,   14,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  537,    0,    0,    0,    0,    0,    7, yyDummy>>,
			1, 858, 1000)
		end

	yycheck_template: SPECIAL [INTEGER] is
			-- Template for `yycheck'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make (0, 1857)
			yycheck_template_1 (an_array)
			yycheck_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yycheck_template_1 (an_array: ARRAY [INTEGER]) is
			-- Fill chunk #1 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   20,   20,  241,   20,  138,  131,  176,  177,  179,    3,
			   23,  178,   18,    1,   20,  160,    1,   23,    1,    1,
			  178,  222,  520,   14,  103,    1,   47,  550,  269,  499,
			   24,    1,   86,   95,  420,  244,   90,   91,    1,   94,
			   94,  118,    1,  113,  114,  122,    0,  224,   94,  113,
			  114,  121,   72,   47,  263,    1,   26,  580,  120,   26,
			   36,  123,  232,   26,   47,  120,   26,  565,  114,  184,
			  185,  186,  187,    1,  128,    0,    0,    1,  127,   46,
			  550,   94,  124,  217,   90,   13,  124,  107,  109,   95,
			    1,    1,  262,  294,   18,  229,   12,  117,   34,  225,

			   16,   17,   94,  280,   95,    1,   97,    3,    4,   94,
			  580,  190,   28,  121,  500,  109,   12,  503,   14,   15,
			   16,   17,   18,  121,   20,   21,  260,   23,   24,  208,
			   26,   27,   28,  139,  122,  521,  119,  157,  120,  122,
			  160,  342,  343,  344,  345,  115,  166,  314,  389,  307,
			   66,   47,  393,    1,   70,  115,  327,  328,  178,   75,
			  119,  119,  329,  122,  184,  185,  186,  187,  326,  555,
			   66,  121,  349,  119,   70,  352,  122,  292,   18,   75,
			  381,  499,  391,  422,   95,   81,   20,  396,   98,  115,
			  116,  117,  102,    1,   90,  189,  107,    1,  114,   95,

			    1,  207,   95,    1,   97,    1,   36,    3,   42,  120,
			   82,  337,   84,  109,  110,    1,  455,  499,  114,  420,
			  390,  117,  118,  119,  499,  122,  122,  466,   17,   25,
			  115,  116,  550,  121,  443,  131,  107,  133,  121,   35,
			   36,    1,  137,  139,   40,   96,   97,  121,  143,  450,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  121,
			   94,    1,  580,    3,  115,  410,  107,  183,  550,  121,
			  166,  119,  292,  121,  121,  550,  499,  173,  122,  175,
			  176,  177,  178,  179,  121,   25,  120,  183,  184,  185,
			  186,  187,  107,  189,  314,   35,   36,  498,  580,  500,

			   40,  129,  503,   47,  438,  580,  385,  499,  121,  329,
			  330,  207,  332,  107,  523,   94,   95,  107,  113,  114,
			  521,  530,  122,  119,    1,  121,  222,  550,  224,  225,
			   90,   97,   96,   97,  230,   95,  232,    1,  233,    3,
			  499,   95,  237,  238,  239,  240,  241,  107,  120,  244,
			  559,  115,  318,  319,  555,  499,  107,  580,  550,  119,
			  120,   25,  606,  607,  259,  261,  262,   97,   33,  264,
			    4,   35,   36,   33,  121,  107,   40,   26,   12,  119,
			  122,  121,  143,   94,  280,   96,   97,  283,  580,  409,
			    1,  550,    3,   40,   28,   29,  292,   31,  294,  121,

			  121,  121,  298,  114,   38,  301,  550,   41,  121,  120,
			  120,  307,  121,  121,   25,   36,   26,  121,  314,  121,
			  121,  580,  318,  319,   35,   36,  121,  121,  120,   40,
			  326,  327,  328,  329,  330,  107,  580,  333,   26,  335,
			    1,  337,  121,  118,  339,  107,  342,  343,  344,  345,
			  595,  122,  121,  349,  599,  119,  352,  121,  121,  478,
			   94,   95,  121,  358,   35,  117,    3,   26,  126,    5,
			  489,  367,  489,  234,   26,   26,  371,  121,  121,  107,
			  126,  377,  118,  244,  126,  381,  122,  126,  121,    3,
			   46,  143,   35,   26,  390,  131,   26,   26,  107,   97,

			  395,  396,  263,  264,  399,  121,   97,  121,  119,  121,
			  121,   97,   97,  121,  166,  534,  121,   26,    1,   26,
			    3,   26,   97,  419,  420,  107,  178,  422,   97,   26,
			  119,   26,  184,  185,  186,  187,   26,  189,   25,  107,
			  176,  177,   25,   84,   18,  119,    1,  107,    3,    1,
			    1,   95,   35,   36,  450,   14,   84,   40,  599,  498,
			  455,  119,  107,  108,  109,  110,  111,  112,  463,  331,
			   25,  466,  136,  353,  380,  595,  121,  534,  330,  599,
			   35,   36,  166,  478,  450,   40,  222,  482,  224,  225,
			  231,  133,  244,    1,  489,  407,  232,  375,  395,  410,

			  409,   -1,  498,  157,  500,   -1,   -1,  503,   -1,   -1,
			   -1,  263,  264,   -1,   -1,  376,  511,  378,   -1,  117,
			   -1,   -1,   -1,   -1,   -1,  521,  262,   -1,   -1,   -1,
			  391,   -1,   -1,   -1,  395,  396,  119,   -1,  121,  534,
			  292,   -1,   -1,   -1,  280,   -1,   98,   99,  100,  101,
			  102,  103,  104,  105,  106,  107,   -1,   -1,  294,  555,
			   -1,  159,  314,   -1,  119,  560,  121,   -1,  166,  564,
			  107,  108,  109,  110,  111,  112,   -1,  329,  330,   -1,
			  178,  179,  443,   -1,   -1,   -1,  184,  185,  186,  187,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,   -1,

			   -1,  337,   20,   -1,   -1,   -1,  342,  343,  344,  345,
			  471,  606,  607,  349,   32,   -1,  352,  107,  108,  109,
			  110,  111,  112,   -1,   42,   -1,  107,  108,  109,  110,
			  111,  112,  113,  114,   -1,   -1,   -1,   -1,   -1,  391,
			  121,   -1,   -1,  395,  396,  381,  107,  108,  109,  110,
			  111,  112,  113,  114,  390,   -1,   -1,   -1,   -1,  520,
			   -1,   -1,  523,   -1,   -1,   -1,   -1,   -1,   -1,  530,
			   -1,   -1,   -1,   -1,   -1,   -1,   94,   95,   96,   97,
			   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
			   -1,  443,   -1,   -1,  292,   -1,  114,   -1,  559,   -1,

			   -1,   -1,  120,   -1,  565,   -1,   -1,   -1,  569,  307,
			   -1,  572,   -1,   -1,  450,   -1,  314,   -1,   -1,   -1,
			  318,  319,    1,   -1,    3,   -1,    5,   -1,  326,  327,
			  328,  329,  330,   -1,   -1,   14,   -1,   -1,   17,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   25,   26,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   34,   35,   36,   -1,   -1,
			   -1,   40,  498,   -1,  500,   -1,   -1,  503,   47,   -1,
			   -1,  523,   -1,   -1,   -1,   -1,   -1,   -1,  530,   -1,
			   -1,   -1,   -1,   -1,   -1,  521,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  559,   -1,   -1,
			  408,   -1,   -1,   -1,   -1,   -1,   95,   -1,   97,  555,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  107,  108,
			  109,  110,  111,  112,  113,  114,  115,  116,  117,    4,
			  119,   -1,  121,  122,   -1,   -1,   -1,   12,  127,   -1,
			   -1,   -1,   -1,   -1,   -1,   20,   -1,   22,   -1,   -1,
			   -1,   -1,   27,   28,   29,   -1,   31,   -1,   -1,   -1,
			   -1,   -1,   -1,   38,   39,   -1,   41,   42,   -1,   -1,
			   -1,    4,   -1,   48,   -1,   -1,   -1,   -1,   -1,   12,
			   -1,   -1,   -1,   58,   59,   60,   61,   20,   -1,   22, yyDummy>>,
			1, 1000, 0)
		end

	yycheck_template_2 (an_array: ARRAY [INTEGER]) is
			-- Fill chunk #2 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   27,   28,   29,   -1,   31,   -1,
			   -1,   -1,   -1,   -1,   -1,   38,   39,   -1,   41,   42,
			   -1,   -1,   -1,   -1,   -1,   48,   -1,   92,   93,   94,
			   95,   96,   97,   -1,   -1,   58,   59,   60,   61,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  114,
			   -1,   -1,   -1,   -1,   -1,  120,   -1,   -1,  123,  124,
			  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,
			   93,   94,   95,   96,   97,   -1,   -1,   -1,   -1,    4,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   12,   -1,   -1,
			   -1,  114,   -1,   -1,   -1,   20,   -1,  120,   -1,   24,

			  123,  124,  125,   28,   29,   -1,   31,   32,   -1,   -1,
			   -1,   -1,   -1,   38,   -1,   -1,   41,   42,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,    9,   -1,   -1,   -1,
			   -1,   -1,   -1,   58,   59,   60,   61,   20,   -1,   22,
			   -1,   -1,   -1,   -1,   27,   20,   -1,   22,   -1,   -1,
			   -1,   26,   27,   -1,   -1,   -1,   39,   -1,   -1,   42,
			   85,   -1,   -1,   -1,   39,   48,   -1,   42,   93,   94,
			   95,   96,   97,   48,   -1,   58,   59,   60,   61,   -1,
			   -1,   -1,   -1,   58,   59,   60,   61,   -1,   -1,  114,
			   -1,   -1,   -1,   -1,   -1,  120,   -1,   -1,  123,  124,

			  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,
			   93,   94,   95,   96,   97,   -1,   -1,   92,   93,   94,
			   95,   96,   97,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  114,   -1,   -1,   -1,   -1,   20,  120,   22,  114,
			  123,  124,  125,   27,   20,  120,   22,  122,  123,  124,
			  125,   27,   -1,   -1,   -1,   39,   32,   -1,   42,   -1,
			   -1,   -1,   -1,   39,   48,   -1,   42,   -1,   -1,   -1,
			   -1,   -1,   48,   -1,   58,   59,   60,   61,   -1,   -1,
			   -1,   -1,   58,   59,   60,   61,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,   93,
			   94,   95,   96,   97,   -1,   -1,   92,   93,   94,   95,
			   96,   97,   -1,   -1,   20,   -1,   22,   -1,   -1,   -1,
			  114,   27,   -1,   -1,   -1,   -1,  120,  121,  114,  123,
			  124,  125,   -1,   39,  120,   -1,   42,  123,  124,  125,
			   -1,   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   58,   59,   60,   61,   20,   -1,   22,    1,
			   -1,   -1,   -1,   27,    6,    7,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   15,   -1,   39,   18,   19,   42,   21,
			   -1,   23,   -1,   25,   48,   -1,   92,   93,   94,   95,

			   96,   97,   -1,   -1,   58,   59,   60,   61,   -1,   -1,
			   -1,   43,   44,   45,   -1,   -1,   -1,   -1,  114,   -1,
			   -1,   -1,   -1,   -1,  120,  121,   -1,  123,  124,  125,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   92,   93,
			   94,   95,   96,   97,   -1,   20,   -1,   22,   -1,   -1,
			   -1,   -1,   27,   -1,   -1,   87,   -1,   -1,   -1,   -1,
			  114,   93,   -1,   -1,   39,   -1,  120,   42,   -1,  123,
			  124,  125,   -1,   48,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   58,   59,   60,   61,   20,   -1,   22,
			    1,   -1,   -1,   -1,   27,    6,    7,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,   15,   -1,   39,   18,   19,   42,
			   21,   -1,   23,   -1,   25,   48,   -1,   92,   93,   94,
			   95,   96,   97,   -1,   -1,   58,   59,   60,   61,   -1,
			   -1,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,  114,
			   -1,   -1,   -1,   -1,   -1,  120,   -1,   -1,  123,  124,
			  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   20,   92,
			   93,   94,   95,   96,   97,   27,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   87,   39,   -1,   -1,
			   42,  114,   93,   -1,   -1,   -1,   48,  120,   -1,   -1,
			  123,  124,  125,   -1,   -1,   -1,   58,   59,   60,   61,

			    1,   -1,   -1,   -1,   -1,    6,    7,    8,   -1,   10,
			   11,   -1,   -1,   -1,   15,   16,   -1,   18,   19,   -1,
			   21,   -1,   23,   -1,   25,   -1,   -1,   -1,   -1,   -1,
			   92,   93,   94,   95,   96,   97,   37,   -1,   -1,   -1,
			   -1,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  114,   -1,   -1,   -1,   -1,   -1,  120,   -1,
			    1,  123,  124,  125,   -1,    6,    7,    8,   -1,   10,
			   11,   -1,   -1,   -1,   15,   16,   -1,   18,   19,   -1,
			   21,   82,   23,   84,   25,   -1,   87,   88,   89,   -1,
			   91,   -1,   93,   94,   -1,   -1,   37,   -1,   -1,   -1,

			   -1,   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,    1,   -1,   -1,   -1,   -1,    6,    7,
			    8,   -1,   10,   11,   -1,   -1,   -1,   15,   16,   -1,
			   18,   19,   -1,   21,   -1,   23,   -1,   25,   -1,   -1,
			   -1,   82,   -1,   84,   -1,   -1,   87,   88,   89,   37,
			   91,   -1,   93,   94,   -1,   43,   44,   45,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,    1,   -1,   -1,   -1,   -1,
			    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   15,
			   -1,   -1,   18,   19,   -1,   21,   -1,   23,   -1,   25,
			   -1,   -1,   -1,   -1,   82,   -1,   84,   -1,   -1,   87,

			   88,   89,   -1,   91,   -1,   93,   94,   43,   44,   45,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   87,   -1,   -1,   -1,   -1,   -1,   93, yyDummy>>,
			1, 858, 1000)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [ANY]
			-- Stack for semantic values of type ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [ANY]
			-- Routines that ought to be in SPECIAL [ANY]

	yyvs2: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs3: SPECIAL [INTEGER]
			-- Stack for semantic values of type INTEGER

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [INTEGER]
			-- Routines that ought to be in SPECIAL [INTEGER]

	yyvs4: SPECIAL [XPLAIN_BASE]
			-- Stack for semantic values of type XPLAIN_BASE

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [XPLAIN_BASE]
			-- Routines that ought to be in SPECIAL [XPLAIN_BASE]

	yyvs5: SPECIAL [XPLAIN_DOMAIN_RESTRICTION]
			-- Stack for semantic values of type XPLAIN_DOMAIN_RESTRICTION

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [XPLAIN_DOMAIN_RESTRICTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_DOMAIN_RESTRICTION]

	yyvs6: SPECIAL [XPLAIN_A_NODE]
			-- Stack for semantic values of type XPLAIN_A_NODE

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [XPLAIN_A_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_A_NODE]

	yyvs7: SPECIAL [XPLAIN_I_NODE]
			-- Stack for semantic values of type XPLAIN_I_NODE

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [XPLAIN_I_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_I_NODE]

	yyvs8: SPECIAL [XPLAIN_LOGICAL_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_LOGICAL_EXPRESSION

	yyvsc8: INTEGER
			-- Capacity of semantic value stack `yyvs8'

	yyvsp8: INTEGER
			-- Top of semantic value stack `yyvs8'

	yyspecial_routines8: KL_SPECIAL_ROUTINES [XPLAIN_LOGICAL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_LOGICAL_EXPRESSION]

	yyvs9: SPECIAL [XPLAIN_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_EXPRESSION

	yyvsc9: INTEGER
			-- Capacity of semantic value stack `yyvs9'

	yyvsp9: INTEGER
			-- Top of semantic value stack `yyvs9'

	yyspecial_routines9: KL_SPECIAL_ROUTINES [XPLAIN_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXPRESSION]

	yyvs10: SPECIAL [XPLAIN_LOGICAL_VALUE_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_LOGICAL_VALUE_EXPRESSION

	yyvsc10: INTEGER
			-- Capacity of semantic value stack `yyvs10'

	yyvsp10: INTEGER
			-- Top of semantic value stack `yyvs10'

	yyspecial_routines10: KL_SPECIAL_ROUTINES [XPLAIN_LOGICAL_VALUE_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_LOGICAL_VALUE_EXPRESSION]

	yyvs11: SPECIAL [XPLAIN_SYSTEM_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_SYSTEM_EXPRESSION

	yyvsc11: INTEGER
			-- Capacity of semantic value stack `yyvs11'

	yyvsp11: INTEGER
			-- Top of semantic value stack `yyvs11'

	yyspecial_routines11: KL_SPECIAL_ROUTINES [XPLAIN_SYSTEM_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_SYSTEM_EXPRESSION]

	yyvs12: SPECIAL [XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE_NAME_NODE

	yyvsc12: INTEGER
			-- Capacity of semantic value stack `yyvs12'

	yyvsp12: INTEGER
			-- Top of semantic value stack `yyvs12'

	yyspecial_routines12: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE_NAME_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE_NAME_NODE]

	yyvs13: SPECIAL [XPLAIN_ATTRIBUTE_NAME]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE_NAME

	yyvsc13: INTEGER
			-- Capacity of semantic value stack `yyvs13'

	yyvsp13: INTEGER
			-- Top of semantic value stack `yyvs13'

	yyspecial_routines13: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE_NAME]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE_NAME]

	yyvs14: SPECIAL [XPLAIN_TYPE]
			-- Stack for semantic values of type XPLAIN_TYPE

	yyvsc14: INTEGER
			-- Capacity of semantic value stack `yyvs14'

	yyvsp14: INTEGER
			-- Top of semantic value stack `yyvs14'

	yyspecial_routines14: KL_SPECIAL_ROUTINES [XPLAIN_TYPE]
			-- Routines that ought to be in SPECIAL [XPLAIN_TYPE]

	yyvs15: SPECIAL [XPLAIN_REPRESENTATION]
			-- Stack for semantic values of type XPLAIN_REPRESENTATION

	yyvsc15: INTEGER
			-- Capacity of semantic value stack `yyvs15'

	yyvsp15: INTEGER
			-- Top of semantic value stack `yyvs15'

	yyspecial_routines15: KL_SPECIAL_ROUTINES [XPLAIN_REPRESENTATION]
			-- Routines that ought to be in SPECIAL [XPLAIN_REPRESENTATION]

	yyvs16: SPECIAL [XPLAIN_PK_REPRESENTATION]
			-- Stack for semantic values of type XPLAIN_PK_REPRESENTATION

	yyvsc16: INTEGER
			-- Capacity of semantic value stack `yyvs16'

	yyvsp16: INTEGER
			-- Top of semantic value stack `yyvs16'

	yyspecial_routines16: KL_SPECIAL_ROUTINES [XPLAIN_PK_REPRESENTATION]
			-- Routines that ought to be in SPECIAL [XPLAIN_PK_REPRESENTATION]

	yyvs17: SPECIAL [XPLAIN_ATTRIBUTE_NODE]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE_NODE

	yyvsc17: INTEGER
			-- Capacity of semantic value stack `yyvs17'

	yyvsp17: INTEGER
			-- Top of semantic value stack `yyvs17'

	yyspecial_routines17: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE_NODE]

	yyvs18: SPECIAL [XPLAIN_ATTRIBUTE]
			-- Stack for semantic values of type XPLAIN_ATTRIBUTE

	yyvsc18: INTEGER
			-- Capacity of semantic value stack `yyvs18'

	yyvsp18: INTEGER
			-- Top of semantic value stack `yyvs18'

	yyspecial_routines18: KL_SPECIAL_ROUTINES [XPLAIN_ATTRIBUTE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ATTRIBUTE]

	yyvs19: SPECIAL [XPLAIN_ASSERTION]
			-- Stack for semantic values of type XPLAIN_ASSERTION

	yyvsc19: INTEGER
			-- Capacity of semantic value stack `yyvs19'

	yyvsp19: INTEGER
			-- Top of semantic value stack `yyvs19'

	yyspecial_routines19: KL_SPECIAL_ROUTINES [XPLAIN_ASSERTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_ASSERTION]

	yyvs20: SPECIAL [XPLAIN_ASSIGNMENT_NODE]
			-- Stack for semantic values of type XPLAIN_ASSIGNMENT_NODE

	yyvsc20: INTEGER
			-- Capacity of semantic value stack `yyvs20'

	yyvsp20: INTEGER
			-- Top of semantic value stack `yyvs20'

	yyspecial_routines20: KL_SPECIAL_ROUTINES [XPLAIN_ASSIGNMENT_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_ASSIGNMENT_NODE]

	yyvs21: SPECIAL [XPLAIN_ASSIGNMENT]
			-- Stack for semantic values of type XPLAIN_ASSIGNMENT

	yyvsc21: INTEGER
			-- Capacity of semantic value stack `yyvs21'

	yyvsp21: INTEGER
			-- Top of semantic value stack `yyvs21'

	yyspecial_routines21: KL_SPECIAL_ROUTINES [XPLAIN_ASSIGNMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_ASSIGNMENT]

	yyvs22: SPECIAL [XPLAIN_SUBJECT]
			-- Stack for semantic values of type XPLAIN_SUBJECT

	yyvsc22: INTEGER
			-- Capacity of semantic value stack `yyvs22'

	yyvsp22: INTEGER
			-- Top of semantic value stack `yyvs22'

	yyspecial_routines22: KL_SPECIAL_ROUTINES [XPLAIN_SUBJECT]
			-- Routines that ought to be in SPECIAL [XPLAIN_SUBJECT]

	yyvs23: SPECIAL [XPLAIN_SELECTION_FUNCTION]
			-- Stack for semantic values of type XPLAIN_SELECTION_FUNCTION

	yyvsc23: INTEGER
			-- Capacity of semantic value stack `yyvs23'

	yyvsp23: INTEGER
			-- Top of semantic value stack `yyvs23'

	yyspecial_routines23: KL_SPECIAL_ROUTINES [XPLAIN_SELECTION_FUNCTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_SELECTION_FUNCTION]

	yyvs24: SPECIAL [XPLAIN_EXTENSION]
			-- Stack for semantic values of type XPLAIN_EXTENSION

	yyvsc24: INTEGER
			-- Capacity of semantic value stack `yyvs24'

	yyvsp24: INTEGER
			-- Top of semantic value stack `yyvs24'

	yyspecial_routines24: KL_SPECIAL_ROUTINES [XPLAIN_EXTENSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXTENSION]

	yyvs25: SPECIAL [XPLAIN_EXTEND_ATTRIBUTE]
			-- Stack for semantic values of type XPLAIN_EXTEND_ATTRIBUTE

	yyvsc25: INTEGER
			-- Capacity of semantic value stack `yyvs25'

	yyvsp25: INTEGER
			-- Top of semantic value stack `yyvs25'

	yyspecial_routines25: KL_SPECIAL_ROUTINES [XPLAIN_EXTEND_ATTRIBUTE]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXTEND_ATTRIBUTE]

	yyvs26: SPECIAL [XPLAIN_EXTENSION_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_EXTENSION_EXPRESSION

	yyvsc26: INTEGER
			-- Capacity of semantic value stack `yyvs26'

	yyvsp26: INTEGER
			-- Top of semantic value stack `yyvs26'

	yyspecial_routines26: KL_SPECIAL_ROUTINES [XPLAIN_EXTENSION_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXTENSION_EXPRESSION]

	yyvs27: SPECIAL [XPLAIN_SELECTION]
			-- Stack for semantic values of type XPLAIN_SELECTION

	yyvsc27: INTEGER
			-- Capacity of semantic value stack `yyvs27'

	yyvsp27: INTEGER
			-- Top of semantic value stack `yyvs27'

	yyspecial_routines27: KL_SPECIAL_ROUTINES [XPLAIN_SELECTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_SELECTION]

	yyvs28: SPECIAL [XPLAIN_SELECTION_LIST]
			-- Stack for semantic values of type XPLAIN_SELECTION_LIST

	yyvsc28: INTEGER
			-- Capacity of semantic value stack `yyvs28'

	yyvsp28: INTEGER
			-- Top of semantic value stack `yyvs28'

	yyspecial_routines28: KL_SPECIAL_ROUTINES [XPLAIN_SELECTION_LIST]
			-- Routines that ought to be in SPECIAL [XPLAIN_SELECTION_LIST]

	yyvs29: SPECIAL [XPLAIN_SORT_NODE]
			-- Stack for semantic values of type XPLAIN_SORT_NODE

	yyvsc29: INTEGER
			-- Capacity of semantic value stack `yyvs29'

	yyvsp29: INTEGER
			-- Top of semantic value stack `yyvs29'

	yyspecial_routines29: KL_SPECIAL_ROUTINES [XPLAIN_SORT_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_SORT_NODE]

	yyvs30: SPECIAL [XPLAIN_FUNCTION]
			-- Stack for semantic values of type XPLAIN_FUNCTION

	yyvsc30: INTEGER
			-- Capacity of semantic value stack `yyvs30'

	yyvsp30: INTEGER
			-- Top of semantic value stack `yyvs30'

	yyspecial_routines30: KL_SPECIAL_ROUTINES [XPLAIN_FUNCTION]
			-- Routines that ought to be in SPECIAL [XPLAIN_FUNCTION]

	yyvs31: SPECIAL [XPLAIN_EXPRESSION_NODE]
			-- Stack for semantic values of type XPLAIN_EXPRESSION_NODE

	yyvsc31: INTEGER
			-- Capacity of semantic value stack `yyvs31'

	yyvsp31: INTEGER
			-- Top of semantic value stack `yyvs31'

	yyspecial_routines31: KL_SPECIAL_ROUTINES [XPLAIN_EXPRESSION_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXPRESSION_NODE]

	yyvs32: SPECIAL [XPLAIN_STATEMENT_NODE]
			-- Stack for semantic values of type XPLAIN_STATEMENT_NODE

	yyvsc32: INTEGER
			-- Capacity of semantic value stack `yyvs32'

	yyvsp32: INTEGER
			-- Top of semantic value stack `yyvs32'

	yyspecial_routines32: KL_SPECIAL_ROUTINES [XPLAIN_STATEMENT_NODE]
			-- Routines that ought to be in SPECIAL [XPLAIN_STATEMENT_NODE]

	yyvs33: SPECIAL [XPLAIN_STATEMENT]
			-- Stack for semantic values of type XPLAIN_STATEMENT

	yyvsc33: INTEGER
			-- Capacity of semantic value stack `yyvs33'

	yyvsp33: INTEGER
			-- Top of semantic value stack `yyvs33'

	yyspecial_routines33: KL_SPECIAL_ROUTINES [XPLAIN_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_STATEMENT]

	yyvs34: SPECIAL [XPLAIN_CONSTANT_STATEMENT]
			-- Stack for semantic values of type XPLAIN_CONSTANT_STATEMENT

	yyvsc34: INTEGER
			-- Capacity of semantic value stack `yyvs34'

	yyvsp34: INTEGER
			-- Top of semantic value stack `yyvs34'

	yyspecial_routines34: KL_SPECIAL_ROUTINES [XPLAIN_CONSTANT_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_CONSTANT_STATEMENT]

	yyvs35: SPECIAL [XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]
			-- Stack for semantic values of type XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT

	yyvsc35: INTEGER
			-- Capacity of semantic value stack `yyvs35'

	yyvsp35: INTEGER
			-- Top of semantic value stack `yyvs35'

	yyspecial_routines35: KL_SPECIAL_ROUTINES [XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_CONSTANT_ASSIGNMENT_STATEMENT]

	yyvs36: SPECIAL [XPLAIN_CASCADE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_CASCADE_STATEMENT

	yyvsc36: INTEGER
			-- Capacity of semantic value stack `yyvs36'

	yyvsp36: INTEGER
			-- Top of semantic value stack `yyvs36'

	yyspecial_routines36: KL_SPECIAL_ROUTINES [XPLAIN_CASCADE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_CASCADE_STATEMENT]

	yyvs37: SPECIAL [XPLAIN_CASCADE_FUNCTION_EXPRESSION]
			-- Stack for semantic values of type XPLAIN_CASCADE_FUNCTION_EXPRESSION

	yyvsc37: INTEGER
			-- Capacity of semantic value stack `yyvs37'

	yyvsp37: INTEGER
			-- Top of semantic value stack `yyvs37'

	yyspecial_routines37: KL_SPECIAL_ROUTINES [XPLAIN_CASCADE_FUNCTION_EXPRESSION]
			-- Routines that ought to be in SPECIAL [XPLAIN_CASCADE_FUNCTION_EXPRESSION]

	yyvs38: SPECIAL [XPLAIN_DELETE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_DELETE_STATEMENT

	yyvsc38: INTEGER
			-- Capacity of semantic value stack `yyvs38'

	yyvsp38: INTEGER
			-- Top of semantic value stack `yyvs38'

	yyspecial_routines38: KL_SPECIAL_ROUTINES [XPLAIN_DELETE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_DELETE_STATEMENT]

	yyvs39: SPECIAL [XPLAIN_EXTEND_STATEMENT]
			-- Stack for semantic values of type XPLAIN_EXTEND_STATEMENT

	yyvsc39: INTEGER
			-- Capacity of semantic value stack `yyvs39'

	yyvsp39: INTEGER
			-- Top of semantic value stack `yyvs39'

	yyspecial_routines39: KL_SPECIAL_ROUTINES [XPLAIN_EXTEND_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_EXTEND_STATEMENT]

	yyvs40: SPECIAL [XPLAIN_GET_STATEMENT]
			-- Stack for semantic values of type XPLAIN_GET_STATEMENT

	yyvsc40: INTEGER
			-- Capacity of semantic value stack `yyvs40'

	yyvsp40: INTEGER
			-- Top of semantic value stack `yyvs40'

	yyspecial_routines40: KL_SPECIAL_ROUTINES [XPLAIN_GET_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_GET_STATEMENT]

	yyvs41: SPECIAL [XPLAIN_PROCEDURE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_PROCEDURE_STATEMENT

	yyvsc41: INTEGER
			-- Capacity of semantic value stack `yyvs41'

	yyvsp41: INTEGER
			-- Top of semantic value stack `yyvs41'

	yyspecial_routines41: KL_SPECIAL_ROUTINES [XPLAIN_PROCEDURE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_PROCEDURE_STATEMENT]

	yyvs42: SPECIAL [XPLAIN_SQL_STATEMENT]
			-- Stack for semantic values of type XPLAIN_SQL_STATEMENT

	yyvsc42: INTEGER
			-- Capacity of semantic value stack `yyvs42'

	yyvsp42: INTEGER
			-- Top of semantic value stack `yyvs42'

	yyspecial_routines42: KL_SPECIAL_ROUTINES [XPLAIN_SQL_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_SQL_STATEMENT]

	yyvs43: SPECIAL [XPLAIN_TYPE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_TYPE_STATEMENT

	yyvsc43: INTEGER
			-- Capacity of semantic value stack `yyvs43'

	yyvsp43: INTEGER
			-- Top of semantic value stack `yyvs43'

	yyspecial_routines43: KL_SPECIAL_ROUTINES [XPLAIN_TYPE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_TYPE_STATEMENT]

	yyvs44: SPECIAL [XPLAIN_UPDATE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_UPDATE_STATEMENT

	yyvsc44: INTEGER
			-- Capacity of semantic value stack `yyvs44'

	yyvsp44: INTEGER
			-- Top of semantic value stack `yyvs44'

	yyspecial_routines44: KL_SPECIAL_ROUTINES [XPLAIN_UPDATE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_UPDATE_STATEMENT]

	yyvs45: SPECIAL [XPLAIN_VALUE_STATEMENT]
			-- Stack for semantic values of type XPLAIN_VALUE_STATEMENT

	yyvsc45: INTEGER
			-- Capacity of semantic value stack `yyvs45'

	yyvsp45: INTEGER
			-- Top of semantic value stack `yyvs45'

	yyspecial_routines45: KL_SPECIAL_ROUTINES [XPLAIN_VALUE_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_VALUE_STATEMENT]

	yyvs46: SPECIAL [XPLAIN_VALUE_SELECTION_STATEMENT]
			-- Stack for semantic values of type XPLAIN_VALUE_SELECTION_STATEMENT

	yyvsc46: INTEGER
			-- Capacity of semantic value stack `yyvs46'

	yyvsp46: INTEGER
			-- Top of semantic value stack `yyvs46'

	yyspecial_routines46: KL_SPECIAL_ROUTINES [XPLAIN_VALUE_SELECTION_STATEMENT]
			-- Routines that ought to be in SPECIAL [XPLAIN_VALUE_SELECTION_STATEMENT]

feature {NONE} -- Constants

	yyFinal: INTEGER is 612
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 130
			-- Number of tokens

	yyLast: INTEGER is 1857
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 365
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 267
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



feature -- Initialization

	make_with_file (a_file: KI_CHARACTER_INPUT_STREAM; a_sqlgenerator: SQL_GENERATOR) is
		require
			sqlgenerator_not_void: a_sqlgenerator /= Void
		do
			make_scanner_with_file (a_file)
			make (a_sqlgenerator)
		end

	make_with_stdin (a_sqlgenerator: SQL_GENERATOR) is
		require
			sqlgenerator_not_void: a_sqlgenerator /= Void
		do
			make_scanner_with_stdin
			make (a_sqlgenerator)
		end


feature {NONE} -- private creation

	make (a_sqlgenerator: SQL_GENERATOR) is
		do
			make_parser_skeleton
			create statements.make
			set_sqlgenerator (a_sqlgenerator)
		end


feature {NONE} -- dummy variables to store created objects in

	dummya: XPLAIN_A_REFERENCES
	dummyi: XPLAIN_I_REFERENCES
	dummye: XPLAIN_EXPRESSION
	dummyl: XPLAIN_LOGICAL_EXPRESSION
	dummybool: XPLAIN_LOGICAL_VALUE_EXPRESSION
	dummyrestriction: XPLAIN_DOMAIN_RESTRICTION

	last_width: INTEGER
			-- saves latest domain width, for example I2 will save 2 here

feature {NONE} -- local variables, do not survive outside a code block!

	myobject: XPLAIN_ABSTRACT_OBJECT
	myabstracttype: XPLAIN_ABSTRACT_TYPE
	mytype: XPLAIN_TYPE
	myvariable: XPLAIN_VARIABLE
	myvalue: XPLAIN_VALUE
	myattribute: XPLAIN_ATTRIBUTE
	myindex: XPLAIN_INDEX
	myprocedure: XPLAIN_PROCEDURE
	current_type_name: STRING
	auto_identifier: BOOLEAN
	my_selection_function: XPLAIN_SELECTION_FUNCTION
	my_str: XPLAIN_STRING_EXPRESSION

	is_init_default: BOOLEAN
			-- Determine if init or init default statement has to be created.


feature {NONE} -- these vars survive a little bit longer

	subject_type: XPLAIN_TYPE  -- used to check if valid attribute
	extend_type: XPLAIN_TYPE   -- used in extend statement
	my_parameters: XPLAIN_ATTRIBUTE_NAME_NODE
			-- List of declared parameters for a procedure

feature -- Xplain

	statements: XPLAIN_STATEMENTS
			-- All executable statements.


feature {NONE} -- Expression generation

	new_logical_infix_expression (a_left: XPLAIN_EXPRESSION; an_operator: STRING; a_right: XPLAIN_EXPRESSION): XPLAIN_INFIX_EXPRESSION is
			-- Create a new infix expression. It's main purpose is to
			-- determine when to use the like operator instead of the '='
			-- operator.
		require
			valid_left: a_left /= Void
			valid_right: a_right /= Void
			operator_not_empty: an_operator /= Void and then not an_operator.is_empty
		local
			equal_operator,
			not_equal_operator: BOOLEAN
		do
			if an_operator.is_equal (once_equal) then
				equal_operator := True
			elseif an_operator.is_equal (once_not_equal) then
				not_equal_operator := True
			end
			if equal_operator or else not_equal_operator then
				if a_left.has_wild_card_characters or a_right.has_wild_card_characters then
					if equal_operator then
						create {XPLAIN_LIKE_EXPRESSION} Result.make (a_left, a_right)
					else
						create {XPLAIN_NOT_LIKE_EXPRESSION} Result.make (a_left, a_right)
					end
				end
			end

			-- Fallback to standard infix expression.
			if Result = Void then
				create {XPLAIN_LOGICAL_INFIX_EXPRESSION} Result.make (a_left, an_operator, a_right)
			end
		ensure
			new_infix_expression_not_void: Result /= Void
		end


feature -- Middleware

	mwgenerator: MIDDLEWARE_GENERATOR

	set_mwgenerator (mwg: MIDDLEWARE_GENERATOR) is
		do
			mwgenerator := mwg
		end


feature {NONE} -- Error handling

	error_unknown_attribute (type: STRING; attribute: XPLAIN_ATTRIBUTE_NAME) is
			-- abort with unknown attribute error
		local
			s: STRING
		do
			s := "Type `" + type + "' does not have the attribute `"
			if attribute.role /= Void then
				s := s + attribute.role + "_"
			end
			s := s + attribute.name + "'."
			report_error (s)
			abort
		end

feature {NONE} -- pending statements

	pending_type: XPLAIN_TYPE
			-- set for type not yet written

	write_pending_init is
		require
			pending_type_written: pending_init = Void or else pending_type = Void
		do
			if pending_init /= Void then
				if not use_mode then
					sqlgenerator.write_init (pending_init)
				end
				pending_init := Void
			end
		ensure
			pending_init_void: pending_init = Void
		end

	write_pending_statement is
			-- Call this before outputting anything!
		do
			write_pending_type
			write_pending_init
		ensure then
			pending_init_void: pending_init = Void
		end

	write_pending_type is
		do
			if pending_type /= Void then
				if not use_mode then
					sqlgenerator.write_type (pending_type)
					if mwgenerator /= Void then
						mwgenerator.dump_type (pending_type, sqlgenerator)
					end
				end
				pending_type := Void
			end
		ensure
			pending_type_void: pending_type = Void
		end


feature {NONE} -- Checks for validness of parsed code

	get_known_base_or_type (name: STRING): XPLAIN_ABSTRACT_TYPE is
			-- Test if known type, but be aware of self-reference.
		do
			Result := universe.find_base_or_type (name)
			if Result = Void and then
				not equal(current_type_name, name) then
				report_error ("Unknown base or type: " + name)
				abort
			end
		end

	get_known_object (name: STRING): XPLAIN_ABSTRACT_OBJECT is
			-- Return object, must exist.
		do
			Result := universe.find_object (name)
			if Result = Void then
				report_error ("Not a defined object: " + name)
				abort
			end
		end

	get_known_type (name: STRING): XPLAIN_TYPE is
			-- Return the type for `name' or die.
		local
			b: XPLAIN_BASE
		do
			Result := universe.find_type (name)
			if Result = Void then
				b := universe.find_base (name)
				if b = Void then
					report_error ("Type unknown: " + name)
				else
					report_error (format ("`$s' is a base, but a type is expected here.", <<name>>))
				end
				abort
			end
		end

	get_known_value (name: STRING): XPLAIN_VALUE is
		do
			Result := universe.find_value (name)
			if Result = Void then
				report_error ("Value unknown: " + name)
				abort
			end
		end

	last_object_in_tree: XPLAIN_ABSTRACT_OBJECT
			-- Set by `get_object_if_valid_tree' to last object in list.

	get_object_if_valid_tree (first: XPLAIN_ATTRIBUTE_NAME_NODE): XPLAIN_ABSTRACT_OBJECT is
			-- The object for the first name of this tree, if this
			-- is a valid tree;
			-- Also augment tree with type information.
		require
			first_not_void: first /= Void
			subject_type_set: subject_type /= Void
		local
			attribute: XPLAIN_ATTRIBUTE
			value: XPLAIN_VALUE
			variable: XPLAIN_VARIABLE
			node: XPLAIN_ATTRIBUTE_NAME_NODE
			preceding_type: XPLAIN_TYPE
			atype: XPLAIN_ABSTRACT_TYPE
			valid_attribute: BOOLEAN
			msg: STRING
		do
			last_object_in_tree := Void
			if first.next /= Void then
				-- Something like a its b its c, should all be attributes.
				from
					node := first
					preceding_type := subject_type
					valid_attribute := True
				until
					node = Void or
					not valid_attribute
				loop
					attribute := preceding_type.find_attribute (node.item)
					valid_attribute := attribute /= Void
					if valid_attribute then
						node.item.set_attribute (attribute)
						atype := attribute.abstracttype
						--node.item.set_object (atype)
						if node.next /= Void then
							preceding_type ?= atype
							if preceding_type = Void then
								-- we've a base here (but missed extension
								-- because it's a type, need to fix this)
								valid_attribute := False
								report_error ("A base cannot have attributes. Base name is: " + node.item.name)
								abort
							end
						end
					else -- type doesn't have this attribute
						valid_attribute := False
						report_error ("Type " + preceding_type.name + " doesn't have the attribute: " + node.item.name)
						abort
					end
					node := node.next
				end
				if valid_attribute then
					last_object_in_tree := atype
					Result := subject_type.find_attribute (first.item).abstracttype
				end
			else
				-- Can be value/variable or attribute.
				-- Check attribute first.
				attribute := subject_type.find_attribute (first.item)
				if attribute = Void then
					Result := universe.find_object (first.item.name)
					if Result = Void then
						report_error ( format("Object `$s' is not an attribute of type `$s', nor a value or constant.", <<first.item.name, subject_type.name>>))
						abort
					else
						-- check if value/variable
						value ?= Result
						variable ?= Result
						if value = Void and then variable = Void then
							create msg.make (128)
							msg.append_string ("base/type '")
							if first.item.role /= Void then
								msg.append_string (first.item.role)
								msg.append_string ("_")
							end
							msg.append_string (first.item.name)
							msg.append_string ("' is not an attribute of '")
							msg.append_string (subject_type.name)
							msg.append_string ("'%N")
							report_error (msg)
							abort
							Result := Void
						else
							first.item.set_object (Result)
						end
					end
				else
					first.item.set_attribute (attribute)
					Result := attribute.abstracttype
				end
				if Result /= Void then
					last_object_in_tree := Result
				end
			end
		ensure
			if_not_valid_tree: True -- Warnings are given
			if_valid_tree: True
			-- Result /= Void and object is the object for the first name
			-- in the tree
			last_object_set: Result /= Void implies last_object_in_tree /= Void
		end

	is_parameter_declared (a_name: XPLAIN_ATTRIBUTE_NAME): BOOLEAN is
			-- Has `a_name' been declared in the parameter list for the
			-- current procedure?
		require
			name_not_empty: a_name /= Void
		do
			Result := my_parameters /= Void and then my_parameters.has (a_name)
			if not Result then
				report_error ("Parameter `" + a_name.full_name + "' has not been declared.")
				abort
			end
		end


feature {NONE} -- Checks

	warn_attributes_with_inits (an_assignment_list: XPLAIN_ASSIGNMENT_NODE) is
			-- Check if user has specified an attribute for which an init
			-- expression exists. Assignment will be (should be...)
			-- ignored in that case.
		require
			an_assignment_list_not_void: an_assignment_list /= Void
		local
			node: XPLAIN_ASSIGNMENT_NODE
		do
			from
				node := an_assignment_list
			until
				node = Void
			loop
				if
					node.item.attribute_name.attribute.init /= Void and then
					not node.item.attribute_name.attribute.is_init_default
				then
					report_error (format ("Attribute $s has an init expression. Assignment specified in insert will be ignored.%N", <<node.item.attribute_name.full_name>>))
				end
				node := node.next
			end
		end


feature {NONE} -- Once strings

	once_equal: STRING is "="
	once_not_equal: STRING is "<>"


invariant

	have_sqlgenerator: sqlgenerator /= Void
	have_statements: statements /= Void

end
